//package Metrics;
//
//import java.io.BufferedWriter;
//import java.io.FileWriter;
//import java.util.ArrayList;
//import java.util.HashMap;
//
//import workerCode.Coord;
//import workerCode.Robot;
//import workerCode.Queen;
//import workerCode.Worker;
//import simulation.Scout;
//
//public class Metrics_Old {
//	private HashMap<Robot, MetricRobotInformation> robotMetricHash = new HashMap<Robot, MetricRobotInformation>();
//	private int numQueens=0;
//	private int numWorkers=0;
//	private int numScouts=0;
//	private ArrayList<Robot> completeRobotList = new ArrayList<Robot>();
//	
//	/**
//	 * Public constructor
//	 * 
//	 * Creates the hashmap of robots to their information
//	 * @param completeRobotList
//	 */
//	public Metrics_Old(ArrayList<Robot> completeRobotList){
//		this.completeRobotList = completeRobotList;
//		this.makeHashmap(completeRobotList);
//	}
//
//	public Metrics_Old() {
//		//Blank By Design
//	}
//
//	/**
//	 * Makes the hashmap
//	 * @param completeRobotList
//	 */
//	private void makeHashmap(ArrayList<Robot> completeRobotList) {
//		for (Robot r : completeRobotList){
//			if (r instanceof Queen){
//				numQueens++;
//			}
//			else if (r instanceof Worker){
//				numWorkers++;
//			}
//			else if (r instanceof Scout){
//				numScouts++;
//			}
////			robotMetricHash.put(r, new MetricRobotInformation(r));
//		}
//	}
//	
//	/**
//	 * Sets the start time of all the robots to be the current time
//	 */
//	public void startAllRobots(){
//		for (MetricRobotInformation mri : robotMetricHash.values()){
//			mri.setStartTime();
//		}
//	}
//	
//	/**
//	 * Sets the stop time of all the robot
//	 */
//	public void stopAllRobots(){
//		for (MetricRobotInformation mri : robotMetricHash.values()){
//			mri.setEndTime();
//		}
//	}
//	
//	/**
//	 * Update the number of packets that have been sent and received by two robots
//	 * @param sender
//	 * @param recipient
//	 */
//	public void updatePacketNumbers(Robot sender, Robot recipient){
//		robotMetricHash.get(sender).incrementPacketsSent();
//		robotMetricHash.get(recipient).incrementPacketsReceived();
//	}
//	
//	/**
//	 * Update information about the number of paths that have been driven
//	 * @param sender
//	 * @param recipient
//	 * @param path
//	 */
//	public void updatePathsDriven(Robot sender, Robot recipient, ArrayList<Coord> path){
//		MetricRobotInformation senderInfo = robotMetricHash.get(sender);
//		MetricRobotInformation recipientInfo = robotMetricHash.get(recipient);
//		
//		senderInfo.incrementPacketsSent();
//		recipientInfo.incrementPacketsReceived();
//		recipientInfo.updatePathInformation(recipient.getCurrentLocation(), path);
//	}
//	
//	/**
//	 * Update information about the number of scans that have been performed
//	 * @param sender
//	 * @param recipient
//	 * @param radius
//	 */
//	public void updateScanInformation(Robot sender, Robot recipient, int radius){
//		MetricRobotInformation senderInfo = robotMetricHash.get(sender);
//		MetricRobotInformation recipientInfo = robotMetricHash.get(recipient);
//		
//		senderInfo.incrementPacketsSent();
//		recipientInfo.incrementPacketsReceived();
//		recipientInfo.updateScanInformation(radius);
//	}
//	
//	/**
//	 * Print a report to the screen
//	 */
//	public void printReportToScreen(){
//		System.out.println(new String("ID, " + 
//    	    					 "Level, " + 
//    	    					 "Runtime, " + 
//    	    					 "Scan Time, " + 
//    	    					 "Drive Time, " +
//    	    					 "Packets Sent, " +
//    	    					 "Packets Received, " + 
//    	    					 "# Paths, " + 
//    	    					 "Distance Driven, " + 
//    	    					 "# Scans, " + 
//    	    					 "Area Scanned, "));
//		
//		 for (Robot r : this.completeRobotList){
// 	    	System.out.println(this.robotMetricHash.get(r).toString());
// 	    }
//		
//	}
//	
//	/**
//	 * Print a report to the file system in the "Simulation Output" folder
//	 */
//	public void printReportToFile(){
//      try{
//    	    // Create file 
//    	  	String fileName = new String(numQueens + "Q " + numWorkers + "W " + numScouts + "S  "  + System.currentTimeMillis() + ".txt");
//    	    FileWriter fstream = new FileWriter(new String("Simulation Output/" + fileName));
//    	    BufferedWriter out = new BufferedWriter(fstream);
//    	        
//    	    out.write(new String("ID, " + 
//    	    					 "Level, " + 
//    	    					 "Runtime (ms), " + 
//    	    					 "Scan Time (ms), " + 
//    	    					 "Drive Time (ms), " +
//    	    					 "Packets Sent, " +
//    	    					 "Packets Received, " + 
//    	    					 "# Paths, " + 
//    	    					 "Distance Driven (cm), " + 
//    	    					 "# Scans, " + 
//    	    					 "Area Scanned (cm), "));
//    	    out.newLine();
//    	    out.flush();
//    	    
//    	    for (Robot r : this.completeRobotList){
//    	    	out.write(this.robotMetricHash.get(r).toString());
//        	    out.newLine();
//        	    out.flush();
//    	    }
//    	    
//    	  //Close the output stream
//    	    out.close();
//    	    }catch (Exception e){//Catch exception if any
//    	      System.err.println("Error: " + e.getMessage());
//    	    }
//	}
//}
