package gui;

import java.awt.BasicStroke;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.util.ArrayList;
import java.util.Collection;

import javax.swing.JComponent;

public class DrawingArea_v2 extends JComponent {
	private JComponent container;
	//not really used but suppresses the warning
	private static final long serialVersionUID = 1L;
	
	private Collection<GUIRobot> guiRobots;
	private GUIMap guiMap;
	
	public DrawingArea_v2(JComponent container) {
		this.container= container;
		this.guiRobots= new ArrayList<GUIRobot>();
	}
	/**
	 * Refresh this component.
	 * This method will redraw this entire component with the most up to date
	 * values stored in this component.
	 */
	@Override
	public void paintComponent(Graphics g) {
		if(this.guiMap == null) return;
		//g will always be 2d graphics
		Graphics2D g2d= (Graphics2D)g;
		g2d.setStroke(new BasicStroke(1));
		g2d.setColor(Color.blue);
		g2d.drawRect(0, 0, 100, 100);
		
		//draw the map
		this.getGuiMap().drawMap(g2d);
		this.setPreferredSize(new Dimension(this.guiMap.getXSize(), this.guiMap.getYSize()));
		this.setSize(new Dimension(this.guiMap.getXSize(), this.guiMap.getYSize()));
		this.container.setPreferredSize(this.getPreferredSize());
		this.container.setSize(this.getSize());
		
		if(this.guiRobots == null) return;
		g2d.setStroke(new BasicStroke(5));
		//draw all the robots
		for(GUIRobot gr : this.getGuiRobots()) {
			gr.drawRobot(g2d);
		}
	}
	/**
	 * @param guiRobots the guiRobots to set
	 */
	public void setGuiRobots(Collection<GUIRobot> guiRobots) {
		this.guiRobots = guiRobots;
	}
	/**
	 * @return the guiRobots
	 */
	public Collection<GUIRobot> getGuiRobots() {
		return guiRobots;
	}
	/**
	 * @param guiMap the guiMap to set
	 */
	public void setGuiMap(GUIMap guiMap) {
		this.guiMap = guiMap;
		this.setSize(this.guiMap.getXSize(), this.guiMap.getYSize());
	}
	/**
	 * @return the guiMap
	 */
	public GUIMap getGuiMap() {
		return guiMap;
	}
	

}
