/**
 * 
 */
package gui;

// Will have to be changed when moved!
import java.awt.Color;
import java.awt.Graphics;
import java.util.ArrayList;

import workerCode.*;
import simulation.Scout;

/**
 * @author Ricky
 *
 */
public class GUIRobot {
	
	private Coord location = new Coord(0,0);
	private boolean drawRadius;
	private int radius;
	private char robotType;
	private int robotSize; //robot diameter in pixels

	private ArrayList<Coord> path = new ArrayList<Coord>();
	
	// TODO PRIORITY SIMULATION allow use of path to animate robots point to point
	
	/**
	 * Default constructor
	 */
	public GUIRobot() {

	}
	
	public GUIRobot(Robot robot) {
		if(robot instanceof Queen) {
			robotType = 'Q';
		}
		else if (robot instanceof Worker) {
			robotType = 'W';
		}
		else if (robot instanceof Scout) {
			robotType = 'S';
		}
		else {robotType = '?';}
	}

	public void setLocation(Coord location) {
		this.location = location;
	}

	public Coord getLocation() {
		return location;
	}

	public void setDrawRadius(boolean drawRadius) {
		this.drawRadius = drawRadius;
	}

	public boolean shouldDrawRadius() {
		return drawRadius;
	}

	public void setRadius(int radius) {
		this.radius = radius;
	}

	public int getRadius() {
		return radius;
	}

	public void setPath(ArrayList<Coord> path) {
		this.path = path;
	}

	public ArrayList<Coord> getPath() {
		return path;
	}


	public void setRobotType(char robotType) {
		this.robotType = robotType;
	}

	public char getRobotType() {
		return robotType;
	}
	
	public void drawRobot(Graphics g2d) {
		if(this.robotType == 'Q') return;
		if(this.robotType == 'S') {
			g2d.setColor(Color.green);
		}
		else {
			g2d.setColor(Color.blue);
		}
		this.drawRobotFrame(g2d);
		this.drawRobotBubble(g2d);
		this.drawRobotPath(g2d);
	}
	
	private void drawRobotFrame(Graphics g2d) {
		g2d.fillOval(this.location.getX()-this.robotSize/2, this.location.getY()-this.robotSize/2,
				this.robotSize, this.robotSize);
	}
	
	private void drawRobotBubble(Graphics g2d) {
		if(this.shouldDrawRadius()) {
			g2d.drawOval(this.location.getX()-this.radius,
				     this.location.getY()-this.radius,
				     2*this.radius, 2*this.radius);
		}
	}
	
	private void drawRobotPath(Graphics g2d) {
		g2d.setColor(Color.BLACK);
		Coord prevC= this.location;
		for(Coord c : this.path) {
			g2d.drawLine(prevC.getX(), prevC.getY(), c.getX(), c.getY());
			prevC= c;
		}
	}

	/**
	 * @param robotSize the robotSize to set
	 */
	public void setRobotSize(int robotSize) {
		this.robotSize = robotSize;
	}

	/**
	 * @return the robotSize
	 */
	public int getRobotSize() {
		return robotSize;
	}

}
