package robots;

import gnu.io.CommPortIdentifier;
import gnu.io.NoSuchPortException;

import java.util.ArrayList;
import java.util.Scanner;

import workerCode.Coord;

public class VirtualConfig {
	
	//Xbee Addresses
	public static final long queen1XbeeAddress = 0x0013A200403B0E27L;	
	public static final long worker1XbeeAddress = 0x0013A200405D7EF0L;
	public static final long worker2XbeeAddress = 0x0013A200405D7EEFL;	
	public static final long scout1XbeeAddress = 0x0013A200403B0E2CL;
	public static final long scout2XbeeAddress = 0x0013A200405D7EE9L;
	public static final long scout3XbeeAddress = 0x0013A200405D7EEDL;
	public static final long scout4XbeeAddress = 0x0013A200405D7EE7L;
	
	//Queen Information
	public static final String defaultQueenComm = "COM3";
	public static final int defaultQueenNumWorkers = 2;
	public static final Coord defaultQueenPosition = new Coord(0,0);
	
	//Worker 1 Information
	public static final String defaultWorker1Comm = "COM12";
	public static final int defaultWorker1Scouts = 2;
	public static final Coord defaultWorker1Position = new Coord(60,0);
	
	//Worker 2 Information
	public static final String defaultWorker2Comm = "COM13";
	public static final int defaultWorker2Scouts = 2;
	public static final Coord defaultWorker2Position = new Coord(200,0);
	
	public static CommPortIdentifier requestComPort(String port) {
		
		CommPortIdentifier xbeePortID= null;
		boolean validPort= false;
		while(!validPort) {
			try {
				xbeePortID= CommPortIdentifier.getPortIdentifier(port);
				validPort= true;
			}
			catch (NoSuchPortException e) {
				System.out.println("Invalid COM Port");
				validPort= false;
			}
		}
		
		return xbeePortID;
	}
}
