package robots;

import gnu.io.CommPortIdentifier;

import java.util.ArrayList;
import java.util.Scanner;

import simulation.SimulationParameters;
import simulation.VirtualLocomotionDriver;
import communication.Comm;
import communication.XbeeRemoteCommDriver;

import workerCode.Coord;
import workerCode.ProbMap;
import workerCode.Queen;
import workerCode.Worker;

public class VirtualWorker1 {
	
	public static final void main(String [] args){
		System.out.println("STARTING WORKER 1");
		
		CommPortIdentifier xbeePortID= VirtualConfig.requestComPort(VirtualConfig.defaultWorker1Comm);
		
		XbeeRemoteCommDriver workerCommDriver = new XbeeRemoteCommDriver(xbeePortID);
		
		//Parent
		workerCommDriver.addAddressTableEntry(VirtualConfig.queen1XbeeAddress, 0);
		
		//Children
		if(VirtualConfig.defaultWorker1Scouts == 1){
			workerCommDriver.addAddressTableEntry(VirtualConfig.scout1XbeeAddress, 1);
		}
		else if (VirtualConfig.defaultWorker1Scouts == 2){
			workerCommDriver.addAddressTableEntry(VirtualConfig.scout1XbeeAddress, 1);
			workerCommDriver.addAddressTableEntry(VirtualConfig.scout2XbeeAddress, 2);
		}
		else {
			System.out.println("Invalid Number of Scouts");
		}
		
		Comm workerComm = new Comm(workerCommDriver);
		Worker worker1 = new Worker(Comm.MAX_RANGE, SimulationParameters.workerMinRadius, workerComm, VirtualConfig.defaultWorker1Scouts, new VirtualLocomotionDriver(VirtualConfig.defaultWorker1Position));
		Thread workerThread = new Thread(worker1);
		
		workerThread.start();
		
		System.out.println("WORKER 1 IS NOW RUNNING");

	}
	
}
