package robots;

import gnu.io.CommPortIdentifier;

import java.util.ArrayList;
import java.util.Scanner;

import simulation.SimulationParameters;
import simulation.VirtualLocomotionDriver;
import communication.Comm;
import communication.XbeeRemoteCommDriver;

import workerCode.Coord;
import workerCode.ProbMap;
import workerCode.Queen;
import workerCode.Worker;

public class VirtualWorker2 {
	
	public static final void main(String [] args){
		System.out.println("STARTING WORKER 2");
		
		CommPortIdentifier xbeePortID= VirtualConfig.requestComPort(VirtualConfig.defaultWorker2Comm);
		
		XbeeRemoteCommDriver workerCommDriver = new XbeeRemoteCommDriver(xbeePortID);
		
		//Parent
		workerCommDriver.addAddressTableEntry(VirtualConfig.queen1XbeeAddress, 0);
		
		//Children
		if(VirtualConfig.defaultWorker2Scouts == 1){
			workerCommDriver.addAddressTableEntry(VirtualConfig.scout3XbeeAddress, 1);
		}
		else if (VirtualConfig.defaultWorker2Scouts == 2){
			workerCommDriver.addAddressTableEntry(VirtualConfig.scout3XbeeAddress, 1);
			workerCommDriver.addAddressTableEntry(VirtualConfig.scout4XbeeAddress, 2);
		}
		else {
			System.out.println("Invalid Number of Scouts");
		}
		
		Comm workerComm = new Comm(workerCommDriver);
		Worker worker2 = new Worker(Comm.MAX_RANGE, SimulationParameters.workerMinRadius, workerComm, VirtualConfig.defaultWorker2Scouts, new VirtualLocomotionDriver(VirtualConfig.defaultWorker2Position));
		Thread workerThread = new Thread(worker2);
		
		workerThread.start();
		
		System.out.println("WORKER 2 IS NOW RUNNING");

	}
	
}