package simulation;

import communication.ScanCompletedKnownShadowingPacket;
import communication.PathPacket;
import communication.ReachedDestinationPacket;
import communication.ScanPacket;

import communication.SwarmPacket;

import workerCode.Robot;

public class SimulationPacket {

	private Robot sender;
	private Robot recipient;
	private SwarmPacket packet;
	
	SimulationPacket(Robot sender, Robot recipient, SwarmPacket packet){
		this.sender = sender;
		this.recipient = recipient;
		this.packet = packet;
		
//		System.out.print(this.sender.toString() + " Sending " + this.recipient.toString());
		
		if (packet instanceof ScanPacket){
//		System.out.println(" a Scan Packet");
		}
		
		else if (packet instanceof PathPacket){
//			System.out.println(" a New Path Packet");
		}
		
		else if (packet instanceof ScanCompletedKnownShadowingPacket){
//			System.out.println(" a New Map Completed Packet");
		}
		
		else if (packet instanceof ReachedDestinationPacket){
//			System.out.println(" a New Reached Destination Packet");
		}
		
		else {
//			System.out.println();
		}
		
	}
	
	public Robot getSender(){
		return this.sender;
	}
	
	public Robot getRecipient(){
		return this.recipient;
	}
	
	public SwarmPacket getData(){
		return this.packet;
	}
	
}
