//package simulation;
//
//import workerCode.Coord;
//import workerCode.ProbMap;
//import workerCode.Queen;
//import workerCode.Robot;
//import workerCode.Worker;
//
//import java.util.ArrayList;
//import java.util.HashMap;
//import java.util.Observable;
//import java.util.Observer;
//import java.util.Vector;
//
//import Metrics.Metrics;
//
//import communication.*;
//
//public class Simulation_Old extends Observable implements Runnable, Observer{
//	
//	/**
//	 * NOTES ABOUT THE SIMULATION
//	 * 
//	 * q = queen
//	 * w = worker
//	 * s = scout
//	 */
//	
//	//The map that the simulation will hold and use
//	private ProbMap simulationMap;
//	
//	//The Default Timescale
//	public static int TIMESCALE = 999999999;
//	
//	//Comm Drivers for the robots
//	private  VirtualRemoteCommDriver queenCommDriver;
//	private  ArrayList<VirtualRemoteCommDriver> workerCommDriverTable = new ArrayList<VirtualRemoteCommDriver>();
//	private  ArrayList<VirtualRemoteCommDriver> scoutCommDriverTable = new ArrayList<VirtualRemoteCommDriver>();
//	
//	//Comms for the robots
//	private  Comm queenComm;
//	private  ArrayList<Comm> workerCommTable = new ArrayList<Comm>();
//	private  ArrayList<Comm> scoutCommTable = new ArrayList<Comm>();
//	
//	//Robots themselves
//	private  Queen queen;
//	private  ArrayList<Worker> workerList = new ArrayList<Worker>();
//	private  ArrayList<Scout> scoutList = new ArrayList<Scout>();
//	
//	//Threads
//	private  Thread queenThread;
//	private  ArrayList<Thread> workerThreads = new ArrayList<Thread>();
//	private  ArrayList<Thread> scoutThreads = new ArrayList<Thread>();
//	
//	//Used by the simulation
//	private  VirtualRemoteCommDriver simulationCommDriver= new VirtualRemoteCommDriver("Simulation");
//	private  Comm simulationComm;
//	private  boolean simulationReady= false;
//	private  ArrayList<Coord> workerStart = new ArrayList<Coord>();
//	private  ArrayList<Coord> scoutStart = new ArrayList<Coord>();
//	private HashMap<Comm, Robot> commToRobot = new HashMap<Comm, Robot>();
//	private Vector<Vector<Robot>> workerToScoutList = new Vector<Vector<Robot>>();
//	private ArrayList<Robot> completeRobotList = new ArrayList<Robot>();
//	
//	private int numWorkers;
//	private int scoutsPerWorker;
//	private int minXSize;
//	
//	Metrics swarmMetrics = new Metrics();
//	private boolean killOnce = false;
//	
//	public Simulation_Old(int numWorkers, int scoutsPerWorker, int mapXSize, int mapYSize, int cellSize, int distanceConstant, int cellsUncoveredConstant){
//		simulationMap = new ProbMap(mapXSize, mapYSize, cellSize, ProbMap.NO_OFFSET);
//		
//		//Make a new hashmap of comms to robots but don't populate it yet
//		commToRobot = new HashMap<Comm, Robot>(1 + (numWorkers * scoutsPerWorker));
//		
//		//The number of workers
//		this.numWorkers = numWorkers;
//		
//		//The number of scouts per worker
//		this.scoutsPerWorker = scoutsPerWorker;
//		
////		CoverageAlgorithm.DISTANCECONSTANT = distanceConstant;
////		CoverageAlgorithm.UNCOVEREDCONSTANT = cellsUncoveredConstant;
//	}
//
//	public static final void main(String [] args){
//		System.out.println("Starting a new Simulation");
//
//		Simulation_Old newSim = new Simulation_Old(SimulationParameters.simulationNumWorkers,
//										   					 SimulationParameters.simulationNumScoutsPerWorker,
//										   					 SimulationParameters.mapXSize,
//										   					 SimulationParameters.mapYSize,
//										   					 SimulationParameters.mapCellSize,
//										   					 SimulationParameters.simulationDistanceConstant,
//										   					 SimulationParameters.simulationCellsConstant);
//		
//		newSim.run();
//
//	}
//
//	@Override
//	public void run(){
//		this.setup();
//		this.start();
//	}
//	
//	/**
//	 * This robot performs all of the setup operations for the robots and simulation
//	 */
//	public void setup(){
//		
//		this.setRobotStartLocations(); //Setup the start locations of the robots
//		this.setupRobotCommDrivers();
//		this.setupParentChildRelationships();
//		this.setupRobotComms();
//		this.setupRobots();
//		this.setupThreads();
//		this.setupCommToRobotHashmap();
//		this.setupWorkerScoutList();
//		this.addSimulationToObservers();
//		this.createCompleteRobotList();
//	}
//	
//	private void createCompleteRobotList() {
//		// Assemble the entire list of robots for the simulation
//		
//		//Queen
//		completeRobotList.add(queen);
//		
//		//Workers
//		for(Robot worker: workerList) {
//			completeRobotList.add(worker);
//		}
//		
//		//Scouts
//		for(Robot scout : scoutList) {
//			completeRobotList.add(scout);
//		}
//	}
//
//	/**
//	 * This method adds the simulation as an observer to all the robot comms
//	 * 
//	 * This is done so that the simulation will be notified whenever someone recieves a packet
//	 */
//	private void addSimulationToObservers(){
//		//Queen
//		queenComm.addObserver(this);
//		
//		//Workers
//		for (Comm c : workerCommTable){
//			c.addObserver(this);
//		}
//		
//		//Scouts
//		for (Comm c : scoutCommTable){
//			c.addObserver(this);
//		}
//	}
//	
//	/**
//	 * This method sets up the worker to scout list used by the communication to look up senders
//	 */
//	private void setupWorkerScoutList() {
//		
//		//For Each Worker
//		for (int worker = 0; worker < numWorkers; worker++){
//			
//			//Add a space into the complete robot list
//			this.workerToScoutList.add(new Vector<Robot>());
//			
//			this.workerToScoutList.get(worker).add(workerList.get(worker));
//			
//			//For each Scout (+ 1 for the worker
//			for (int robot = 0; robot < scoutsPerWorker; robot++){
//
//				//Add the scout to the workers list
//				this.workerToScoutList.get(worker).add(scoutList.get((worker * scoutsPerWorker) + (robot)));
//
//			}
//		}
//	}
//	
//	/**
//	 * This method sets up hashmap of every comm to a robot
//	 */
//	private void setupCommToRobotHashmap() {
//		this.commToRobot.put(queenComm, queen);
//		
//		for(int i = 0; i < numWorkers; i++){
//			this.commToRobot.put(workerCommTable.get(i), workerList.get(i));
//		}
//		for(int i = 0; i < numWorkers * scoutsPerWorker; i++){
//			this.commToRobot.put(scoutCommTable.get(i), scoutList.get(i));
//		}		
//	}
//	
//	/**
//	 * This method sets up the threads for each robot
//	 */
//	private void setupThreads() {
//		//Queen
//		queenThread = new Thread(queen);
//		
//		//Workers
//		for (Worker w : this.workerList){
//			workerThreads.add(new Thread(w));
//		}
//		
//		//Scouts
//		for (Scout s : this.scoutList){
//			scoutThreads.add(new Thread(s));
//		}
//	}
//
//	/**
//	 * This method sets up the robot objects for each robot
//	 */
//	private void setupRobots() {
//		// Create The Queen
//		queen = new Queen(0, 0, queenComm, numWorkers, new VirtualLocomotionDriver(new Coord(-1,-1)), new ProbMap(this.simulationMap));
//		
//		// Create the workers and the threads they will run in
//		for(int worker = 0; worker < numWorkers; worker++) {
//			workerList.add(new Worker(SimulationParameters.workerMaxRadius, 
//									  SimulationParameters.workerMinRadius,
//									  workerCommTable.get(worker), 
//									  SimulationParameters.simulationNumScoutsPerWorker,
//									  new VirtualLocomotionDriver(this.workerStart.get(worker).deepCopy())));
//		}
//		
//		// Do the same for the scouts
//		for(int scout = 0; scout < (numWorkers*scoutsPerWorker); scout++) {
//			scoutList.add(new Scout(SimulationParameters.scoutMaxRadius, 
//									SimulationParameters.scoutMinRadius,
//									scoutCommTable.get(scout), 0,
//									new VirtualLocomotionDriver(this.scoutStart.get(scout).deepCopy()), simulationMap));
//		}	
//	}
//
//	/**
//	 * This method adds the now setup commDrivers into the Comms 
//	 */
//	private void setupRobotComms() {
//		//Queen
//		queenComm = new Comm(queenCommDriver);
//		
//		//Workers
//		for(int numComms = 0; numComms < numWorkers; numComms++) {
//			workerCommTable.add(new Comm(workerCommDriverTable.get(numComms)));
//		}
//		
//		//Scouts
//		for(int numComms = 0; numComms < (numWorkers*scoutsPerWorker); numComms++) {
//			scoutCommTable.add(new Comm(scoutCommDriverTable.get(numComms)));
//		}	
//	}
//
//	/**
//	 * This method sets up the parent - child relationships for the Queen <--> Worker and Worker <--> Scout
//	 */
//	private void setupParentChildRelationships() {
//		// Add workers to queen and visa versa
//		for(int worker = 0; worker < numWorkers; worker++) {
//			// Add the worker as a child
//			queenCommDriver.addChild(workerCommDriverTable.get(worker));
//			
//			// Add the queen as a parent
//			workerCommDriverTable.get(worker).addParent(queenCommDriver);
//		}
//		
//		// Add scouts to workers and visa versa
//		for(int worker = 0; worker < numWorkers; worker++) {
//			for(int scout = (worker * scoutsPerWorker); scout < ((worker + 1)*scoutsPerWorker); scout++) {
//				// Add scout to worker
//				workerCommDriverTable.get(worker).addChild(scoutCommDriverTable.get(scout));
//				
//				// Add worker to scout
//				scoutCommDriverTable.get(scout).addParent(workerCommDriverTable.get(worker));
//			}
//		}
//	}
//
//	/**
//	 * This method sets up all the virtualCommDrivers for the swarm
//	 */
//	private void setupRobotCommDrivers() {
//		//Queen
//		queenCommDriver = new VirtualRemoteCommDriver("Queen");
//		
//		//Worker Comm Drivers
//		for(int numComms = 0; numComms < numWorkers; numComms++) {
//			workerCommDriverTable.add(new VirtualRemoteCommDriver("WORKER"));
//		}
//		
//		//Scout Comm Drivers
//		for(int numComms = 0; numComms < (numWorkers*scoutsPerWorker); numComms++) {
//			scoutCommDriverTable.add(new VirtualRemoteCommDriver("SCOUT"));
//		}
//		
//	}
//
//	/**
//	 * This method sets the start locations for all of the robots in the simulation
//	 */
//	private void setRobotStartLocations() {
//		int x = SimulationParameters.initialOffsetFromZero; //The initial x offset for the first scout
//		int numScoutsLeft; //The number of scouts on the left of a worker
//		int numScoutsRight; //The number of scouts on the right of a worker
//		
//		//This if / else determines the number of scouts on the left and right of the worker
//		if (scoutsPerWorker %2 == 0){
//			numScoutsLeft = scoutsPerWorker / 2;
//			numScoutsRight = scoutsPerWorker / 2;
//		}
//		else {
//			numScoutsLeft = scoutsPerWorker / 2 + 1;
//			numScoutsRight = scoutsPerWorker /2;
//		}
//		
//		//For each worker
//		for (int i = 0; i < numWorkers; i++){
//			
//			//For each scout on the left, place a scout on the left and increment its position by 30cm
//			for (int j = 0; j < numScoutsLeft; j++){
//				scoutStart.add(new Coord(x, 0));
//				x += SimulationParameters.placementIncrement;
//			}
//			
//			//Place the worker in the middle
//			workerStart.add(new Coord(x, 0));
//			x+= SimulationParameters.placementIncrement;
//			
//			//For each scout on the right, place a scout and increment by 30
//			for (int j = 0; j < numScoutsRight; j++){
//				scoutStart.add(new Coord(x, 0));
//				x += SimulationParameters.placementIncrement;
//			}
//
//			x+=SimulationParameters.placementIncrement;
//		}
//		
//		this.minXSize = ((x-SimulationParameters.placementIncrement) / simulationMap.getCellConversion());
//		
//	}
//
//	public void start(){
//		if (this.simulationMap.getxSize() < this.minXSize){
//			System.out.println("MAP TOO SMALL");
//		}
//		else{
//			swarmMetrics = new Metrics(this.completeRobotList);
//			swarmMetrics.startAllRobots();
//			startRobotThreads();
//		}
//	}
//	
//	private void startRobotThreads() {
//		// Start the Queen
//		queenThread.start();
//		
//		// Start the Workers
//		for(Thread worker : workerThreads) {
//			worker.start();
//		}
//		
//		//Start the Scouts
//		for(Thread scout : scoutThreads) {
//			scout.start();
//		}
//	}
//
//	
//	
//	
//	
//	
//	
//	
//	
//	
//	
//	
//	
//	
//	
//	
//	
//	
//	
//	
//	
//	
//
//
//
//
//	
//	
//
//
//	@Override
//	public synchronized void update(Observable arg0, Object arg1) {
////		if(arg0 == this.simulationComm) {
////			SwarmPacket packet= ((SwarmCommunication)arg1).getPacket();
////			//if the packet is a scan complete packet
////			if(packet instanceof ScanCompletedPacket) {
////				this.simulationReady= true;
////				this.notifyAll();
////			}
////			//if the packet is a child info packet
////			else if(packet instanceof ChildInformationPacket) {
////				this.simulationReady= true;
////				this.notifyAll();
////			}
////		}
////		//Instead of calling handler directly call
////		else if ((arg0 instanceof Comm)){
////			
////			SwarmCommunication newSComm = (SwarmCommunication)arg1;
////			SwarmPacket newPacket = newSComm.getPacket();
////			Comm newComm = (Comm)arg0;
////			
////			if(!(arg0 == this.queenComm && newSComm.getID() == Comm.PARENT_ID)) {
////				Robot sender = this.lookupSender(newComm, newSComm.getID());
////				Robot recipient = this.commToRobot.get(newComm);
////				
////				/*****************************
////				 *       Metrics             *
////				 *****************************/
////				
////				if (newPacket instanceof ScanPacket){
////					swarmMetrics.updateScanInformation(sender, recipient, ((ScanPacket) newPacket).getRadius());
////				}
////				
////				else if (newPacket instanceof PathPacket){
////					swarmMetrics.updatePathsDriven(sender, recipient, ((PathPacket) newPacket).getPath());
////				}
////				
////				else if (newPacket instanceof KillPacket){
////					if(!this.killOnce){
////						swarmMetrics.stopAllRobots();
//////						swarmMetrics.printReportToScreen();
////						swarmMetrics.printReportToFile();
////						this.killOnce = true;
////					}
////				}
////				else {
////					swarmMetrics.updatePacketNumbers(sender, recipient);
////				}
////				
////				/*****************************
////				 *       End Metrics         *
////				 *****************************/
////				
////				alertWatchers(new SimulationPacket(sender, //Sender
////						   recipient, //Recipient
////						   newSComm.getPacket()));  //Packet
////			}
////			
////			
////			if (newSComm.getPacket() instanceof SimulationDonePacket){
////				synchronized(this){
////					this.notify();
////				}
////			}
////		}
//		
//	}
//	
//	private Robot lookupSender(Comm newComm, int senderID){
//		int count = 0;
//		int myID = 0;
//		
//		if (this.commToRobot.get(newComm) instanceof Queen){
//			return this.workerToScoutList.get(senderID - 1).get(0);
//		}
//		
//		//IF you are a worker
//		else if (this.commToRobot.get(newComm) instanceof Worker){
//			
//			//If the ID = 0, the sender must be the queen
//			if (senderID == 0){
//				return queen;
//			}
//			
//			//If the ID is not zero
//			else {
//				
//				//Determine which worker you are
//				for (Robot r : workerList){
//					if (this.commToRobot.get(newComm) == r){
//						myID = count;
//						break;
//					}
//					count++;
//				}
//				
//				//Return the appropriate scout
//				return this.workerToScoutList.get(myID).get(senderID);
//			}
//		}
//		
//		else if (this.commToRobot.get(newComm) instanceof Scout){
//			
//			//Sender was a parent
//			if (senderID == 0){
//				for (int worker = 0; worker < numWorkers; worker++){
//					for (int scout = 1; scout <= scoutsPerWorker; scout++){
//						
//						//Look for yourself
//						if (this.workerToScoutList.get(worker).get(scout) == this.commToRobot.get(newComm)){
//							return workerToScoutList.get(worker).get(0);
//						}
//					}
//				}
//			}
//		}
//		
//		return null;
//	}
//
//
//	private void alertWatchers(SimulationPacket sPacket){
//		this.setChanged();
//		this.notifyObservers(sPacket);
//		
//	}
//
//	public void setCompleteRobotList(ArrayList<Robot> completeRobotList) {
//		this.completeRobotList = completeRobotList;
//	}
//
//	public ArrayList<Robot> getCompleteRobotList() {
//		return completeRobotList;
//	}
//	
//}
