	package virtualRemoteCommDriverTest;

	import java.util.Observable;
	import java.util.Observer;

	import org.junit.Test;
	import static org.junit.Assert.*;

	import workerCode.Coord;

	import communication.Comm;
	import communication.ChildInformationPacket;
	import communication.SwarmCommunication;
	import communication.VirtualRemoteCommDriver;

public class ChildInformationReplyPacketTest implements Observer{
		
		Coord location = new Coord();
		int min = 0;
		int max = 0;
		ChildInformationPacket packet = new ChildInformationPacket();
		
		@Test
		public void basicCommTest() {
			VirtualRemoteCommDriver parent= new VirtualRemoteCommDriver();
			VirtualRemoteCommDriver child= new VirtualRemoteCommDriver();
			parent.addChild(child);
			child.addParent(parent);
			Comm parentComm= new Comm(parent);
			Comm childComm= new Comm(child);
			parentComm.addObserver(this);
			childComm.send(Comm.PARENT_ID, new ChildInformationPacket(new Coord(50,50), 80, 10, true));
			
			synchronized(this){
				try {
					this.wait();
				} catch (InterruptedException e) {
					e.printStackTrace();
				}
				assertEquals(50, this.location.getX());
				assertEquals(50, this.location.getY());
				assertEquals(10, this.min);
				assertEquals(80, this.max);
			}
			
		}

		@Override
		public void update(Observable arg0, Object arg1) {
			
			if(arg1 instanceof SwarmCommunication) {
				
				synchronized(this){
					packet = (ChildInformationPacket)((SwarmCommunication)arg1).getPacket();
					this.location = packet.getLocation();
					this.min = packet.getMinScanRadius();
					this.max = packet.getMaxScanRadius();
					this.notify();
				}
			}
			
		}
	}

