package virtualRemoteCommDriverTest;

import java.util.Observable;
import java.util.Observer;

import org.junit.Test;
import static org.junit.Assert.*;


import communication.Comm;
import communication.ScanCompletedKnownShadowingPacket;
import communication.SwarmCommunication;
import communication.VirtualRemoteCommDriver;

public class MapCompletedSuccessfullyPacketTest implements Observer{
	
	boolean recieved = false;
	ScanCompletedKnownShadowingPacket packet = new ScanCompletedKnownShadowingPacket();

	
	@Test
	public void basicCommTest() {
		VirtualRemoteCommDriver parent= new VirtualRemoteCommDriver("Parent Driver");
		VirtualRemoteCommDriver child= new VirtualRemoteCommDriver("Child Driver");
		parent.addChild(child);
		child.addParent(parent);
		Comm parentComm= new Comm(parent);
		Comm childComm= new Comm(child);
		parentComm.addObserver(this);
		childComm.send(Comm.PARENT_ID, new ScanCompletedKnownShadowingPacket());
		
		synchronized(this){
			try {
				this.wait();
			} catch (InterruptedException e) {
				e.printStackTrace();
			}
			assertTrue(recieved);
		}
		
	}

	@Override
	public void update(Observable arg0, Object arg1) {
		
		if(arg1 instanceof SwarmCommunication) {
			synchronized(this){
					packet = (ScanCompletedKnownShadowingPacket)((SwarmCommunication)arg1).getPacket();
						recieved = true;
						this.notify();
			}
		}
		
	}
}
