	package virtualRemoteCommDriverTest;

	import java.util.ArrayList;
import java.util.Observable;
	import java.util.Observer;

	import org.junit.Test;
	import static org.junit.Assert.*;

	import workerCode.Coord;

	import communication.Comm;
	import communication.PathPacket;
	import communication.SwarmCommunication;
	import communication.VirtualRemoteCommDriver;

public class NewPathPacketTest implements Observer{
		
		ArrayList<Coord> newPath = new ArrayList<Coord>();
		PathPacket packet = new PathPacket();
		
		@Test
		public void basicCommTest() {
			this.newPath.add(new Coord(0,0));
			this.newPath.add(new Coord(1,0));
			this.newPath.add(new Coord(0,1));
			this.newPath.add(new Coord(1,1));
			
			VirtualRemoteCommDriver parent= new VirtualRemoteCommDriver();
			VirtualRemoteCommDriver child= new VirtualRemoteCommDriver();
			parent.addChild(child);
			child.addParent(parent);
			Comm parentComm= new Comm(parent);
			Comm childComm= new Comm(child);
			childComm.addObserver(this);
			parentComm.send(1, new PathPacket(this.newPath));
			
			synchronized(this){
				try {
					this.wait();
				} catch (InterruptedException e) {
					e.printStackTrace();
				}
				assertTrue(this.newPath.get(0).equals(new Coord(0,0)));
				assertTrue(this.newPath.get(1).equals(new Coord(1,0)));
				assertTrue(this.newPath.get(2).equals(new Coord(0,1)));
				assertTrue(this.newPath.get(3).equals(new Coord(1,1)));
			}
			
		}

		@Override
		public void update(Observable arg0, Object arg1) {
			
			if(arg1 instanceof SwarmCommunication) {
				
				synchronized(this){
					packet = (PathPacket)((SwarmCommunication)arg1).getPacket();
					this.newPath = packet.getPath();
					this.notify();
				}
			}
			
		}
	}

