package virtualRemoteCommDriverTest;

import java.util.Observable;
import java.util.Observer;

import org.junit.Test;
import static org.junit.Assert.*;


import communication.Comm;
import communication.ReadyPacket;
import communication.SwarmCommunication;
import communication.VirtualRemoteCommDriver;

public class ReadyPacketTest implements Observer{
	
	boolean recieved = false;
	int count= 0;
	ReadyPacket packet = new ReadyPacket();

	
	@Test
	public void basicCommTest() {
		VirtualRemoteCommDriver parent1= new VirtualRemoteCommDriver("Parent1 Driver");
		VirtualRemoteCommDriver parent2=  new VirtualRemoteCommDriver("Parent2 Driver");
		VirtualRemoteCommDriver child1 = new VirtualRemoteCommDriver("Child1 Driver");
		VirtualRemoteCommDriver child2 = new VirtualRemoteCommDriver("Child2 Driver");
		VirtualRemoteCommDriver child3 = new VirtualRemoteCommDriver("Child1 Driver");
		VirtualRemoteCommDriver child4 = new VirtualRemoteCommDriver("Child2 Driver");
		
		parent1.addChild(child1);
		parent1.addChild(child2);
		parent2.addChild(child3);
		parent2.addChild(child4);
		child1.addParent(parent1);
		child2.addParent(parent1);
		child3.addParent(parent2);
		child4.addParent(parent2);
		
		Comm parent1Comm= new Comm(parent1);
		Comm parent2Comm= new Comm(parent2);
		Comm child1Comm= new Comm(child1);
		Comm child2Comm= new Comm(child2);
		Comm child3Comm= new Comm(child3);
		Comm child4Comm= new Comm(child4);
		
		parent1Comm.addObserver(this);
		parent2Comm.addObserver(this);
		
		for(int i= 0; i < 100; i ++) {
			child1Comm.send(Comm.PARENT_ID, new ReadyPacket());
			child2Comm.send(Comm.PARENT_ID, new ReadyPacket());
			child3Comm.send(Comm.PARENT_ID, new ReadyPacket());
			child4Comm.send(Comm.PARENT_ID, new ReadyPacket());
		}
		
		synchronized(this){
			try {
				this.wait();
				System.out.println("Woke Up");
				System.out.flush();
			} catch (InterruptedException e) {
				e.printStackTrace();
			}
			assertTrue(recieved);
		}
		
	}

	@Override
	public void update(Observable arg0, Object arg1) {
		
		if(arg1 instanceof SwarmCommunication) {
			System.out.println("Recieved a Packet");
			synchronized(this){
					packet = (ReadyPacket)((SwarmCommunication)arg1).getPacket();
					count++;
					System.out.println(count);
					if(count == 400) {
						System.out.println("GOT IT");
						recieved = true;
						this.notify();
					}
			}
		}
		
	}
}
