package virtualRemoteCommDriverTest;

import java.util.Observable;
import java.util.Observer;

import org.junit.Test;
import static org.junit.Assert.*;

import communication.Comm;
import communication.RequestInformationPacket;
import communication.SwarmCommunication;
import communication.VirtualRemoteCommDriver;

public class RequestInformationPacketTest implements Observer{
		
		boolean recieved = false;
		RequestInformationPacket packet = new RequestInformationPacket();
		
		@Test
		public void basicCommTest() {
			VirtualRemoteCommDriver parent= new VirtualRemoteCommDriver();
			VirtualRemoteCommDriver child= new VirtualRemoteCommDriver();
			parent.addChild(child);
			child.addParent(parent);
			Comm parentComm= new Comm(parent);
			Comm childComm= new Comm(child);
			childComm.addObserver(this);
			parentComm.send(1, new RequestInformationPacket());
			
			synchronized(this){
				try {
					this.wait();
				} catch (InterruptedException e) {
					e.printStackTrace();
				}
				assertTrue(recieved);
			}
			
		}

		@Override
		public void update(Observable arg0, Object arg1) {
			
			if(arg1 instanceof SwarmCommunication) {
				
				synchronized(this){
					packet = (RequestInformationPacket)((SwarmCommunication)(arg1)).getPacket();
					recieved = true;
					this.notify();
				}
			}
			
		}
	}

