package virtualRemoteCommDriverTest;

import java.util.Observable;
import java.util.Observer;

import org.junit.Test;
import static org.junit.Assert.*;

import communication.Comm;
import communication.ScanPacket;
import communication.SwarmCommunication;
import communication.VirtualRemoteCommDriver;

public class ScanPacketTest implements Observer{
		
		int radius = 0;
		ScanPacket packet = new ScanPacket();
		
		@Test
		public void basicCommTest() {
			VirtualRemoteCommDriver parent= new VirtualRemoteCommDriver();
			VirtualRemoteCommDriver child= new VirtualRemoteCommDriver();
			parent.addChild(child);
			child.addParent(parent);
			Comm parentComm= new Comm(parent);
			Comm childComm= new Comm(child);
			childComm.addObserver(this);
			parentComm.send(1, new ScanPacket(200));
			
			synchronized(this){
				try {
					this.wait();
				} catch (InterruptedException e) {
					e.printStackTrace();
				}
				assertEquals(200, this.radius);
			}
			
		}

		@Override
		public void update(Observable arg0, Object arg1) {
			
			if(arg1 instanceof SwarmCommunication) {
				
				synchronized(this){
					packet = (ScanPacket)((SwarmCommunication)arg1).getPacket();
					this.radius = packet.getRadius();
					this.notify();
				}
			}
			
		}
	}

