package virtualRemoteCommDriverTest;

import static org.junit.Assert.*;

import org.junit.Test;

import communication.TypeConverter;

public class TypeConverterTest {

	
	@Test
	public void intToBytesTest(){
		int test = Integer.MAX_VALUE;
		byte[] byteArray = new byte[4];
		
		byteArray = TypeConverter.intToBytes(test);
		
		assertEquals((byte)127, byteArray[0]);
		assertEquals((byte)255, byteArray[1]);
		assertEquals((byte)255, byteArray[2]);
		assertEquals((byte)255, byteArray[3]);
	}
	
	@Test
	public void shortToBytesTest(){
		short test = Short.MAX_VALUE;
		byte[] byteArray = new byte[2];
		
		byteArray = TypeConverter.shortToBytes(test);
		
		assertEquals((byte)127, byteArray[0]);
		assertEquals((byte)255, byteArray[1]);
	}
	
	@Test
	public void bytesToIntTest(){
		byte[] byteArray = new byte[4];
		byteArray[0] = (byte)127;
		byteArray[1] = (byte)255;
		byteArray[2] = (byte)255;
		byteArray[3] = (byte)255;
		
		assertEquals(Integer.MAX_VALUE, TypeConverter.bytesToInt(byteArray));
	}
	
	@Test
	public void bytesToShortTest(){
		byte[] byteArray = new byte[2];
		byteArray[0] = (byte)127;
		byteArray[1] = (byte)255;
		
		assertEquals(Short.MAX_VALUE, TypeConverter.bytesToShort(byteArray));
	}
}
