package communication;

import java.util.ArrayList;

import workerCode.Coord;

public class PathPacket extends SwarmPacket {

	private ArrayList<Coord> path = new ArrayList<Coord>();
	
	public PathPacket(){
		//Blank by Design
	}
	
	public PathPacket(ArrayList<Coord> finalPath) {
		super(Comm.NEW_PATH_OPCODE);
		this.path = finalPath;
	}

	@Override
	public void deSerializeData(byte[] data) {
		
		byte[] tempArrayX = new byte[2];
		byte[] tempArrayY = new byte[2];

		for (int i = 0; i < data.length/4; i++){
			this.path.add(new Coord());
		}
		
		for (int i = 0; i < data.length/4; i++){
			tempArrayX[0] = data[(i * 4 + 0)];
			tempArrayX[1] = data[(i * 4 + 1)];
			tempArrayY[0] = data[(i * 4 + 2)];
			tempArrayY[1] = data[(i * 4 + 3)];
			
			int tempX = TypeConverter.bytesToShort(tempArrayX);
			int tempY = TypeConverter.bytesToShort(tempArrayY);

			this.path.set(i, new Coord(tempX, tempY));
		}

	}

	@Override
	public byte[] serializeData() {
		byte[] tempArrayX = new byte[2];
		byte[] tempArrayY = new byte[2];
		
		byte[] retVal = new byte[this.path.size() * 4];
		
		
		for (int i = 0; i<this.path.size(); i++){
			
			// Retrieve the coordinates as data bytes
			tempArrayX = TypeConverter.shortToBytes((short)this.path.get(i).getX());
			tempArrayY = TypeConverter.shortToBytes((short)this.path.get(i).getY());
			
			// Add them to the array of bytes
			retVal[(i * 4 + 0)] = tempArrayX[0];
			retVal[(i * 4 + 1)] = tempArrayX[1];
			retVal[(i * 4 + 2)] = tempArrayY[0];
			retVal[(i * 4 + 3)] = tempArrayY[1];
		}
		
		return retVal;
	}
	
	public ArrayList<Coord> getPath(){
		return this.path;
	}

}
