package communication;

import workerCode.Coord;

public class ReachedDestinationPacket extends SwarmPacket {

	private Coord destination;
	
	public ReachedDestinationPacket() {
		super(Comm.REACHED_DESTINATION_OPCODE);
		this.setDestination(new Coord());
	}
	public ReachedDestinationPacket(Coord destination){
		super(Comm.REACHED_DESTINATION_OPCODE);
		this.setDestination(destination);
	}
	
	@Override
	public byte[] serializeData() {
		byte[] serialData= new byte[4];
		byte[] tmpArray;
		tmpArray= TypeConverter.shortToBytes((short)getDestination().getX());
		serialData[0]= tmpArray[0];
		serialData[1]= tmpArray[1];
		
		tmpArray= TypeConverter.shortToBytes((short)getDestination().getY());
		serialData[2]= tmpArray[0];
		serialData[3]= tmpArray[1];
		
		return serialData;
	}

	@Override
	public void deSerializeData(byte[] data) {
		byte[] tmpArray= new byte[2];
		tmpArray[0]= data[0];
		tmpArray[1]= data[1];
		this.getDestination().setX(TypeConverter.bytesToShort(tmpArray));
		
		tmpArray[0]= data[2];
		tmpArray[1]= data[3];
		this.getDestination().setY(TypeConverter.bytesToShort(tmpArray));
	}
	/**
	 * @param destination the destination to set
	 */
	public void setDestination(Coord destination) {
		this.destination = destination;
	}
	/**
	 * @return the destination
	 */
	public Coord getDestination() {
		return destination;
	}
	

}
