package communication;

import java.util.Observable;

public abstract class RemoteCommDriver extends Observable implements Runnable {
	
	
	public abstract boolean send(byte id, byte[] serialData);
	public abstract void kill();
	
	/**
	 * @author Eric
	 * This class is intended to act as a container for both the id of the
	 * sender and the payload of the packet.
	 */
	public class ReceiveDataArray {
		public byte id; //id of sender
		public byte[] data; //array of data bytes
		
		public ReceiveDataArray() {
			//Blank default constructor by design
		}
		public ReceiveDataArray(byte id, byte[] data) {
			this.id= id;
			this.data= data;
		}
		
	}

}
