package communication;

public class RxPacketAPI extends XbeeAPIFrame {
	private long addr64bit;
	private short addr16bit;
	private byte rxOptions;
	private byte[] rxData;

	public RxPacketAPI() {
		super(XbeeAPIFrame.RX_PACKET);
	}
	
	@Override
	protected byte[] serializeFrame() {
		byte[] tempBuf;
		byte[] retVal= new byte[11 + this.rxData.length];
		//serialize 64 bit address
		tempBuf= TypeConverter.longToBytes(this.addr64bit);
		retVal[0]= tempBuf[0];
		retVal[1]= tempBuf[1];
		retVal[2]= tempBuf[2];
		retVal[3]= tempBuf[3];
		retVal[4]= tempBuf[4];
		retVal[5]= tempBuf[5];
		retVal[6]= tempBuf[6];
		retVal[7]= tempBuf[7];
		
		//serialize 16 bit address
		tempBuf= TypeConverter.shortToBytes(this.addr16bit);
		retVal[8]= tempBuf[0];
		retVal[9]= tempBuf[1];
		
		//serialize rx options
		retVal[10]= this.rxOptions;
		
		//append rx data
		for(int i= 0; i < this.rxData.length; i++) {
			retVal[11 + i]= this.rxData[i];
		}
		
		return retVal;
	}

	@Override
	protected void deSerializeFrame(byte[] serialData) {
		//pull out 64 bit address
		byte[] tempBuf= new byte[8];
		tempBuf[0]= serialData[0];
		tempBuf[1]= serialData[1];
		tempBuf[2]= serialData[2];
		tempBuf[3]= serialData[3];
		tempBuf[4]= serialData[4];
		tempBuf[5]= serialData[5];
		tempBuf[6]= serialData[6];
		tempBuf[7]= serialData[7];
		
		this.addr64bit= TypeConverter.bytesToLong(tempBuf);
		
		//pull out 16 bit address
		tempBuf= new byte[2];
		tempBuf[0]= serialData[8];
		tempBuf[1]= serialData[9];
		
		this.addr16bit= TypeConverter.bytesToShort(tempBuf);
		
		//pull out rx options
		this.rxOptions= serialData[10];
		
		//copy out rx payload
		this.rxData= new byte[serialData.length - 11];
		for(int i= 0; i < this.rxData.length; i++) {
			this.rxData[i]= serialData[i+11];
		}
		
	}

	/**
	 * @param addr64bit the addr64bit to set
	 */
	public void setAddr64bit(long addr64bit) {
		this.addr64bit = addr64bit;
	}

	/**
	 * @return the addr64bit
	 */
	public long getAddr64bit() {
		return addr64bit;
	}

	/**
	 * @param addr16bit the addr16bit to set
	 */
	public void setAddr16bit(int addr16bit) {
		this.addr16bit = (short)addr16bit;
	}

	/**
	 * @return the addr16bit
	 */
	public short getAddr16bit() {
		return addr16bit;
	}

	/**
	 * @param rxOptions the rxOptions to set
	 */
	public void setRxOptions(int rxOptions) {
		this.rxOptions = (byte)rxOptions;
	}

	/**
	 * @return the rxOptions
	 */
	public byte getRxOptions() {
		return rxOptions;
	}

	/**
	 * @param rxData the rxData to set
	 */
	public void setRxData(byte[] rxData) {
		this.rxData = rxData;
	}

	/**
	 * @return the rxData
	 */
	public byte[] getRxData() {
		return rxData;
	}

}
