package communication;

public class ScanPacket extends SwarmPacket {

	private int radius; //the radius to scan
	
	public ScanPacket() {
		super(Comm.SCAN_PACKET_OPCODE);
	}
	
	public ScanPacket(int radius) {
		super(Comm.SCAN_PACKET_OPCODE);
		this.radius= radius;
	}
	@Override
	protected byte[] serializeData() {
		// radius is stored as 16 bit integer
		byte[] retVal;
		retVal = TypeConverter.shortToBytes((short)this.radius);
		return retVal;
	}
	
	@Override
	protected void deSerializeData(byte[] data) {
		this.radius = TypeConverter.bytesToShort(data);
	}
	
	public int getRadius() {
		return this.radius;
	}

}
