/**
 * 
 */
package communication;

/**
 * @author hsrmqp
 *
 */
public abstract class SwarmPacket {
	
	private byte opcode;

	public SwarmPacket() {
		//Intentionally left blank
	}
	/**
	 * 
	 */
	public SwarmPacket(byte opcodenum) {
		this.opcode = opcodenum;
	}


	public byte getOpcode() {
		return opcode;
	}
	
	public void setOpcode(byte opcode) {
		this.opcode= opcode;
	}
	
	static public byte getOpcode(byte[] serialData) {
		return serialData[0];
	}
	
	public byte[] serializeHeader() {
		byte retVal[]= new byte[1];
		retVal[0]= this.opcode;
		
		return retVal;
	}
	
	protected abstract byte[] serializeData();
	protected abstract void deSerializeData(byte[] data);
	
	/**
	 * Convert the information in this packet into an array of bytes.  The
	 * data should be sent in big endian form.
	 * @return
	 */
	public byte[] serialize() {
		byte header[]= this.serializeHeader();
		byte data[]= this.serializeData();
		byte retVal[]= new byte[header.length + data.length];
		
		for(int i= 0; i < header.length; i++) {
			retVal[i]= header[i];
		}
		
		for(int i= 0; i < data.length; i++) {
			retVal[i+header.length]= data[i];
		}
		
		return retVal;
	}
	
	/**
	 * Fill the fields of this swarm packet based on the serial data received.
	 */
	public void deSerialize(byte[] serialData) {
		this.opcode= serialData[0];
		byte[] packetSpecificData= new byte[serialData.length - 1];
		for(int i= 0; i < packetSpecificData.length; i++) {
			packetSpecificData[i]= serialData[i+1];
		}
		this.deSerializeData(packetSpecificData);
	}

}
