package communication;

public class TxStatusAPI extends XbeeAPIFrame {
	private byte frameID;
	private short addr16bit;
	private byte retryCount;
	private byte deliveryStatus;
	private byte discoveryStatus;
	
	
	public TxStatusAPI() {
		super(XbeeAPIFrame.TX_STATUS);
	}

	@Override
	protected byte[] serializeFrame() {
		byte[] serialFrame= new byte[6];
		
		//serialize frameID
		serialFrame[0]= frameID;
		
		//serialize 16 bit address
		byte[] tempBuf= TypeConverter.shortToBytes(this.addr16bit);
		serialFrame[1]= tempBuf[0];
		serialFrame[2]= tempBuf[1];
		
		//serialize retry count
		serialFrame[3]= this.retryCount;
		
		//serialize delivery status
		serialFrame[4]= this.deliveryStatus;
		
		//serialize discovery status
		serialFrame[5]= this.discoveryStatus;
		
		return serialFrame;
	}

	@Override
	protected void deSerializeFrame(byte[] serialData) {
		//strip out frame ID
		this.frameID= serialData[0];
		
		//get 16 bit address
		byte[] tempBuf= new byte[2];
		tempBuf[0]= serialData[1];
		tempBuf[1]= serialData[2];
		this.addr16bit= TypeConverter.bytesToShort(tempBuf);
		
		//get retry count
		this.retryCount= serialData[3];
		
		//get delivery status
		this.deliveryStatus= serialData[4];
		
		//get discovery status
		this.discoveryStatus= serialData[5];

	}

	/**
	 * @param frameID the frameID to set
	 */
	public void setFrameID(int frameID) {
		this.frameID = (byte)frameID;
	}

	/**
	 * @return the frameID
	 */
	public byte getFrameID() {
		return frameID;
	}

	/**
	 * @param addr16bit the addr16bit to set
	 */
	public void setAddr16bit(int addr16bit) {
		this.addr16bit = (short)addr16bit;
	}

	/**
	 * @return the addr16bit
	 */
	public short getAddr16bit() {
		return addr16bit;
	}

	/**
	 * @param retryCount the retryCount to set
	 */
	public void setRetryCount(int retryCount) {
		this.retryCount = (byte)retryCount;
	}

	/**
	 * @return the retryCount
	 */
	public byte getRetryCount() {
		return retryCount;
	}

	/**
	 * @param deliveryStatus the deliveryStatus to set
	 */
	public void setDeliveryStatus(int deliveryStatus) {
		this.deliveryStatus = (byte)deliveryStatus;
	}

	/**
	 * @return the deliveryStatus
	 */
	public byte getDeliveryStatus() {
		return deliveryStatus;
	}

	/**
	 * @param discoveryStatus the discoveryStatus to set
	 */
	public void setDiscoveryStatus(int discoveryStatus) {
		this.discoveryStatus = (byte)discoveryStatus;
	}

	/**
	 * @return the discoveryStatus
	 */
	public byte getDiscoveryStatus() {
		return discoveryStatus;
	}

}
