package communication;

public class TypeConverter {

	public TypeConverter(){
		
	}
	
	public static byte[] longToBytes(long number) {
		byte[] byteData= new byte[8];
		byteData[0]= (byte)((number & 0xFF00000000000000L) >> 56);
		byteData[1]= (byte)((number & 0x00FF000000000000L) >> 48);
		byteData[2]= (byte)((number & 0x0000FF0000000000L) >> 40);
		byteData[3]= (byte)((number & 0x000000FF00000000L) >> 32);
		byteData[4]= (byte)((number & 0x00000000FF000000L) >> 24);
		byteData[5]= (byte)((number & 0x0000000000FF0000L) >> 16);
		byteData[6]= (byte)((number & 0x000000000000FF00L) >> 8);
		byteData[7]= (byte)(number & 0x00000000000000FFL);
		
		return byteData;
	}
	
	public static byte[] intToBytes(int integer ){
		byte[] byteData = new byte[4];
		byteData[0] = (byte)((integer & 0xFF000000) >> 24);
		byteData[1] = (byte)((integer & 0x00FF0000) >> 16);
		byteData[2] = (byte)((integer & 0x0000FF00) >> 8);
		byteData[3] = (byte)(integer & 0x000000FF);
	
		return byteData;
	}
	
	public static byte[] shortToBytes(short number){
		int integer = (int)number;
		byte[] byteData = new byte[2];
		byteData[0] = (byte)((integer & 0x0000FF00) >> 8);
		byteData[1] = (byte)(integer & 0x000000FF);
	
		return byteData;
	}
	
	public static long bytesToLong(byte[] bytes) {
		long firstByte= 0;
		long secondByte= 0;
		long thirdByte= 0;
		long fourthByte= 0;
		long fifthByte= 0;
		long sixthByte= 0;
		long seventhByte= 0;
		long eighthByte= 0;
		
		firstByte= ((0xFF & (long)bytes[0]) << 56);
		secondByte= ((0xFF & (long)bytes[1]) << 48);
		thirdByte= ((0xFF & (long)bytes[2]) << 40);
		fourthByte= ((0xFF & (long)bytes[3]) << 32);
		fifthByte= ((0xFF & (long)bytes[4]) << 24);
		sixthByte= ((0xFF & (long)bytes[5]) << 16);
		seventhByte= ((0xFF & (long)bytes[6]) << 8);
		eighthByte= (0xFF & (long)bytes[7]);
		
		return (long)(firstByte | secondByte | thirdByte | fourthByte |
				      fifthByte | sixthByte | seventhByte | eighthByte);
	}
	
	public static int bytesToInt(byte[] bytes){
		int firstByte = 0;
        int secondByte = 0;
        int thirdByte = 0;
        int fourthByte = 0;
        
        firstByte = ((0x000000FF & (int)bytes[0]) << 24);
        secondByte = ((0x000000FF & (int)bytes[1]) << 16);
        thirdByte = ((0x000000FF & (int)bytes[2]) << 8);
        fourthByte = (0x000000FF & (int)bytes[3]);
        
        return (int)(firstByte | secondByte | thirdByte | fourthByte);
	}
	
	public static short bytesToShort(byte[] bytes){
		short firstByte = 0;
        short secondByte = 0;
        
        firstByte = (short) ((0x00FF & (short)bytes[0]) << 8);
        secondByte = (short) (0x00FF & (short)bytes[1]);

        return (short) (firstByte | secondByte);
	}
	
	
}
