package workerCode;

import java.util.ArrayList;

import communication.*;

public class Queen extends Robot {

	
	
	//TODO PRIORITY SIMULATION Delete
//	private int iterations = 0;
	
	public Queen(int scanMax, int scanMin, Comm robotComm,
			int numChildren, Locomotion robotLocomotion) {
		super(scanMax, scanMin, robotComm, numChildren, robotLocomotion);
		this.robotCoverageAlgorithm= new CoverageAlgorithm();
	}
	
	public Queen(int scanMax, int scanMin, Comm robotComm, int numChildren, Locomotion robotLocomotion, ProbMap map){
		super(scanMax, scanMin, robotComm, numChildren, robotLocomotion);
		this.robotCoverageAlgorithm = new CoverageAlgorithm();
		this.robotMap = map;
	}
	
	@Override
	protected void scan(int radius) {
		int caStatus = 0;
		this.updateMapWithCurrentLocation();
		ArrayList<Child> childArrayList= new ArrayList<Child>();
		ArrayList<Child> childSendList= new ArrayList<Child>();
		childArrayList.addAll(this.childList.values());
		while(true) {
			//TODO PRIORITY SIMULATION Delete
//			iterations++;
			caStatus= this.robotCoverageAlgorithm.run(this.robotLocomotion.getCurrentLocation(), this.robotMap, childArrayList, radius);
//			System.out.println(caStatus);
			if(caStatus == CoverageAlgorithm.WORK_TO_DO) {
				
				
				//Determine how many waves are in this iteration of the CA
				
				for (int currentWave = 1; currentWave <= this.findNumWaves(); currentWave++){	
				
					childSendList.clear();
					for(Child c : this.childList.values()) {
						if(c.isMove() && c.getWave() == currentWave) {
//							System.out.println("Queen sending child Worker " + c.getID() + " in wave " + c.getWave() + " currently at " + c.getCurrentLocation() + " to " + c.getNextLocation());
							childSendList.add(c);
						}
	//					System.out.println("Queen Sending child Worker to: " + c.getNextLocation());
					}
					this.sendPathToChildren(childSendList);
					childSendList.clear();
					//wait for children to be ready to scan
					this.waitForChildren();
				
				}
				
				//form list of children to be sent a map
				for(Child c : this.childList.values()) {
					if(c.getRequiresMap()) {
						childSendList.add(c);
//						System.out.println("Queen sending child Worker " + c.getID() + " a Map");
					}
				}
				//send map to children
				this.sendMapToChildren(childSendList);
				childSendList.clear();
				//form list of children which should be sent scan
				for(Child c : this.childList.values()) {
					if(c.isScan()) {
						childSendList.add(c);
//						System.out.println("Queen sending child Worker " + c.getID() + " a Scan Packet");
					}
//					System.out.println("Queen Telling Child Worker to Scan with Radius: " + c.getScanRadius());
				}
				//send scan packets to children
				this.sendScanToChildren(childSendList);
				childSendList.clear();
				
				this.waitForChildren();
//				System.out.println("Queen: Done One Interation");
//				this.robotMap.testMapPrint();
		}
				
			else if(caStatus == CoverageAlgorithm.NO_MORE_VALID_SPACES) {
				//send back map completed
				//break out of while loop
				
//				System.out.print(iterations + "[,] ");
				this.kill();
				break;
			}

			
			else if(caStatus == CoverageAlgorithm.UNREACHABLE_SPACES) {
				//send back map completed with shadowing
				//break out of while loop
				
//				System.out.print(iterations + "{,} ");
				this.kill();
				break;
			}
				
		}
		
	}

	@Override
	protected void allChildrenReady() {
		
		//this.robotMap.cellScan(new Coord(0,0));
		
		for (Child c : this.childList.values()){
			c.setScanRadius(c.getMinScanRadius());
		}
		this.sendMapToChildren(this.childList.values());
		this.scan(Integer.MAX_VALUE);
	}
	
	public void startSwarm(){
		this.scan(Integer.MAX_VALUE);
	}

}
