package workerTest;

import static org.junit.Assert.*;
import org.junit.*;

import workerCode.Coord;

public class CoordTest {
	
	Coord coord1 = new Coord();
	Coord coord2 = new Coord(0,0);
	
	@Test
	public void defaultConstructorTest(){
		assertEquals(-1, coord1.getX());
		assertEquals(-1, coord1.getY());
	}
	
	@Test
	public void constructorTest(){
		assertEquals(0, coord2.getX());
		assertEquals(0, coord2.getY());
	}
	
	@Test
	public void setXTest(){
		Coord coord3 = new Coord();
		coord3.setX(1);
		assertEquals(1, coord3.getX());
	}
	
	@Test
	public void setYTest(){
		Coord coord3 = new Coord();
		coord3.setY(1);
		assertEquals(1, coord3.getY());
	}
	
	@Test
	public void validFailTest(){
		Coord coord4 = new Coord();
		assertFalse(coord4.isValid());
	}
	
	@Test
	public void validPassTest(){
		Coord coord5 = new Coord(1,1);
		assertTrue(coord5.isValid());
	}
	
	@Test
	public void deepCopyTest(){
		Coord coord6 = new Coord(1,1);
		Coord coord7 = new Coord();
		coord7 = coord6.deepCopy();
		assertEquals(1, coord7.getX());
		assertEquals(1, coord7.getY());
	}
	
	@Test
	public void equalsFailTest(){
		Coord coord8 = new Coord(1,1);
		Coord coord9 = new Coord();
		assertFalse(coord8.equals(coord9));
	}
	
	@Test
	public void equalsPassTest(){
		Coord coord10 = new Coord(1,1);
		Coord coord11 = new Coord(1,1);
		assertTrue(coord10.equals(coord11));
	}
}
