//package workerTest;
//
//import static org.junit.Assert.*;
//
//import java.util.ArrayList;
//
//import org.junit.*;
//
//import workerCode.Child;
//import workerCode.Coord;
//import workerCode.Dijkstra;
//import workerCode.ProbMap;
//
//public class DijkstraTest {
//	private Child child1;
//	private ProbMap testMap;
//	private Dijkstra myTestDijk;
//	private ArrayList<Child> testChildList = new ArrayList<Child>();
//	
//	@Before
//	public void setUp() throws Exception{
//		myTestDijk = new Dijkstra();
//		testMap = new ProbMap(3,3, 1, ProbMap.NO_OFFSET);
//		testMap.testMapUnscan();
//		
//		child1 = new Child(1, new Coord(0,0), 10, 80);
//		
//		testChildList.add(child1);
//		
//		testMap.cellScan(child1.getCurrentLocation());
//		
//	}
//	
//	@Test
//	public void distance3x3Test(){
//		testMap.testMapScan();
//		myTestDijk.runDijkstras(child1, testMap);
//		assertEquals(0, child1.getDijkstraMap().cellGetDistance(child1.getCurrentLocation()));
//		assertEquals(1, child1.getDijkstraMap().cellGetDistance(new Coord(1,0)));
//		assertEquals(1, child1.getDijkstraMap().cellGetDistance(new Coord(0,1)));
//		assertEquals(2, child1.getDijkstraMap().cellGetDistance(new Coord(1,1)));	
//		
//		assertEquals(2, child1.getDijkstraMap().cellGetDistance(new Coord(0,2)));
//		assertEquals(3, child1.getDijkstraMap().cellGetDistance(new Coord(1,2)));
//		assertEquals(4, child1.getDijkstraMap().cellGetDistance(new Coord(2,2)));
//		assertEquals(3, child1.getDijkstraMap().cellGetDistance(new Coord(2,1)));
//		assertEquals(2, child1.getDijkstraMap().cellGetDistance(new Coord(2,0)));
//	}
//	
//	@Test
//	public void distance5x5Test(){
//		testMap = new ProbMap(5,5,10, ProbMap.NO_OFFSET);
//		testMap.testMapScan();
//		myTestDijk.runDijkstras(child1, testMap);
//		assertEquals(0, child1.getDijkstraMap().cellGetDistance(new Coord(0,0)));
//		assertEquals(1, child1.getDijkstraMap().cellGetDistance(new Coord(1,0)));
//		assertEquals(2, child1.getDijkstraMap().cellGetDistance(new Coord(2,0)));
//		assertEquals(3, child1.getDijkstraMap().cellGetDistance(new Coord(3,0)));
//		assertEquals(4, child1.getDijkstraMap().cellGetDistance(new Coord(4,0)));
//		
//		assertEquals(1, child1.getDijkstraMap().cellGetDistance(new Coord(0,1)));
//		assertEquals(2, child1.getDijkstraMap().cellGetDistance(new Coord(1,1)));
//		assertEquals(3, child1.getDijkstraMap().cellGetDistance(new Coord(2,1)));
//		assertEquals(4, child1.getDijkstraMap().cellGetDistance(new Coord(3,1)));
//		assertEquals(5, child1.getDijkstraMap().cellGetDistance(new Coord(4,1)));
//		
//		assertEquals(2, child1.getDijkstraMap().cellGetDistance(new Coord(0,2)));
//		assertEquals(3, child1.getDijkstraMap().cellGetDistance(new Coord(1,2)));
//		assertEquals(4, child1.getDijkstraMap().cellGetDistance(new Coord(2,2)));
//		assertEquals(5, child1.getDijkstraMap().cellGetDistance(new Coord(3,2)));
//		assertEquals(6, child1.getDijkstraMap().cellGetDistance(new Coord(4,2)));
//		
//		assertEquals(3, child1.getDijkstraMap().cellGetDistance(new Coord(0,3)));
//		assertEquals(4, child1.getDijkstraMap().cellGetDistance(new Coord(1,3)));
//		assertEquals(5, child1.getDijkstraMap().cellGetDistance(new Coord(2,3)));
//		assertEquals(6, child1.getDijkstraMap().cellGetDistance(new Coord(3,3)));
//		assertEquals(7, child1.getDijkstraMap().cellGetDistance(new Coord(4,3)));
//		
//		assertEquals(4, child1.getDijkstraMap().cellGetDistance(new Coord(0,4)));
//		assertEquals(5, child1.getDijkstraMap().cellGetDistance(new Coord(1,4)));
//		assertEquals(6, child1.getDijkstraMap().cellGetDistance(new Coord(2,4)));
//		assertEquals(7, child1.getDijkstraMap().cellGetDistance(new Coord(3,4)));
//		assertEquals(8, child1.getDijkstraMap().cellGetDistance(new Coord(4,4)));
//
//	}
//	
//	@Test
//	public void path001Test(){
//		testMap.testMapScan();
//		child1.setNextLocation(new Coord(2,2));
//		myTestDijk.runDijkstras(child1, testMap);
//		
//		child1.setFinalPath();
//		assertEquals(0, child1.getFinalPath().get(0).getX());
//		assertEquals(0, child1.getFinalPath().get(0).getY());
//		
//		assertEquals(0, child1.getFinalPath().get(1).getX());
//		assertEquals(1, child1.getFinalPath().get(1).getY());
//		
//		assertEquals(0, child1.getFinalPath().get(2).getX());
//		assertEquals(2, child1.getFinalPath().get(2).getY());
//		
//		assertEquals(1, child1.getFinalPath().get(3).getX());
//		assertEquals(2, child1.getFinalPath().get(3).getY());
//		
//		assertEquals(2, child1.getFinalPath().get(4).getX());
//		assertEquals(2, child1.getFinalPath().get(4).getY());
//	}
//	
//	@Test
//	public void pathUnscannedChangeTest(){
//		testMap.testMapScan();
//		testMap.cellUnscan(new Coord(0,2));
//		child1.setNextLocation(new Coord(2,2));
//		myTestDijk.runDijkstras(child1, testMap);
//		
//		child1.setFinalPath();
//		assertEquals(0, child1.getFinalPath().get(0).getX());
//		assertEquals(0, child1.getFinalPath().get(0).getY());
//		
//		assertEquals(0, child1.getFinalPath().get(1).getX());
//		assertEquals(1, child1.getFinalPath().get(1).getY());
//		
//		assertEquals(1, child1.getFinalPath().get(2).getX());
//		assertEquals(1, child1.getFinalPath().get(2).getY());
//		
//		assertEquals(1, child1.getFinalPath().get(3).getX());
//		assertEquals(2, child1.getFinalPath().get(3).getY());
//		
//		assertEquals(2, child1.getFinalPath().get(4).getX());
//		assertEquals(2, child1.getFinalPath().get(4).getY());
//	}
//	
//	@Test
//	public void pathBlockedChangedTest(){
//		testMap.testMapScan();
//		testMap.cellSetBlockValue(new Coord(0,2), 1);
//		child1.setNextLocation(new Coord(2,2));
//		myTestDijk.runDijkstras(child1, testMap);
//		
//		child1.setFinalPath();
//		assertEquals(2, child1.getFinalPath().get(4).getX());
//		assertEquals(2, child1.getFinalPath().get(4).getY());
//		
//		assertEquals(1, child1.getFinalPath().get(3).getX());
//		assertEquals(2, child1.getFinalPath().get(3).getY());
//		
//		assertEquals(1, child1.getFinalPath().get(2).getX());
//		assertEquals(1, child1.getFinalPath().get(2).getY());
//		
//		assertEquals(0, child1.getFinalPath().get(1).getX());
//		assertEquals(1, child1.getFinalPath().get(1).getY());
//		
//		assertEquals(0, child1.getFinalPath().get(0).getX());
//		assertEquals(0, child1.getFinalPath().get(0).getY());
//
//	}
//	
//	@Test
//	public void repathLoopTest(){
//		testMap.testMapScan();
//		testMap.cellUnscan(new Coord(0,1));
//		testMap.cellUnscan(new Coord(1,1));
//		child1.setNextLocation(new Coord(0,2));
//		myTestDijk.runDijkstras(child1, testMap);
//		
//		child1.setFinalPath();
//		assertEquals(0, child1.getFinalPath().get(0).getX());
//		assertEquals(0, child1.getFinalPath().get(0).getY());
//		
//		assertEquals(1, child1.getFinalPath().get(1).getX());
//		assertEquals(0, child1.getFinalPath().get(1).getY());
//		
//		assertEquals(2, child1.getFinalPath().get(2).getX());
//		assertEquals(0, child1.getFinalPath().get(2).getY());
//		
//		assertEquals(2, child1.getFinalPath().get(3).getX());
//		assertEquals(1, child1.getFinalPath().get(3).getY());
//		
//		assertEquals(2, child1.getFinalPath().get(4).getX());
//		assertEquals(2, child1.getFinalPath().get(4).getY());
//		
//		assertEquals(1, child1.getFinalPath().get(5).getX());
//		assertEquals(2, child1.getFinalPath().get(5).getY());
//		
//		assertEquals(0, child1.getFinalPath().get(6).getX());
//		assertEquals(2, child1.getFinalPath().get(6).getY());
//		
//	}
//	
//	@Test
//	public void noNextPointTest(){
//		testMap.testMapScan();
//		child1.setNextLocation(new Coord());
//		myTestDijk.runDijkstras(child1, testMap);
//		
//		child1.setFinalPath();
//		assertEquals(0, child1.getFinalPath().size());
//		
//	}
//	
//	@Test
//	public void unreachableNextPoint001Test(){
//		testMap.testMapScan();
//		child1.setNextLocation(new Coord(0,2));
//		testMap.cellUnscan(new Coord(0,1));
//		testMap.cellUnscan(new Coord(1,1));
//		testMap.cellUnscan(new Coord(2,1));
//		myTestDijk.runDijkstras(child1, testMap);
//		
//		child1.setFinalPath();
//		assertEquals(0, child1.getFinalPath().size());
//	}
//	
//	@Test
//	public void unreachableNextPoint002Test(){
//		testMap.testMapScan();
//		child1.setNextLocation(new Coord(0,2));
//		testMap.cellUnscan(new Coord(0,1));
//		testMap.cellUnscan(new Coord(1,1));
//		testMap.cellUnscan(new Coord(2,2));
//		myTestDijk.runDijkstras(child1, testMap);
//		
//		child1.setFinalPath();
//		assertEquals(0, child1.getFinalPath().size());
//	}
//	
//	@Test
//	public void noMoveTest(){
//		testMap.testMapUnscan();
//		child1.setNextLocation(new Coord(0,0));
//		testMap.cellScan(new Coord(0,0));
//		
//		myTestDijk.runDijkstras(child1, testMap);
//		child1.setFinalPath();
//		
//		assertEquals(0, child1.getFinalPath().size());
//	}
//	
//	@Test
//	public void optimizeTest() {
//		testMap.testMapScan();
//		child1.setNextLocation(new Coord(2,2));
//		myTestDijk.runDijkstras(child1, testMap);
//		
//		child1.setFinalPath();
//		assertEquals(5, child1.getFinalPath().size());
//		
//		child1.optimizeFinalPath();
//		assertEquals(2, child1.getFinalPath().size());
//	}
//	
//	@Test
//	public void partialOptimizeTest() {
//		testMap.testMapScan();
//		testMap.cellUnscan(new Coord(0,1));
//		child1.setNextLocation(new Coord(2,2));
//		myTestDijk.runDijkstras(child1, testMap);
//		
//		child1.setFinalPath();
//		assertEquals(5, child1.getFinalPath().size());
//		
//		child1.optimizeFinalPath();
//		assertEquals(3, child1.getFinalPath().size());
//	}
//	
//	@Test
//	public void partialOptimizeTest2() {
//		testMap.testMapScan();
//		testMap.cellUnscan(new Coord(1,0));
//		child1.setNextLocation(new Coord(2,2));
//		myTestDijk.runDijkstras(child1, testMap);
//		
//		child1.setFinalPath();
//		assertEquals(5, child1.getFinalPath().size());
//		
//		child1.optimizeFinalPath();
//		assertEquals(3, child1.getFinalPath().size());
//	}
//	
//	@Test
//	public void partialOptimizeTest3() {
//		testMap.testMapScan();
//		testMap.cellUnscan(new Coord(1,0));
//		testMap.cellUnscan(new Coord(1,1));
//		testMap.cellUnscan(new Coord(2,1));
//		
//		child1.setNextLocation(new Coord(2,2));
//		myTestDijk.runDijkstras(child1, testMap);
//		
//		child1.setFinalPath();
//		assertEquals(5, child1.getFinalPath().size());
//		
//		child1.optimizeFinalPath();
//		assertEquals(3, child1.getFinalPath().size());
//		child1.getFinalPath().get(0).testPrint();
//		child1.getFinalPath().get(1).testPrint();
//		child1.getFinalPath().get(2).testPrint();
//	}
//	
//	@Test
//	public void cannotOptimizeTest() {
//		testMap.testMapScan();
//		testMap.cellUnscan(new Coord(1,0));
//		testMap.cellUnscan(new Coord(0,2));
//		testMap.cellUnscan(new Coord(2,1));
//		child1.setNextLocation(new Coord(2,2));
//		myTestDijk.runDijkstras(child1, testMap);
//		
//		child1.setFinalPath();
//		assertEquals(5, child1.getFinalPath().size());
//		
//		child1.optimizeFinalPath();
//		assertEquals(5, child1.getFinalPath().size());
//	}
//	
//	
//}
