package workerTest;

import static org.junit.Assert.*;

import org.junit.Test;

import workerCode.Coord;
import workerCode.ProbMap;

public class RobotTest {

	ProbMap robotMap = new ProbMap(10, 10, 10, ProbMap.NO_OFFSET);
	
	@Test
	public void robotBodyAreaTest001(){
		robotMap.testMapUnscan();
		robotMap.testMapPrint();
		
		updateRobotOccupiedArea(new Coord(50,50));
		
		robotMap.testMapPrint();
		
		assertTrue(robotMap.cellIsScanned(new Coord(4,4)));
		assertTrue(robotMap.cellIsScanned(new Coord(5,4)));
		assertTrue(robotMap.cellIsScanned(new Coord(6,4)));
		
		assertTrue(robotMap.cellIsScanned(new Coord(5,4)));
		assertTrue(robotMap.cellIsScanned(new Coord(5,5)));
		assertTrue(robotMap.cellIsScanned(new Coord(5,6)));
		
		assertTrue(robotMap.cellIsScanned(new Coord(6,4)));
		assertTrue(robotMap.cellIsScanned(new Coord(6,5)));
		assertTrue(robotMap.cellIsScanned(new Coord(6,6)));
	}
	
	@Test
	public void robotBodyAreaTest002(){
		robotMap.testMapUnscan();
		robotMap.testMapPrint();
		
		updateRobotOccupiedArea(new Coord(0,0));
		
		robotMap.testMapPrint();
		
		assertTrue(robotMap.cellIsScanned(new Coord(0,0)));
		assertTrue(robotMap.cellIsScanned(new Coord(0,1)));
		assertTrue(robotMap.cellIsScanned(new Coord(1,0)));
		assertTrue(robotMap.cellIsScanned(new Coord(1,1)));
		
	}
	
	@Test
	public void robotBodyAreaTest003(){
		robotMap.testMapUnscan();
		robotMap.testMapPrint();
		
		updateRobotOccupiedArea(new Coord(90,90));
		
		robotMap.testMapPrint();
		
		assertTrue(robotMap.cellIsScanned(new Coord(9,9)));
		assertTrue(robotMap.cellIsScanned(new Coord(8,9)));
		assertTrue(robotMap.cellIsScanned(new Coord(8,8)));
		assertTrue(robotMap.cellIsScanned(new Coord(9,8)));
		
	}
	
	@Test
	public void robotBodyAreaTest004(){
		robotMap.testMapUnscan();
		robotMap.testMapPrint();
		
		updateRobotOccupiedArea(new Coord(50,0));
		
		robotMap.testMapPrint();
		
		assertTrue(robotMap.cellIsScanned(new Coord(5,0)));
		assertTrue(robotMap.cellIsScanned(new Coord(4,0)));
		assertTrue(robotMap.cellIsScanned(new Coord(6,0)));
		
		assertTrue(robotMap.cellIsScanned(new Coord(5,1)));
		assertTrue(robotMap.cellIsScanned(new Coord(4,1)));
		assertTrue(robotMap.cellIsScanned(new Coord(6,1)));
		
	}
	
	@Test
	public void robotBodyAreaTest005(){
		robotMap.testMapUnscan();
		robotMap.testMapPrint();
		
		updateRobotOccupiedArea(new Coord(50,90));
		
		robotMap.testMapPrint();
		
		assertTrue(robotMap.cellIsScanned(new Coord(5,9)));
		assertTrue(robotMap.cellIsScanned(new Coord(4,9)));
		assertTrue(robotMap.cellIsScanned(new Coord(6,9)));
		
		assertTrue(robotMap.cellIsScanned(new Coord(5,8)));
		assertTrue(robotMap.cellIsScanned(new Coord(4,8)));
		assertTrue(robotMap.cellIsScanned(new Coord(6,8)));
		
	}
	
	private void updateRobotOccupiedArea(Coord currentLocation) {
		Coord scaledLocation = currentLocation.scaleCoordDown(this.robotMap.getCellConversion());
		this.robotMap.cellScan(scaledLocation);
		
		if (this.robotMap.CUpIsInTheMap(scaledLocation)){
			this.robotMap.cellScan(this.robotMap.CUp(scaledLocation));
		}
		
		if (this.robotMap.CDownIsInTheMap(scaledLocation)){
			this.robotMap.cellScan(this.robotMap.CDown(scaledLocation));
		}
		
		if (this.robotMap.CLeftIsInTheMap(scaledLocation)){
			this.robotMap.cellScan(this.robotMap.CLeft(scaledLocation));
			
			if (this.robotMap.CUpIsInTheMap(this.robotMap.CLeft(scaledLocation))){
				this.robotMap.cellScan(this.robotMap.CUp(this.robotMap.CLeft(scaledLocation)));
			}
			
			if (this.robotMap.CDownIsInTheMap(this.robotMap.CLeft(scaledLocation))){
				this.robotMap.cellScan(this.robotMap.CDown(this.robotMap.CLeft(scaledLocation)));
			}
			
		}
		
		if (this.robotMap.CRightIsInTheMap(scaledLocation)){
			this.robotMap.cellScan(this.robotMap.CRight(scaledLocation));
			
			if (this.robotMap.CUpIsInTheMap(this.robotMap.CRight(scaledLocation))){
				this.robotMap.cellScan(this.robotMap.CUp(this.robotMap.CRight(scaledLocation)));
			}
			
			if (this.robotMap.CDownIsInTheMap(this.robotMap.CRight(scaledLocation))){
				this.robotMap.cellScan(this.robotMap.CDown(this.robotMap.CRight(scaledLocation)));
			}
		}
		
		
		
	}
	
}
