/*
 * beacondetector.h
 *
 *  Created on: Dec 6, 2010
 *      Author: hsrmqp
 */

#ifndef BEACONDETECTOR_H_
#define BEACONDETECTOR_H_


#include "avr/io.h"
#include "adc_driver.h"
#include "stdbool.h"

//Defines
#define CANDLE_DETECT_bm 0x01
#define BEACON_DETECT_bm 0x02

/* The point of this struct is ONLY to set up hardware defined things known at
 * compile time such as port/pin numbers or other setup stuff */
typedef struct beacondetector_setup {

   PORT_t** port;	// Array of Input ports
   uint8_t* pin;	// Array of Input pins

} beacon_detector_setup_t;

//Function Prototypes
void init_beaconDetector(beacon_detector_setup_t* setup);
uint8_t irledDetectorGet(uint8_t beaconSel);

#endif /* BEACONDETECTOR_H_ */
