/*
 * hbridge.h
 *
 *  Created on: Dec 2, 2010
 *      Author: hsrmqp
 */

#ifndef HBRIDGE_H_
#define HBRIDGE_H_

#include "avr/io.h"
#include "tc_driver.h"

//Defines
#define MOTOR_PWM_PERIOD 1000


//Simple struct to handle the direction pins of the HBridge
typedef struct hbridge_dirPins{
	uint8_t dir0;
	uint8_t dir1;
} direcPins_t;

//The point of this struct is ONLY to set up hardware defined things known at
//compile time such as port/pin numbers or other setup stuff
typedef struct hbridge_setup {

   TC0_t** motorPWMTimer; //Array of PWM timers
   TCCOMPARE_t* motorCompare; //Array of compare registers
   PORT_t** motorOutputPort; //Array of output ports
   direcPins_t* motorDirPins; //Array of direction pin structs

} hbridge_setup_t;

//Function Prototypes
void init_hbridge(hbridge_setup_t* setup);
void setMotorPWM(uint8_t motor, float dutyCycle);
void setMotorsPWM(float* motorPWMArray, uint8_t numMotors);
float getMotorPWM(uint8_t motor);

#endif /* HBRIDGE_H_ */
