/*
 * localization.h
 *
 *  Created on: Dec 18, 2010
 *      Author: hsrmqp
 */

#ifndef LOCALIZATION_H_
#define LOCALIZATION_H_

#include <stdint.h>

#define MOUSE_SENSOR_WEIGHT  1
#define ENCODER_WEIGHT       0

typedef struct pose {
   float x;     //x position (in cm)
   float y;     //y position (in cm)
   float theta; //orientation (between -pi and pi in radians)

} pose_t;


typedef struct coordinate {
   uint16_t x;  //x position (in cm)
   uint16_t y;  //y position (in cm)
} coordinate_t;


void getPose(pose_t* p);
void getPose_dev(pose_t* p, uint16_t* deviation);
void setPose(pose_t* p);
void updatePose();
void updateState();
float getWheelVelocity(uint8_t wheel);
uint64_t getTimeStamp_us(void);
float getTimeStamp_s(void);

#endif /* LOCALIZATION_H_ */
