/*
 * locomotion.h
 *
 *  Created on: Dec 19, 2010
 *      Author: hsrmqp
 */

#ifndef LOCOMOTION_H_
#define LOCOMOTION_H_
#include "localization.h"
#include <stdbool.h>

//UCOS flag bitmask
#define DRIVING_FLAG 0x01u
#define COLLISION_FLAG 0x02u

//Tolerances which define how close a robot needs to be to the endpoint
//before it can consider itself there.
#define ANGULAR_TOLERANCE    0.0174532925 //in radians (1 degree)
#define POSITIONAL_TOLERANCE 1 //in cm

//Constants for closed loop path control
#define K_ROW   10
#define K_ALPHA 20
#define K_BETA -1

//PID constants
#define K_P .007
#define K_I 0
#define K_D 0

//structs
typedef struct v_omega_pair {
   float v;
   float omega;
} v_omega_pair_t;

bool driveToPose(pose_t* p);
void locomotion_task(void* pd);
void emergencyStop(void);
void setEndpointPose(pose_t* newEndpoint);
void getEndpointPose(pose_t* endpoint);


#endif /* LOCOMOTION_H_ */
