/*
 * scanner.h
 *
 *  Created on: Dec 19, 2010
 *      Author: hsrmqp
 */

#ifndef SCANNER_H_
#define SCANNER_H_

#include "stdint.h"
#include "stdbool.h"

#define MAX_SCAN_RADIUS 75
#define MIN_SCAN_RADIUS 20


typedef struct object {
   int16_t x;       //x coordinate of the object (in cm)
   int16_t y;       //y coordinate of the object (in cm)
   uint8_t stdDeviation; //expected deviation of object from reported x,y
   uint8_t properties_bm;  //bitmask for the properties of the object.
                           //All zeros indicates that it is just an ordinary obstacle.
                           //b0 - candle
                           //b1 - beacon
} object_t;

int8_t scanAngle(int8_t servoAngle, uint8_t irSel, uint8_t range, object_t* o);

#endif /* SCANNER_H_ */
