/*
 * app_cfg.h
 *
 *  Created on: Dec 12, 2010
 *      Author: hsrmqp
 */

#ifndef APP_CFG_H_
#define APP_CFG_H_

/*
 ******************************************************************************
 *                           Task/Mutex Priorities
 ******************************************************************************
 */
// enum makes for an easy way to specify the relative priorities of each task
// first one in list is priority 0, second is priority 1, etc.
enum {
   CURRENT_POSE_MUTEX_p_enum,
   SETPOINT_POSE_MUTEX_p_enum,
   LOCOMOTION_TASK_p_enum,
   RX_REMOTE_TASK_p_enum,
   COMMAND_TASK_p_enum,
};
#define CURRENT_POSE_MUTEX_PRIO CURRENT_POSE_MUTEX_p_enum
#define SETPOINT_POSE_MUTEX_PRIO SETPOINT_POSE_MUTEX_p_enum
#define LOCOMOTION_TASK_PRIO LOCOMOTION_TASK_p_enum
#define RX_REMOTE_TASK_PRIO RX_REMOTE_TASK_p_enum
#define COMMAND_TASK_PRIO COMMAND_TASK_p_enum

/*
 ******************************************************************************
 *                               Stack Sizes
 ******************************************************************************
 */
#define LOCOMOTION_TASK_STACK_SIZE 1536
#define RX_REMOTE_TASK_STACK_SIZE 512
#define COMMAND_TASK_STACK_SIZE 512

/*
 ******************************************************************************
 *                               Heap Sizes
 ******************************************************************************
 */
#define SMALL_MEM_BLOCK_SIZE   50
#define MEDIUM_MEM_BLOCK_SIZE  100
#define LARGE_MEM_BLOCK_SIZE   300

#define SMALL_MEM_NUM_BLOCKS   15
#define MEDIUM_MEM_NUM_BLOCKS  5
#define LARGE_MEM_NUM_BLOCKS   2

/*
 ******************************************************************************
 *                           Message Queue Sizes
 ******************************************************************************
 */
#define COMMAND_Q_SIZE 5

#endif /* APP_CFG_H_ */
