/*
 * matrix.h
 *
 *  Created on: Dec 9, 2010
 *      Author: hsrmqp
 */

#ifndef MATRIX_H_
#define MATRIX_H_

#include "stdint.h"
#include "stdbool.h"

//#defines
#define MAX_ROWS 6
#define MAX_COLS 6

typedef struct matrix {
   float* data;     //values in matrix
   uint8_t numRows; //number of rows
   uint8_t numCols; //number of columns
} matrix_t;

//Function prototypes
void matrix_create(matrix_t* m, uint8_t rows, uint8_t cols);
void matirx_create_preallocated(matrix_t* m, uint8_t rows, uint8_t cols, float* data);
void matrix_delete(matrix_t* m);
float matrix_get(matrix_t* m, uint8_t i, uint8_t j);
void matrix_set(matrix_t* m, uint8_t i, uint8_t j, float value);
void matrix_add_scalar(matrix_t* m, float s, matrix_t* output);
void matrix_multiply_scalar(matrix_t* m, float s, matrix_t* output);
void matrix_add(matrix_t* A, matrix_t* B, matrix_t* output);
void matrix_multiply(matrix_t* A, matrix_t* B, matrix_t* output);
bool matrix_isScalar(matrix_t* m);
float matrix_determinant(matrix_t* m);
void matrix_minor(matrix_t* m, uint8_t i, uint8_t j, matrix_t* output);
void matrix_cofactor(matrix_t* m, bool transpose, matrix_t* output);
void matrix_transpose(matrix_t* m, matrix_t* output);
void matrix_invert(matrix_t* m, matrix_t* output);

#endif /* MATRIX_H_ */
