/*
 * adc.c
 *
 *  Created on: Nov 13, 2010
 *      Author: Nicholas Alunni
 *      Am I still eric?
 */

//This file will contain all the higher level functions for the adc
//Such files might be Init, Set, and Get
//The commented out code below is an example (from the XPlain series) about how to do a single ADC coversion
/*
 */

/*
 *                     Task 1
 *
 * In this task we will use the Virtual Channel 0 (CH0),
 * (do not worry about Virtual Channel's yet as they
 * will be covered in task3.) To the Virtual Channel 0,
 * we will attach and convert the NTC-resistor-
 * voltage from the Xplain board.
 *
 */




#include <avr/io.h>
#include "adc_driver.h"
#include "adcTest.h"

#define LEDPORT PORTE

volatile uint16_t ADC_result;

/*
 * This function handles setting an ADC
 *
 * @param myADC the ADC struct that contains all the pertinant information
 */
void adcSet(adcStruct_t* myADC){
//
//	switch (myADC->ADC){
//		case 'A':
//
//			/* Move stored calibration values to ADC A */
//			ADC_CalibrationValues_Load(&ADCA);
//
//			//Set the resolution and the signed or unsigned conversion mode
//			ADC_ConvMode_and_Resolution_Config(&ADCA, myADC->isSigned, ADC_RESOLUTION_12BIT_gc);
//
//			//Set the vRef
//			switch (myADC->vRef){
//			case 0: ADC_Reference_Config(&ADCA, ADC_REFSEL_VCC_gc);
//			}
//
//			//Set the PreScaler
//			switch (myADC->preScale){
//			case 4: ADC_Prescaler_Config(&ADCA, ADC_PRESCALER_DIV4_gc);
//			case 8: ADC_Prescaler_Config(&ADCA, ADC_PRESCALER_DIV8_gc);
//			case 16: ADC_Prescaler_Config(&ADCA, ADC_PRESCALER_DIV16_gc);
//			case 32: ADC_Prescaler_Config(&ADCA, ADC_PRESCALER_DIV32_gc);
//			case 64: ADC_Prescaler_Config(&ADCA, ADC_PRESCALER_DIV64_gc);
//			case 128: ADC_Prescaler_Config(&ADCA, ADC_PRESCALER_DIV128_gc);
//			case 256: ADC_Prescaler_Config(&ADCA, ADC_PRESCALER_DIV256_gc);
//			case 512: ADC_Prescaler_Config(&ADCA, ADC_PRESCALER_DIV512_gc);
//			}
//
//			//Set the channel, mode, and gain, and input pins
//			switch (myADC->chan){
//			case 0:
//				//set the mode
//				switch (myADC->mode){
//				case 0:
//					//set the gain
//					switch (myADC->gain){
//					case 1: ADC_Ch_InputMode_and_Gain_Config(&ADCA.CH0,ADC_CH_INPUTMODE_SINGLEENDED_gc, ADC_CH_GAIN_1X_gc);
//					case 2: ADC_Ch_InputMode_and_Gain_Config(&ADCA.CH0,ADC_CH_INPUTMODE_SINGLEENDED_gc, ADC_CH_GAIN_2X_gc);
//					case 4: ADC_Ch_InputMode_and_Gain_Config(&ADCA.CH0,ADC_CH_INPUTMODE_SINGLEENDED_gc, ADC_CH_GAIN_4X_gc);
//					case 8: ADC_Ch_InputMode_and_Gain_Config(&ADCA.CH0,ADC_CH_INPUTMODE_SINGLEENDED_gc, ADC_CH_GAIN_8X_gc);
//					case 16: ADC_Ch_InputMode_and_Gain_Config(&ADCA.CH0,ADC_CH_INPUTMODE_SINGLEENDED_gc, ADC_CH_GAIN_16X_gc);
//					case 32: ADC_Ch_InputMode_and_Gain_Config(&ADCA.CH0,ADC_CH_INPUTMODE_SINGLEENDED_gc, ADC_CH_GAIN_32X_gc);
//					case 64: ADC_Ch_InputMode_and_Gain_Config(&ADCA.CH0,ADC_CH_INPUTMODE_SINGLEENDED_gc, ADC_CH_GAIN_64X_gc);
//					}
//				}
//
//				//Select which posative pin
//				switch (myADC->pinPos){
//				case 0:
//					//Select which negative pin (not that the negative pin is internally connected to ground)
//					switch (myADC->pinNeg){
//					case 0: ADC_Ch_InputMux_Config(&ADCA.CH0, ADC_CH_MUXPOS_PIN0_gc, ADC_CH_MUXNEG_PIN0_gc);
//					case 1: ADC_Ch_InputMux_Config(&ADCA.CH0, ADC_CH_MUXPOS_PIN0_gc, ADC_CH_MUXNEG_PIN1_gc);
//					case 2: ADC_Ch_InputMux_Config(&ADCA.CH0, ADC_CH_MUXPOS_PIN0_gc, ADC_CH_MUXNEG_PIN2_gc);
//					case 3: ADC_Ch_InputMux_Config(&ADCA.CH0, ADC_CH_MUXPOS_PIN0_gc, ADC_CH_MUXNEG_PIN3_gc);
//					case 4: ADC_Ch_InputMux_Config(&ADCA.CH0, ADC_CH_MUXPOS_PIN0_gc, ADC_CH_MUXNEG_PIN4_gc);
//					case 5: ADC_Ch_InputMux_Config(&ADCA.CH0, ADC_CH_MUXPOS_PIN0_gc, ADC_CH_MUXNEG_PIN5_gc);
//					case 6: ADC_Ch_InputMux_Config(&ADCA.CH0, ADC_CH_MUXPOS_PIN0_gc, ADC_CH_MUXNEG_PIN6_gc);
//					case 7: ADC_Ch_InputMux_Config(&ADCA.CH0, ADC_CH_MUXPOS_PIN0_gc, ADC_CH_MUXNEG_PIN7_gc);
//					}
//				case 1:
//					//Select which negative pin (not that the negative pin is internally connected to ground)
//					switch (myADC->pinNeg){
//					case 0: ADC_Ch_InputMux_Config(&ADCA.CH0, ADC_CH_MUXPOS_PIN1_gc, ADC_CH_MUXNEG_PIN0_gc);
//					case 1: ADC_Ch_InputMux_Config(&ADCA.CH0, ADC_CH_MUXPOS_PIN1_gc, ADC_CH_MUXNEG_PIN1_gc);
//					case 2: ADC_Ch_InputMux_Config(&ADCA.CH0, ADC_CH_MUXPOS_PIN1_gc, ADC_CH_MUXNEG_PIN2_gc);
//					case 3: ADC_Ch_InputMux_Config(&ADCA.CH0, ADC_CH_MUXPOS_PIN1_gc, ADC_CH_MUXNEG_PIN3_gc);
//					case 4: ADC_Ch_InputMux_Config(&ADCA.CH0, ADC_CH_MUXPOS_PIN1_gc, ADC_CH_MUXNEG_PIN4_gc);
//					case 5: ADC_Ch_InputMux_Config(&ADCA.CH0, ADC_CH_MUXPOS_PIN1_gc, ADC_CH_MUXNEG_PIN5_gc);
//					case 6: ADC_Ch_InputMux_Config(&ADCA.CH0, ADC_CH_MUXPOS_PIN1_gc, ADC_CH_MUXNEG_PIN6_gc);
//					case 7: ADC_Ch_InputMux_Config(&ADCA.CH0, ADC_CH_MUXPOS_PIN1_gc, ADC_CH_MUXNEG_PIN7_gc);
//					}
//				case 2:
//					//Select which negative pin (not that the negative pin is internally connected to ground)
//					switch (myADC->pinNeg){
//					case 0: ADC_Ch_InputMux_Config(&ADCA.CH0, ADC_CH_MUXPOS_PIN2_gc, ADC_CH_MUXNEG_PIN0_gc);
//					case 1: ADC_Ch_InputMux_Config(&ADCA.CH0, ADC_CH_MUXPOS_PIN2_gc, ADC_CH_MUXNEG_PIN1_gc);
//					case 2: ADC_Ch_InputMux_Config(&ADCA.CH0, ADC_CH_MUXPOS_PIN2_gc, ADC_CH_MUXNEG_PIN2_gc);
//					case 3: ADC_Ch_InputMux_Config(&ADCA.CH0, ADC_CH_MUXPOS_PIN2_gc, ADC_CH_MUXNEG_PIN3_gc);
//					case 4: ADC_Ch_InputMux_Config(&ADCA.CH0, ADC_CH_MUXPOS_PIN2_gc, ADC_CH_MUXNEG_PIN4_gc);
//					case 5: ADC_Ch_InputMux_Config(&ADCA.CH0, ADC_CH_MUXPOS_PIN2_gc, ADC_CH_MUXNEG_PIN5_gc);
//					case 6: ADC_Ch_InputMux_Config(&ADCA.CH0, ADC_CH_MUXPOS_PIN2_gc, ADC_CH_MUXNEG_PIN6_gc);
//					case 7: ADC_Ch_InputMux_Config(&ADCA.CH0, ADC_CH_MUXPOS_PIN2_gc, ADC_CH_MUXNEG_PIN7_gc);
//					}
//				case 3:
//					//Select which negative pin (not that the negative pin is internally connected to ground)
//					switch (myADC->pinNeg){
//					case 0: ADC_Ch_InputMux_Config(&ADCA.CH0, ADC_CH_MUXPOS_PIN3_gc, ADC_CH_MUXNEG_PIN0_gc);
//					case 1: ADC_Ch_InputMux_Config(&ADCA.CH0, ADC_CH_MUXPOS_PIN3_gc, ADC_CH_MUXNEG_PIN1_gc);
//					case 2: ADC_Ch_InputMux_Config(&ADCA.CH0, ADC_CH_MUXPOS_PIN3_gc, ADC_CH_MUXNEG_PIN2_gc);
//					case 3: ADC_Ch_InputMux_Config(&ADCA.CH0, ADC_CH_MUXPOS_PIN3_gc, ADC_CH_MUXNEG_PIN3_gc);
//					case 4: ADC_Ch_InputMux_Config(&ADCA.CH0, ADC_CH_MUXPOS_PIN3_gc, ADC_CH_MUXNEG_PIN4_gc);
//					case 5: ADC_Ch_InputMux_Config(&ADCA.CH0, ADC_CH_MUXPOS_PIN3_gc, ADC_CH_MUXNEG_PIN5_gc);
//					case 6: ADC_Ch_InputMux_Config(&ADCA.CH0, ADC_CH_MUXPOS_PIN3_gc, ADC_CH_MUXNEG_PIN6_gc);
//					case 7: ADC_Ch_InputMux_Config(&ADCA.CH0, ADC_CH_MUXPOS_PIN3_gc, ADC_CH_MUXNEG_PIN7_gc);
//					}
//				case 4:
//					//Select which negative pin (not that the negative pin is internally connected to ground)
//					switch (myADC->pinNeg){
//					case 0: ADC_Ch_InputMux_Config(&ADCA.CH0, ADC_CH_MUXPOS_PIN4_gc, ADC_CH_MUXNEG_PIN0_gc);
//					case 1: ADC_Ch_InputMux_Config(&ADCA.CH0, ADC_CH_MUXPOS_PIN4_gc, ADC_CH_MUXNEG_PIN1_gc);
//					case 2: ADC_Ch_InputMux_Config(&ADCA.CH0, ADC_CH_MUXPOS_PIN4_gc, ADC_CH_MUXNEG_PIN2_gc);
//					case 3: ADC_Ch_InputMux_Config(&ADCA.CH0, ADC_CH_MUXPOS_PIN4_gc, ADC_CH_MUXNEG_PIN3_gc);
//					case 4: ADC_Ch_InputMux_Config(&ADCA.CH0, ADC_CH_MUXPOS_PIN4_gc, ADC_CH_MUXNEG_PIN4_gc);
//					case 5: ADC_Ch_InputMux_Config(&ADCA.CH0, ADC_CH_MUXPOS_PIN4_gc, ADC_CH_MUXNEG_PIN5_gc);
//					case 6: ADC_Ch_InputMux_Config(&ADCA.CH0, ADC_CH_MUXPOS_PIN4_gc, ADC_CH_MUXNEG_PIN6_gc);
//					case 7: ADC_Ch_InputMux_Config(&ADCA.CH0, ADC_CH_MUXPOS_PIN4_gc, ADC_CH_MUXNEG_PIN7_gc);
//					}
//				case 5:
//					//Select which negative pin (not that the negative pin is internally connected to ground)
//					switch (myADC->pinNeg){
//					case 0: ADC_Ch_InputMux_Config(&ADCA.CH0, ADC_CH_MUXPOS_PIN5_gc, ADC_CH_MUXNEG_PIN0_gc);
//					case 1: ADC_Ch_InputMux_Config(&ADCA.CH0, ADC_CH_MUXPOS_PIN5_gc, ADC_CH_MUXNEG_PIN1_gc);
//					case 2: ADC_Ch_InputMux_Config(&ADCA.CH0, ADC_CH_MUXPOS_PIN5_gc, ADC_CH_MUXNEG_PIN2_gc);
//					case 3: ADC_Ch_InputMux_Config(&ADCA.CH0, ADC_CH_MUXPOS_PIN5_gc, ADC_CH_MUXNEG_PIN3_gc);
//					case 4: ADC_Ch_InputMux_Config(&ADCA.CH0, ADC_CH_MUXPOS_PIN5_gc, ADC_CH_MUXNEG_PIN4_gc);
//					case 5: ADC_Ch_InputMux_Config(&ADCA.CH0, ADC_CH_MUXPOS_PIN5_gc, ADC_CH_MUXNEG_PIN5_gc);
//					case 6: ADC_Ch_InputMux_Config(&ADCA.CH0, ADC_CH_MUXPOS_PIN5_gc, ADC_CH_MUXNEG_PIN6_gc);
//					case 7: ADC_Ch_InputMux_Config(&ADCA.CH0, ADC_CH_MUXPOS_PIN5_gc, ADC_CH_MUXNEG_PIN7_gc);
//					}
//				case 6:
//					//Select which negative pin (not that the negative pin is internally connected to ground)
//					switch (myADC->pinNeg){
//					case 0: ADC_Ch_InputMux_Config(&ADCA.CH0, ADC_CH_MUXPOS_PIN6_gc, ADC_CH_MUXNEG_PIN0_gc);
//					case 1: ADC_Ch_InputMux_Config(&ADCA.CH0, ADC_CH_MUXPOS_PIN6_gc, ADC_CH_MUXNEG_PIN1_gc);
//					case 2: ADC_Ch_InputMux_Config(&ADCA.CH0, ADC_CH_MUXPOS_PIN6_gc, ADC_CH_MUXNEG_PIN2_gc);
//					case 3: ADC_Ch_InputMux_Config(&ADCA.CH0, ADC_CH_MUXPOS_PIN6_gc, ADC_CH_MUXNEG_PIN3_gc);
//					case 4: ADC_Ch_InputMux_Config(&ADCA.CH0, ADC_CH_MUXPOS_PIN6_gc, ADC_CH_MUXNEG_PIN4_gc);
//					case 5: ADC_Ch_InputMux_Config(&ADCA.CH0, ADC_CH_MUXPOS_PIN6_gc, ADC_CH_MUXNEG_PIN5_gc);
//					case 6: ADC_Ch_InputMux_Config(&ADCA.CH0, ADC_CH_MUXPOS_PIN6_gc, ADC_CH_MUXNEG_PIN6_gc);
//					case 7: ADC_Ch_InputMux_Config(&ADCA.CH0, ADC_CH_MUXPOS_PIN6_gc, ADC_CH_MUXNEG_PIN7_gc);
//					}
//				case 7:
//					//Select which negative pin (not that the negative pin is internally connected to ground)
//					switch (myADC->pinNeg){
//					case 0: ADC_Ch_InputMux_Config(&ADCA.CH0, ADC_CH_MUXPOS_PIN7_gc, ADC_CH_MUXNEG_PIN0_gc);
//					case 1: ADC_Ch_InputMux_Config(&ADCA.CH0, ADC_CH_MUXPOS_PIN7_gc, ADC_CH_MUXNEG_PIN1_gc);
//					case 2: ADC_Ch_InputMux_Config(&ADCA.CH0, ADC_CH_MUXPOS_PIN7_gc, ADC_CH_MUXNEG_PIN2_gc);
//					case 3: ADC_Ch_InputMux_Config(&ADCA.CH0, ADC_CH_MUXPOS_PIN7_gc, ADC_CH_MUXNEG_PIN3_gc);
//					case 4: ADC_Ch_InputMux_Config(&ADCA.CH0, ADC_CH_MUXPOS_PIN7_gc, ADC_CH_MUXNEG_PIN4_gc);
//					case 5: ADC_Ch_InputMux_Config(&ADCA.CH0, ADC_CH_MUXPOS_PIN7_gc, ADC_CH_MUXNEG_PIN5_gc);
//					case 6: ADC_Ch_InputMux_Config(&ADCA.CH0, ADC_CH_MUXPOS_PIN7_gc, ADC_CH_MUXNEG_PIN6_gc);
//					case 7: ADC_Ch_InputMux_Config(&ADCA.CH0, ADC_CH_MUXPOS_PIN7_gc, ADC_CH_MUXNEG_PIN7_gc);
//					}
//				}
//
//
//
//
//			case 1:
//				//set the mode
//				switch (myADC->mode){
//				case 0:
//					//set the gain
//					switch (myADC->gain){
//					case 1: ADC_Ch_InputMode_and_Gain_Config(&ADCA.CH1,ADC_CH_INPUTMODE_SINGLEENDED_gc, ADC_CH_GAIN_1X_gc);
//					case 2: ADC_Ch_InputMode_and_Gain_Config(&ADCA.CH1,ADC_CH_INPUTMODE_SINGLEENDED_gc, ADC_CH_GAIN_2X_gc);
//					case 4: ADC_Ch_InputMode_and_Gain_Config(&ADCA.CH1,ADC_CH_INPUTMODE_SINGLEENDED_gc, ADC_CH_GAIN_4X_gc);
//					case 8: ADC_Ch_InputMode_and_Gain_Config(&ADCA.CH1,ADC_CH_INPUTMODE_SINGLEENDED_gc, ADC_CH_GAIN_8X_gc);
//					case 16: ADC_Ch_InputMode_and_Gain_Config(&ADCA.CH1,ADC_CH_INPUTMODE_SINGLEENDED_gc, ADC_CH_GAIN_16X_gc);
//					case 32: ADC_Ch_InputMode_and_Gain_Config(&ADCA.CH1,ADC_CH_INPUTMODE_SINGLEENDED_gc, ADC_CH_GAIN_32X_gc);
//					case 64: ADC_Ch_InputMode_and_Gain_Config(&ADCA.CH1,ADC_CH_INPUTMODE_SINGLEENDED_gc, ADC_CH_GAIN_64X_gc);
//					}
//				}
//
//				//Select which posative pin
//				switch (myADC->pinPos){
//				case 0:
//					//Select which negative pin (not that the negative pin is internally connected to ground)
//					switch (myADC->pinNeg){
//					case 0: ADC_Ch_InputMux_Config(&ADCA.CH1, ADC_CH_MUXPOS_PIN0_gc, ADC_CH_MUXNEG_PIN0_gc);
//					case 1: ADC_Ch_InputMux_Config(&ADCA.CH1, ADC_CH_MUXPOS_PIN0_gc, ADC_CH_MUXNEG_PIN1_gc);
//					case 2: ADC_Ch_InputMux_Config(&ADCA.CH1, ADC_CH_MUXPOS_PIN0_gc, ADC_CH_MUXNEG_PIN2_gc);
//					case 3: ADC_Ch_InputMux_Config(&ADCA.CH1, ADC_CH_MUXPOS_PIN0_gc, ADC_CH_MUXNEG_PIN3_gc);
//					case 4: ADC_Ch_InputMux_Config(&ADCA.CH1, ADC_CH_MUXPOS_PIN0_gc, ADC_CH_MUXNEG_PIN4_gc);
//					case 5: ADC_Ch_InputMux_Config(&ADCA.CH1, ADC_CH_MUXPOS_PIN0_gc, ADC_CH_MUXNEG_PIN5_gc);
//					case 6: ADC_Ch_InputMux_Config(&ADCA.CH1, ADC_CH_MUXPOS_PIN0_gc, ADC_CH_MUXNEG_PIN6_gc);
//					case 7: ADC_Ch_InputMux_Config(&ADCA.CH1, ADC_CH_MUXPOS_PIN0_gc, ADC_CH_MUXNEG_PIN7_gc);
//					}
//				case 1:
//					//Select which negative pin (not that the negative pin is internally connected to ground)
//					switch (myADC->pinNeg){
//					case 0: ADC_Ch_InputMux_Config(&ADCA.CH1, ADC_CH_MUXPOS_PIN1_gc, ADC_CH_MUXNEG_PIN0_gc);
//					case 1: ADC_Ch_InputMux_Config(&ADCA.CH1, ADC_CH_MUXPOS_PIN1_gc, ADC_CH_MUXNEG_PIN1_gc);
//					case 2: ADC_Ch_InputMux_Config(&ADCA.CH1, ADC_CH_MUXPOS_PIN1_gc, ADC_CH_MUXNEG_PIN2_gc);
//					case 3: ADC_Ch_InputMux_Config(&ADCA.CH1, ADC_CH_MUXPOS_PIN1_gc, ADC_CH_MUXNEG_PIN3_gc);
//					case 4: ADC_Ch_InputMux_Config(&ADCA.CH1, ADC_CH_MUXPOS_PIN1_gc, ADC_CH_MUXNEG_PIN4_gc);
//					case 5: ADC_Ch_InputMux_Config(&ADCA.CH1, ADC_CH_MUXPOS_PIN1_gc, ADC_CH_MUXNEG_PIN5_gc);
//					case 6: ADC_Ch_InputMux_Config(&ADCA.CH1, ADC_CH_MUXPOS_PIN1_gc, ADC_CH_MUXNEG_PIN6_gc);
//					case 7: ADC_Ch_InputMux_Config(&ADCA.CH1, ADC_CH_MUXPOS_PIN1_gc, ADC_CH_MUXNEG_PIN7_gc);
//					}
//				case 2:
//					//Select which negative pin (not that the negative pin is internally connected to ground)
//					switch (myADC->pinNeg){
//					case 0: ADC_Ch_InputMux_Config(&ADCA.CH1, ADC_CH_MUXPOS_PIN2_gc, ADC_CH_MUXNEG_PIN0_gc);
//					case 1: ADC_Ch_InputMux_Config(&ADCA.CH1, ADC_CH_MUXPOS_PIN2_gc, ADC_CH_MUXNEG_PIN1_gc);
//					case 2: ADC_Ch_InputMux_Config(&ADCA.CH1, ADC_CH_MUXPOS_PIN2_gc, ADC_CH_MUXNEG_PIN2_gc);
//					case 3: ADC_Ch_InputMux_Config(&ADCA.CH1, ADC_CH_MUXPOS_PIN2_gc, ADC_CH_MUXNEG_PIN3_gc);
//					case 4: ADC_Ch_InputMux_Config(&ADCA.CH1, ADC_CH_MUXPOS_PIN2_gc, ADC_CH_MUXNEG_PIN4_gc);
//					case 5: ADC_Ch_InputMux_Config(&ADCA.CH1, ADC_CH_MUXPOS_PIN2_gc, ADC_CH_MUXNEG_PIN5_gc);
//					case 6: ADC_Ch_InputMux_Config(&ADCA.CH1, ADC_CH_MUXPOS_PIN2_gc, ADC_CH_MUXNEG_PIN6_gc);
//					case 7: ADC_Ch_InputMux_Config(&ADCA.CH1, ADC_CH_MUXPOS_PIN2_gc, ADC_CH_MUXNEG_PIN7_gc);
//					}
//				case 3:
//					//Select which negative pin (not that the negative pin is internally connected to ground)
//					switch (myADC->pinNeg){
//					case 0: ADC_Ch_InputMux_Config(&ADCA.CH1, ADC_CH_MUXPOS_PIN3_gc, ADC_CH_MUXNEG_PIN0_gc);
//					case 1: ADC_Ch_InputMux_Config(&ADCA.CH1, ADC_CH_MUXPOS_PIN3_gc, ADC_CH_MUXNEG_PIN1_gc);
//					case 2: ADC_Ch_InputMux_Config(&ADCA.CH1, ADC_CH_MUXPOS_PIN3_gc, ADC_CH_MUXNEG_PIN2_gc);
//					case 3: ADC_Ch_InputMux_Config(&ADCA.CH1, ADC_CH_MUXPOS_PIN3_gc, ADC_CH_MUXNEG_PIN3_gc);
//					case 4: ADC_Ch_InputMux_Config(&ADCA.CH1, ADC_CH_MUXPOS_PIN3_gc, ADC_CH_MUXNEG_PIN4_gc);
//					case 5: ADC_Ch_InputMux_Config(&ADCA.CH1, ADC_CH_MUXPOS_PIN3_gc, ADC_CH_MUXNEG_PIN5_gc);
//					case 6: ADC_Ch_InputMux_Config(&ADCA.CH1, ADC_CH_MUXPOS_PIN3_gc, ADC_CH_MUXNEG_PIN6_gc);
//					case 7: ADC_Ch_InputMux_Config(&ADCA.CH1, ADC_CH_MUXPOS_PIN3_gc, ADC_CH_MUXNEG_PIN7_gc);
//					}
//				case 4:
//					//Select which negative pin (not that the negative pin is internally connected to ground)
//					switch (myADC->pinNeg){
//					case 0: ADC_Ch_InputMux_Config(&ADCA.CH1, ADC_CH_MUXPOS_PIN4_gc, ADC_CH_MUXNEG_PIN0_gc);
//					case 1: ADC_Ch_InputMux_Config(&ADCA.CH1, ADC_CH_MUXPOS_PIN4_gc, ADC_CH_MUXNEG_PIN1_gc);
//					case 2: ADC_Ch_InputMux_Config(&ADCA.CH1, ADC_CH_MUXPOS_PIN4_gc, ADC_CH_MUXNEG_PIN2_gc);
//					case 3: ADC_Ch_InputMux_Config(&ADCA.CH1, ADC_CH_MUXPOS_PIN4_gc, ADC_CH_MUXNEG_PIN3_gc);
//					case 4: ADC_Ch_InputMux_Config(&ADCA.CH1, ADC_CH_MUXPOS_PIN4_gc, ADC_CH_MUXNEG_PIN4_gc);
//					case 5: ADC_Ch_InputMux_Config(&ADCA.CH1, ADC_CH_MUXPOS_PIN4_gc, ADC_CH_MUXNEG_PIN5_gc);
//					case 6: ADC_Ch_InputMux_Config(&ADCA.CH1, ADC_CH_MUXPOS_PIN4_gc, ADC_CH_MUXNEG_PIN6_gc);
//					case 7: ADC_Ch_InputMux_Config(&ADCA.CH1, ADC_CH_MUXPOS_PIN4_gc, ADC_CH_MUXNEG_PIN7_gc);
//					}
//				case 5:
//					//Select which negative pin (not that the negative pin is internally connected to ground)
//					switch (myADC->pinNeg){
//					case 0: ADC_Ch_InputMux_Config(&ADCA.CH1, ADC_CH_MUXPOS_PIN5_gc, ADC_CH_MUXNEG_PIN0_gc);
//					case 1: ADC_Ch_InputMux_Config(&ADCA.CH1, ADC_CH_MUXPOS_PIN5_gc, ADC_CH_MUXNEG_PIN1_gc);
//					case 2: ADC_Ch_InputMux_Config(&ADCA.CH1, ADC_CH_MUXPOS_PIN5_gc, ADC_CH_MUXNEG_PIN2_gc);
//					case 3: ADC_Ch_InputMux_Config(&ADCA.CH1, ADC_CH_MUXPOS_PIN5_gc, ADC_CH_MUXNEG_PIN3_gc);
//					case 4: ADC_Ch_InputMux_Config(&ADCA.CH1, ADC_CH_MUXPOS_PIN5_gc, ADC_CH_MUXNEG_PIN4_gc);
//					case 5: ADC_Ch_InputMux_Config(&ADCA.CH1, ADC_CH_MUXPOS_PIN5_gc, ADC_CH_MUXNEG_PIN5_gc);
//					case 6: ADC_Ch_InputMux_Config(&ADCA.CH1, ADC_CH_MUXPOS_PIN5_gc, ADC_CH_MUXNEG_PIN6_gc);
//					case 7: ADC_Ch_InputMux_Config(&ADCA.CH1, ADC_CH_MUXPOS_PIN5_gc, ADC_CH_MUXNEG_PIN7_gc);
//					}
//				case 6:
//					//Select which negative pin (not that the negative pin is internally connected to ground)
//					switch (myADC->pinNeg){
//					case 0: ADC_Ch_InputMux_Config(&ADCA.CH1, ADC_CH_MUXPOS_PIN6_gc, ADC_CH_MUXNEG_PIN0_gc);
//					case 1: ADC_Ch_InputMux_Config(&ADCA.CH1, ADC_CH_MUXPOS_PIN6_gc, ADC_CH_MUXNEG_PIN1_gc);
//					case 2: ADC_Ch_InputMux_Config(&ADCA.CH1, ADC_CH_MUXPOS_PIN6_gc, ADC_CH_MUXNEG_PIN2_gc);
//					case 3: ADC_Ch_InputMux_Config(&ADCA.CH1, ADC_CH_MUXPOS_PIN6_gc, ADC_CH_MUXNEG_PIN3_gc);
//					case 4: ADC_Ch_InputMux_Config(&ADCA.CH1, ADC_CH_MUXPOS_PIN6_gc, ADC_CH_MUXNEG_PIN4_gc);
//					case 5: ADC_Ch_InputMux_Config(&ADCA.CH1, ADC_CH_MUXPOS_PIN6_gc, ADC_CH_MUXNEG_PIN5_gc);
//					case 6: ADC_Ch_InputMux_Config(&ADCA.CH1, ADC_CH_MUXPOS_PIN6_gc, ADC_CH_MUXNEG_PIN6_gc);
//					case 7: ADC_Ch_InputMux_Config(&ADCA.CH1, ADC_CH_MUXPOS_PIN6_gc, ADC_CH_MUXNEG_PIN7_gc);
//					}
//				case 7:
//					//Select which negative pin (not that the negative pin is internally connected to ground)
//					switch (myADC->pinNeg){
//					case 0: ADC_Ch_InputMux_Config(&ADCA.CH1, ADC_CH_MUXPOS_PIN7_gc, ADC_CH_MUXNEG_PIN0_gc);
//					case 1: ADC_Ch_InputMux_Config(&ADCA.CH1, ADC_CH_MUXPOS_PIN7_gc, ADC_CH_MUXNEG_PIN1_gc);
//					case 2: ADC_Ch_InputMux_Config(&ADCA.CH1, ADC_CH_MUXPOS_PIN7_gc, ADC_CH_MUXNEG_PIN2_gc);
//					case 3: ADC_Ch_InputMux_Config(&ADCA.CH1, ADC_CH_MUXPOS_PIN7_gc, ADC_CH_MUXNEG_PIN3_gc);
//					case 4: ADC_Ch_InputMux_Config(&ADCA.CH1, ADC_CH_MUXPOS_PIN7_gc, ADC_CH_MUXNEG_PIN4_gc);
//					case 5: ADC_Ch_InputMux_Config(&ADCA.CH1, ADC_CH_MUXPOS_PIN7_gc, ADC_CH_MUXNEG_PIN5_gc);
//					case 6: ADC_Ch_InputMux_Config(&ADCA.CH1, ADC_CH_MUXPOS_PIN7_gc, ADC_CH_MUXNEG_PIN6_gc);
//					case 7: ADC_Ch_InputMux_Config(&ADCA.CH1, ADC_CH_MUXPOS_PIN7_gc, ADC_CH_MUXNEG_PIN7_gc);
//					}
//				}
//
//
//			case 2:
//				//set the mode
//				switch (myADC->mode){
//				case 0:
//					//set the gain
//					switch (myADC->gain){
//					case 1: ADC_Ch_InputMode_and_Gain_Config(&ADCA.CH2,ADC_CH_INPUTMODE_SINGLEENDED_gc, ADC_CH_GAIN_1X_gc);
//					case 2: ADC_Ch_InputMode_and_Gain_Config(&ADCA.CH2,ADC_CH_INPUTMODE_SINGLEENDED_gc, ADC_CH_GAIN_2X_gc);
//					case 4: ADC_Ch_InputMode_and_Gain_Config(&ADCA.CH2,ADC_CH_INPUTMODE_SINGLEENDED_gc, ADC_CH_GAIN_4X_gc);
//					case 8: ADC_Ch_InputMode_and_Gain_Config(&ADCA.CH2,ADC_CH_INPUTMODE_SINGLEENDED_gc, ADC_CH_GAIN_8X_gc);
//					case 16: ADC_Ch_InputMode_and_Gain_Config(&ADCA.CH2,ADC_CH_INPUTMODE_SINGLEENDED_gc, ADC_CH_GAIN_16X_gc);
//					case 32: ADC_Ch_InputMode_and_Gain_Config(&ADCA.CH2,ADC_CH_INPUTMODE_SINGLEENDED_gc, ADC_CH_GAIN_32X_gc);
//					case 64: ADC_Ch_InputMode_and_Gain_Config(&ADCA.CH2,ADC_CH_INPUTMODE_SINGLEENDED_gc, ADC_CH_GAIN_64X_gc);
//					}
//				}
//
//				//Select which posative pin
//				switch (myADC->pinPos){
//				case 0:
//					//Select which negative pin (not that the negative pin is internally connected to ground)
//					switch (myADC->pinNeg){
//					case 0: ADC_Ch_InputMux_Config(&ADCA.CH2, ADC_CH_MUXPOS_PIN0_gc, ADC_CH_MUXNEG_PIN0_gc);
//					case 1: ADC_Ch_InputMux_Config(&ADCA.CH2, ADC_CH_MUXPOS_PIN0_gc, ADC_CH_MUXNEG_PIN1_gc);
//					case 2: ADC_Ch_InputMux_Config(&ADCA.CH2, ADC_CH_MUXPOS_PIN0_gc, ADC_CH_MUXNEG_PIN2_gc);
//					case 3: ADC_Ch_InputMux_Config(&ADCA.CH2, ADC_CH_MUXPOS_PIN0_gc, ADC_CH_MUXNEG_PIN3_gc);
//					case 4: ADC_Ch_InputMux_Config(&ADCA.CH2, ADC_CH_MUXPOS_PIN0_gc, ADC_CH_MUXNEG_PIN4_gc);
//					case 5: ADC_Ch_InputMux_Config(&ADCA.CH2, ADC_CH_MUXPOS_PIN0_gc, ADC_CH_MUXNEG_PIN5_gc);
//					case 6: ADC_Ch_InputMux_Config(&ADCA.CH2, ADC_CH_MUXPOS_PIN0_gc, ADC_CH_MUXNEG_PIN6_gc);
//					case 7: ADC_Ch_InputMux_Config(&ADCA.CH2, ADC_CH_MUXPOS_PIN0_gc, ADC_CH_MUXNEG_PIN7_gc);
//					}
//				case 1:
//					//Select which negative pin (not that the negative pin is internally connected to ground)
//					switch (myADC->pinNeg){
//					case 0: ADC_Ch_InputMux_Config(&ADCA.CH2, ADC_CH_MUXPOS_PIN1_gc, ADC_CH_MUXNEG_PIN0_gc);
//					case 1: ADC_Ch_InputMux_Config(&ADCA.CH2, ADC_CH_MUXPOS_PIN1_gc, ADC_CH_MUXNEG_PIN1_gc);
//					case 2: ADC_Ch_InputMux_Config(&ADCA.CH2, ADC_CH_MUXPOS_PIN1_gc, ADC_CH_MUXNEG_PIN2_gc);
//					case 3: ADC_Ch_InputMux_Config(&ADCA.CH2, ADC_CH_MUXPOS_PIN1_gc, ADC_CH_MUXNEG_PIN3_gc);
//					case 4: ADC_Ch_InputMux_Config(&ADCA.CH2, ADC_CH_MUXPOS_PIN1_gc, ADC_CH_MUXNEG_PIN4_gc);
//					case 5: ADC_Ch_InputMux_Config(&ADCA.CH2, ADC_CH_MUXPOS_PIN1_gc, ADC_CH_MUXNEG_PIN5_gc);
//					case 6: ADC_Ch_InputMux_Config(&ADCA.CH2, ADC_CH_MUXPOS_PIN1_gc, ADC_CH_MUXNEG_PIN6_gc);
//					case 7: ADC_Ch_InputMux_Config(&ADCA.CH2, ADC_CH_MUXPOS_PIN1_gc, ADC_CH_MUXNEG_PIN7_gc);
//					}
//				case 2:
//					//Select which negative pin (not that the negative pin is internally connected to ground)
//					switch (myADC->pinNeg){
//					case 0: ADC_Ch_InputMux_Config(&ADCA.CH2, ADC_CH_MUXPOS_PIN2_gc, ADC_CH_MUXNEG_PIN0_gc);
//					case 1: ADC_Ch_InputMux_Config(&ADCA.CH2, ADC_CH_MUXPOS_PIN2_gc, ADC_CH_MUXNEG_PIN1_gc);
//					case 2: ADC_Ch_InputMux_Config(&ADCA.CH2, ADC_CH_MUXPOS_PIN2_gc, ADC_CH_MUXNEG_PIN2_gc);
//					case 3: ADC_Ch_InputMux_Config(&ADCA.CH2, ADC_CH_MUXPOS_PIN2_gc, ADC_CH_MUXNEG_PIN3_gc);
//					case 4: ADC_Ch_InputMux_Config(&ADCA.CH2, ADC_CH_MUXPOS_PIN2_gc, ADC_CH_MUXNEG_PIN4_gc);
//					case 5: ADC_Ch_InputMux_Config(&ADCA.CH2, ADC_CH_MUXPOS_PIN2_gc, ADC_CH_MUXNEG_PIN5_gc);
//					case 6: ADC_Ch_InputMux_Config(&ADCA.CH2, ADC_CH_MUXPOS_PIN2_gc, ADC_CH_MUXNEG_PIN6_gc);
//					case 7: ADC_Ch_InputMux_Config(&ADCA.CH2, ADC_CH_MUXPOS_PIN2_gc, ADC_CH_MUXNEG_PIN7_gc);
//					}
//				case 3:
//					//Select which negative pin (not that the negative pin is internally connected to ground)
//					switch (myADC->pinNeg){
//					case 0: ADC_Ch_InputMux_Config(&ADCA.CH2, ADC_CH_MUXPOS_PIN3_gc, ADC_CH_MUXNEG_PIN0_gc);
//					case 1: ADC_Ch_InputMux_Config(&ADCA.CH2, ADC_CH_MUXPOS_PIN3_gc, ADC_CH_MUXNEG_PIN1_gc);
//					case 2: ADC_Ch_InputMux_Config(&ADCA.CH2, ADC_CH_MUXPOS_PIN3_gc, ADC_CH_MUXNEG_PIN2_gc);
//					case 3: ADC_Ch_InputMux_Config(&ADCA.CH2, ADC_CH_MUXPOS_PIN3_gc, ADC_CH_MUXNEG_PIN3_gc);
//					case 4: ADC_Ch_InputMux_Config(&ADCA.CH2, ADC_CH_MUXPOS_PIN3_gc, ADC_CH_MUXNEG_PIN4_gc);
//					case 5: ADC_Ch_InputMux_Config(&ADCA.CH2, ADC_CH_MUXPOS_PIN3_gc, ADC_CH_MUXNEG_PIN5_gc);
//					case 6: ADC_Ch_InputMux_Config(&ADCA.CH2, ADC_CH_MUXPOS_PIN3_gc, ADC_CH_MUXNEG_PIN6_gc);
//					case 7: ADC_Ch_InputMux_Config(&ADCA.CH2, ADC_CH_MUXPOS_PIN3_gc, ADC_CH_MUXNEG_PIN7_gc);
//					}
//				case 4:
//					//Select which negative pin (not that the negative pin is internally connected to ground)
//					switch (myADC->pinNeg){
//					case 0: ADC_Ch_InputMux_Config(&ADCA.CH2, ADC_CH_MUXPOS_PIN4_gc, ADC_CH_MUXNEG_PIN0_gc);
//					case 1: ADC_Ch_InputMux_Config(&ADCA.CH2, ADC_CH_MUXPOS_PIN4_gc, ADC_CH_MUXNEG_PIN1_gc);
//					case 2: ADC_Ch_InputMux_Config(&ADCA.CH2, ADC_CH_MUXPOS_PIN4_gc, ADC_CH_MUXNEG_PIN2_gc);
//					case 3: ADC_Ch_InputMux_Config(&ADCA.CH2, ADC_CH_MUXPOS_PIN4_gc, ADC_CH_MUXNEG_PIN3_gc);
//					case 4: ADC_Ch_InputMux_Config(&ADCA.CH2, ADC_CH_MUXPOS_PIN4_gc, ADC_CH_MUXNEG_PIN4_gc);
//					case 5: ADC_Ch_InputMux_Config(&ADCA.CH2, ADC_CH_MUXPOS_PIN4_gc, ADC_CH_MUXNEG_PIN5_gc);
//					case 6: ADC_Ch_InputMux_Config(&ADCA.CH2, ADC_CH_MUXPOS_PIN4_gc, ADC_CH_MUXNEG_PIN6_gc);
//					case 7: ADC_Ch_InputMux_Config(&ADCA.CH2, ADC_CH_MUXPOS_PIN4_gc, ADC_CH_MUXNEG_PIN7_gc);
//					}
//				case 5:
//					//Select which negative pin (not that the negative pin is internally connected to ground)
//					switch (myADC->pinNeg){
//					case 0: ADC_Ch_InputMux_Config(&ADCA.CH2, ADC_CH_MUXPOS_PIN5_gc, ADC_CH_MUXNEG_PIN0_gc);
//					case 1: ADC_Ch_InputMux_Config(&ADCA.CH2, ADC_CH_MUXPOS_PIN5_gc, ADC_CH_MUXNEG_PIN1_gc);
//					case 2: ADC_Ch_InputMux_Config(&ADCA.CH2, ADC_CH_MUXPOS_PIN5_gc, ADC_CH_MUXNEG_PIN2_gc);
//					case 3: ADC_Ch_InputMux_Config(&ADCA.CH2, ADC_CH_MUXPOS_PIN5_gc, ADC_CH_MUXNEG_PIN3_gc);
//					case 4: ADC_Ch_InputMux_Config(&ADCA.CH2, ADC_CH_MUXPOS_PIN5_gc, ADC_CH_MUXNEG_PIN4_gc);
//					case 5: ADC_Ch_InputMux_Config(&ADCA.CH2, ADC_CH_MUXPOS_PIN5_gc, ADC_CH_MUXNEG_PIN5_gc);
//					case 6: ADC_Ch_InputMux_Config(&ADCA.CH2, ADC_CH_MUXPOS_PIN5_gc, ADC_CH_MUXNEG_PIN6_gc);
//					case 7: ADC_Ch_InputMux_Config(&ADCA.CH2, ADC_CH_MUXPOS_PIN5_gc, ADC_CH_MUXNEG_PIN7_gc);
//					}
//				case 6:
//					//Select which negative pin (not that the negative pin is internally connected to ground)
//					switch (myADC->pinNeg){
//					case 0: ADC_Ch_InputMux_Config(&ADCA.CH2, ADC_CH_MUXPOS_PIN6_gc, ADC_CH_MUXNEG_PIN0_gc);
//					case 1: ADC_Ch_InputMux_Config(&ADCA.CH2, ADC_CH_MUXPOS_PIN6_gc, ADC_CH_MUXNEG_PIN1_gc);
//					case 2: ADC_Ch_InputMux_Config(&ADCA.CH2, ADC_CH_MUXPOS_PIN6_gc, ADC_CH_MUXNEG_PIN2_gc);
//					case 3: ADC_Ch_InputMux_Config(&ADCA.CH2, ADC_CH_MUXPOS_PIN6_gc, ADC_CH_MUXNEG_PIN3_gc);
//					case 4: ADC_Ch_InputMux_Config(&ADCA.CH2, ADC_CH_MUXPOS_PIN6_gc, ADC_CH_MUXNEG_PIN4_gc);
//					case 5: ADC_Ch_InputMux_Config(&ADCA.CH2, ADC_CH_MUXPOS_PIN6_gc, ADC_CH_MUXNEG_PIN5_gc);
//					case 6: ADC_Ch_InputMux_Config(&ADCA.CH2, ADC_CH_MUXPOS_PIN6_gc, ADC_CH_MUXNEG_PIN6_gc);
//					case 7: ADC_Ch_InputMux_Config(&ADCA.CH2, ADC_CH_MUXPOS_PIN6_gc, ADC_CH_MUXNEG_PIN7_gc);
//					}
//				case 7:
//					//Select which negative pin (not that the negative pin is internally connected to ground)
//					switch (myADC->pinNeg){
//					case 0: ADC_Ch_InputMux_Config(&ADCA.CH2, ADC_CH_MUXPOS_PIN7_gc, ADC_CH_MUXNEG_PIN0_gc);
//					case 1: ADC_Ch_InputMux_Config(&ADCA.CH2, ADC_CH_MUXPOS_PIN7_gc, ADC_CH_MUXNEG_PIN1_gc);
//					case 2: ADC_Ch_InputMux_Config(&ADCA.CH2, ADC_CH_MUXPOS_PIN7_gc, ADC_CH_MUXNEG_PIN2_gc);
//					case 3: ADC_Ch_InputMux_Config(&ADCA.CH2, ADC_CH_MUXPOS_PIN7_gc, ADC_CH_MUXNEG_PIN3_gc);
//					case 4: ADC_Ch_InputMux_Config(&ADCA.CH2, ADC_CH_MUXPOS_PIN7_gc, ADC_CH_MUXNEG_PIN4_gc);
//					case 5: ADC_Ch_InputMux_Config(&ADCA.CH2, ADC_CH_MUXPOS_PIN7_gc, ADC_CH_MUXNEG_PIN5_gc);
//					case 6: ADC_Ch_InputMux_Config(&ADCA.CH2, ADC_CH_MUXPOS_PIN7_gc, ADC_CH_MUXNEG_PIN6_gc);
//					case 7: ADC_Ch_InputMux_Config(&ADCA.CH2, ADC_CH_MUXPOS_PIN7_gc, ADC_CH_MUXNEG_PIN7_gc);
//					}
//				}
//
//
//			case 3:
//				//set the mode
//				switch (myADC->mode){
//				case 0:
//					//set the gain
//					switch (myADC->gain){
//					case 1: ADC_Ch_InputMode_and_Gain_Config(&ADCA.CH3,ADC_CH_INPUTMODE_SINGLEENDED_gc, ADC_CH_GAIN_1X_gc);
//					case 2: ADC_Ch_InputMode_and_Gain_Config(&ADCA.CH3,ADC_CH_INPUTMODE_SINGLEENDED_gc, ADC_CH_GAIN_2X_gc);
//					case 4: ADC_Ch_InputMode_and_Gain_Config(&ADCA.CH3,ADC_CH_INPUTMODE_SINGLEENDED_gc, ADC_CH_GAIN_4X_gc);
//					case 8: ADC_Ch_InputMode_and_Gain_Config(&ADCA.CH3,ADC_CH_INPUTMODE_SINGLEENDED_gc, ADC_CH_GAIN_8X_gc);
//					case 16: ADC_Ch_InputMode_and_Gain_Config(&ADCA.CH3,ADC_CH_INPUTMODE_SINGLEENDED_gc, ADC_CH_GAIN_16X_gc);
//					case 32: ADC_Ch_InputMode_and_Gain_Config(&ADCA.CH3,ADC_CH_INPUTMODE_SINGLEENDED_gc, ADC_CH_GAIN_32X_gc);
//					case 64: ADC_Ch_InputMode_and_Gain_Config(&ADCA.CH3,ADC_CH_INPUTMODE_SINGLEENDED_gc, ADC_CH_GAIN_64X_gc);
//					}
//				}
//
//				//Select which posative pin
//				switch (myADC->pinPos){
//				case 0:
//					//Select which negative pin (not that the negative pin is internally connected to ground)
//					switch (myADC->pinNeg){
//					case 0: ADC_Ch_InputMux_Config(&ADCA.CH3, ADC_CH_MUXPOS_PIN0_gc, ADC_CH_MUXNEG_PIN0_gc);
//					case 1: ADC_Ch_InputMux_Config(&ADCA.CH3, ADC_CH_MUXPOS_PIN0_gc, ADC_CH_MUXNEG_PIN1_gc);
//					case 2: ADC_Ch_InputMux_Config(&ADCA.CH3, ADC_CH_MUXPOS_PIN0_gc, ADC_CH_MUXNEG_PIN2_gc);
//					case 3: ADC_Ch_InputMux_Config(&ADCA.CH3, ADC_CH_MUXPOS_PIN0_gc, ADC_CH_MUXNEG_PIN3_gc);
//					case 4: ADC_Ch_InputMux_Config(&ADCA.CH3, ADC_CH_MUXPOS_PIN0_gc, ADC_CH_MUXNEG_PIN4_gc);
//					case 5: ADC_Ch_InputMux_Config(&ADCA.CH3, ADC_CH_MUXPOS_PIN0_gc, ADC_CH_MUXNEG_PIN5_gc);
//					case 6: ADC_Ch_InputMux_Config(&ADCA.CH3, ADC_CH_MUXPOS_PIN0_gc, ADC_CH_MUXNEG_PIN6_gc);
//					case 7: ADC_Ch_InputMux_Config(&ADCA.CH3, ADC_CH_MUXPOS_PIN0_gc, ADC_CH_MUXNEG_PIN7_gc);
//					}
//				case 1:
//					//Select which negative pin (not that the negative pin is internally connected to ground)
//					switch (myADC->pinNeg){
//					case 0: ADC_Ch_InputMux_Config(&ADCA.CH3, ADC_CH_MUXPOS_PIN1_gc, ADC_CH_MUXNEG_PIN0_gc);
//					case 1: ADC_Ch_InputMux_Config(&ADCA.CH3, ADC_CH_MUXPOS_PIN1_gc, ADC_CH_MUXNEG_PIN1_gc);
//					case 2: ADC_Ch_InputMux_Config(&ADCA.CH3, ADC_CH_MUXPOS_PIN1_gc, ADC_CH_MUXNEG_PIN2_gc);
//					case 3: ADC_Ch_InputMux_Config(&ADCA.CH3, ADC_CH_MUXPOS_PIN1_gc, ADC_CH_MUXNEG_PIN3_gc);
//					case 4: ADC_Ch_InputMux_Config(&ADCA.CH3, ADC_CH_MUXPOS_PIN1_gc, ADC_CH_MUXNEG_PIN4_gc);
//					case 5: ADC_Ch_InputMux_Config(&ADCA.CH3, ADC_CH_MUXPOS_PIN1_gc, ADC_CH_MUXNEG_PIN5_gc);
//					case 6: ADC_Ch_InputMux_Config(&ADCA.CH3, ADC_CH_MUXPOS_PIN1_gc, ADC_CH_MUXNEG_PIN6_gc);
//					case 7: ADC_Ch_InputMux_Config(&ADCA.CH3, ADC_CH_MUXPOS_PIN1_gc, ADC_CH_MUXNEG_PIN7_gc);
//					}
//				case 2:
//					//Select which negative pin (not that the negative pin is internally connected to ground)
//					switch (myADC->pinNeg){
//					case 0: ADC_Ch_InputMux_Config(&ADCA.CH3, ADC_CH_MUXPOS_PIN2_gc, ADC_CH_MUXNEG_PIN0_gc);
//					case 1: ADC_Ch_InputMux_Config(&ADCA.CH3, ADC_CH_MUXPOS_PIN2_gc, ADC_CH_MUXNEG_PIN1_gc);
//					case 2: ADC_Ch_InputMux_Config(&ADCA.CH3, ADC_CH_MUXPOS_PIN2_gc, ADC_CH_MUXNEG_PIN2_gc);
//					case 3: ADC_Ch_InputMux_Config(&ADCA.CH3, ADC_CH_MUXPOS_PIN2_gc, ADC_CH_MUXNEG_PIN3_gc);
//					case 4: ADC_Ch_InputMux_Config(&ADCA.CH3, ADC_CH_MUXPOS_PIN2_gc, ADC_CH_MUXNEG_PIN4_gc);
//					case 5: ADC_Ch_InputMux_Config(&ADCA.CH3, ADC_CH_MUXPOS_PIN2_gc, ADC_CH_MUXNEG_PIN5_gc);
//					case 6: ADC_Ch_InputMux_Config(&ADCA.CH3, ADC_CH_MUXPOS_PIN2_gc, ADC_CH_MUXNEG_PIN6_gc);
//					case 7: ADC_Ch_InputMux_Config(&ADCA.CH3, ADC_CH_MUXPOS_PIN2_gc, ADC_CH_MUXNEG_PIN7_gc);
//					}
//				case 3:
//					//Select which negative pin (not that the negative pin is internally connected to ground)
//					switch (myADC->pinNeg){
//					case 0: ADC_Ch_InputMux_Config(&ADCA.CH3, ADC_CH_MUXPOS_PIN3_gc, ADC_CH_MUXNEG_PIN0_gc);
//					case 1: ADC_Ch_InputMux_Config(&ADCA.CH3, ADC_CH_MUXPOS_PIN3_gc, ADC_CH_MUXNEG_PIN1_gc);
//					case 2: ADC_Ch_InputMux_Config(&ADCA.CH3, ADC_CH_MUXPOS_PIN3_gc, ADC_CH_MUXNEG_PIN2_gc);
//					case 3: ADC_Ch_InputMux_Config(&ADCA.CH3, ADC_CH_MUXPOS_PIN3_gc, ADC_CH_MUXNEG_PIN3_gc);
//					case 4: ADC_Ch_InputMux_Config(&ADCA.CH3, ADC_CH_MUXPOS_PIN3_gc, ADC_CH_MUXNEG_PIN4_gc);
//					case 5: ADC_Ch_InputMux_Config(&ADCA.CH3, ADC_CH_MUXPOS_PIN3_gc, ADC_CH_MUXNEG_PIN5_gc);
//					case 6: ADC_Ch_InputMux_Config(&ADCA.CH3, ADC_CH_MUXPOS_PIN3_gc, ADC_CH_MUXNEG_PIN6_gc);
//					case 7: ADC_Ch_InputMux_Config(&ADCA.CH3, ADC_CH_MUXPOS_PIN3_gc, ADC_CH_MUXNEG_PIN7_gc);
//					}
//				case 4:
//					//Select which negative pin (not that the negative pin is internally connected to ground)
//					switch (myADC->pinNeg){
//					case 0: ADC_Ch_InputMux_Config(&ADCA.CH3, ADC_CH_MUXPOS_PIN4_gc, ADC_CH_MUXNEG_PIN0_gc);
//					case 1: ADC_Ch_InputMux_Config(&ADCA.CH3, ADC_CH_MUXPOS_PIN4_gc, ADC_CH_MUXNEG_PIN1_gc);
//					case 2: ADC_Ch_InputMux_Config(&ADCA.CH3, ADC_CH_MUXPOS_PIN4_gc, ADC_CH_MUXNEG_PIN2_gc);
//					case 3: ADC_Ch_InputMux_Config(&ADCA.CH3, ADC_CH_MUXPOS_PIN4_gc, ADC_CH_MUXNEG_PIN3_gc);
//					case 4: ADC_Ch_InputMux_Config(&ADCA.CH3, ADC_CH_MUXPOS_PIN4_gc, ADC_CH_MUXNEG_PIN4_gc);
//					case 5: ADC_Ch_InputMux_Config(&ADCA.CH3, ADC_CH_MUXPOS_PIN4_gc, ADC_CH_MUXNEG_PIN5_gc);
//					case 6: ADC_Ch_InputMux_Config(&ADCA.CH3, ADC_CH_MUXPOS_PIN4_gc, ADC_CH_MUXNEG_PIN6_gc);
//					case 7: ADC_Ch_InputMux_Config(&ADCA.CH3, ADC_CH_MUXPOS_PIN4_gc, ADC_CH_MUXNEG_PIN7_gc);
//					}
//				case 5:
//					//Select which negative pin (not that the negative pin is internally connected to ground)
//					switch (myADC->pinNeg){
//					case 0: ADC_Ch_InputMux_Config(&ADCA.CH3, ADC_CH_MUXPOS_PIN5_gc, ADC_CH_MUXNEG_PIN0_gc);
//					case 1: ADC_Ch_InputMux_Config(&ADCA.CH3, ADC_CH_MUXPOS_PIN5_gc, ADC_CH_MUXNEG_PIN1_gc);
//					case 2: ADC_Ch_InputMux_Config(&ADCA.CH3, ADC_CH_MUXPOS_PIN5_gc, ADC_CH_MUXNEG_PIN2_gc);
//					case 3: ADC_Ch_InputMux_Config(&ADCA.CH3, ADC_CH_MUXPOS_PIN5_gc, ADC_CH_MUXNEG_PIN3_gc);
//					case 4: ADC_Ch_InputMux_Config(&ADCA.CH3, ADC_CH_MUXPOS_PIN5_gc, ADC_CH_MUXNEG_PIN4_gc);
//					case 5: ADC_Ch_InputMux_Config(&ADCA.CH3, ADC_CH_MUXPOS_PIN5_gc, ADC_CH_MUXNEG_PIN5_gc);
//					case 6: ADC_Ch_InputMux_Config(&ADCA.CH3, ADC_CH_MUXPOS_PIN5_gc, ADC_CH_MUXNEG_PIN6_gc);
//					case 7: ADC_Ch_InputMux_Config(&ADCA.CH3, ADC_CH_MUXPOS_PIN5_gc, ADC_CH_MUXNEG_PIN7_gc);
//					}
//				case 6:
//					//Select which negative pin (not that the negative pin is internally connected to ground)
//					switch (myADC->pinNeg){
//					case 0: ADC_Ch_InputMux_Config(&ADCA.CH3, ADC_CH_MUXPOS_PIN6_gc, ADC_CH_MUXNEG_PIN0_gc);
//					case 1: ADC_Ch_InputMux_Config(&ADCA.CH3, ADC_CH_MUXPOS_PIN6_gc, ADC_CH_MUXNEG_PIN1_gc);
//					case 2: ADC_Ch_InputMux_Config(&ADCA.CH3, ADC_CH_MUXPOS_PIN6_gc, ADC_CH_MUXNEG_PIN2_gc);
//					case 3: ADC_Ch_InputMux_Config(&ADCA.CH3, ADC_CH_MUXPOS_PIN6_gc, ADC_CH_MUXNEG_PIN3_gc);
//					case 4: ADC_Ch_InputMux_Config(&ADCA.CH3, ADC_CH_MUXPOS_PIN6_gc, ADC_CH_MUXNEG_PIN4_gc);
//					case 5: ADC_Ch_InputMux_Config(&ADCA.CH3, ADC_CH_MUXPOS_PIN6_gc, ADC_CH_MUXNEG_PIN5_gc);
//					case 6: ADC_Ch_InputMux_Config(&ADCA.CH3, ADC_CH_MUXPOS_PIN6_gc, ADC_CH_MUXNEG_PIN6_gc);
//					case 7: ADC_Ch_InputMux_Config(&ADCA.CH3, ADC_CH_MUXPOS_PIN6_gc, ADC_CH_MUXNEG_PIN7_gc);
//					}
//				case 7:
//					//Select which negative pin (not that the negative pin is internally connected to ground)
//					switch (myADC->pinNeg){
//					case 0: ADC_Ch_InputMux_Config(&ADCA.CH3, ADC_CH_MUXPOS_PIN7_gc, ADC_CH_MUXNEG_PIN0_gc);
//					case 1: ADC_Ch_InputMux_Config(&ADCA.CH3, ADC_CH_MUXPOS_PIN7_gc, ADC_CH_MUXNEG_PIN1_gc);
//					case 2: ADC_Ch_InputMux_Config(&ADCA.CH3, ADC_CH_MUXPOS_PIN7_gc, ADC_CH_MUXNEG_PIN2_gc);
//					case 3: ADC_Ch_InputMux_Config(&ADCA.CH3, ADC_CH_MUXPOS_PIN7_gc, ADC_CH_MUXNEG_PIN3_gc);
//					case 4: ADC_Ch_InputMux_Config(&ADCA.CH3, ADC_CH_MUXPOS_PIN7_gc, ADC_CH_MUXNEG_PIN4_gc);
//					case 5: ADC_Ch_InputMux_Config(&ADCA.CH3, ADC_CH_MUXPOS_PIN7_gc, ADC_CH_MUXNEG_PIN5_gc);
//					case 6: ADC_Ch_InputMux_Config(&ADCA.CH3, ADC_CH_MUXPOS_PIN7_gc, ADC_CH_MUXNEG_PIN6_gc);
//					case 7: ADC_Ch_InputMux_Config(&ADCA.CH3, ADC_CH_MUXPOS_PIN7_gc, ADC_CH_MUXNEG_PIN7_gc);
//					}
//				}
//			}
//
//		    // Before the ADC can be used it must be enabled
//			ADC_Enable(&ADCA);
//
//		    // Wait until the ADC is ready
//		    ADC_Wait_8MHz(&ADCA);
//
//		    // In the while(1) loop, a conversion is started on CH0 and the 8 MSB of the result is
//		    // ouput on the LEDPORT when the conversion is done
//
//			/* Get offset value for ADC B.  */
//		    switch (myADC->isSigned){
//		    case true:
//		    	switch(myADC->chan){
//		    	case 0: myADC->offset = ADC_Offset_Get_Signed(&ADCA, &(ADCB.CH0), myADC->oversampling);
//		    	case 1: myADC->offset = ADC_Offset_Get_Signed(&ADCA, &(ADCB.CH1), myADC->oversampling);
//		    	case 2: myADC->offset = ADC_Offset_Get_Signed(&ADCA, &(ADCB.CH2), myADC->oversampling);
//		    	case 3: myADC->offset = ADC_Offset_Get_Signed(&ADCA, &(ADCB.CH3), myADC->oversampling);
//		    	case 4: myADC->offset = ADC_Offset_Get_Signed(&ADCA, &(ADCB.CH4), myADC->oversampling);
//		    	case 5: myADC->offset = ADC_Offset_Get_Signed(&ADCA, &(ADCB.CH5), myADC->oversampling);
//		    	case 6: myADC->offset = ADC_Offset_Get_Signed(&ADCA, &(ADCB.CH6), myADC->oversampling);
//		    	case 7: myADC->offset = ADC_Offset_Get_Signed(&ADCA, &(ADCB.CH7), myADC->oversampling);
//		    	}
//		    case false:
//		    	switch(myADC->chan){
//		    	case 0: myADC->offset = ADC_Offset_Get_Unsigned(&ADCA, &(ADCB.CH0), myADC->oversampling);
//		    	case 0: myADC->offset = ADC_Offset_Get_Unsigned(&ADCA, &(ADCB.CH1), myADC->oversampling);
//		    	case 2: myADC->offset = ADC_Offset_Get_Unsigned(&ADCA, &(ADCB.CH2), myADC->oversampling);
//		    	case 3: myADC->offset = ADC_Offset_Get_Unsigned(&ADCA, &(ADCB.CH3), myADC->oversampling);
//		    	case 4: myADC->offset = ADC_Offset_Get_Unsigned(&ADCA, &(ADCB.CH4), myADC->oversampling);
//		    	case 5:	myADC->offset = ADC_Offset_Get_Unsigned(&ADCA, &(ADCB.CH5), myADC->oversampling);
//		    	case 6: myADC->offset = ADC_Offset_Get_Unsigned(&ADCA, &(ADCB.CH6), myADC->oversampling);
//		    	case 7: myADC->offset = ADC_Offset_Get_Unsigned(&ADCA, &(ADCB.CH7), myADC->oversampling);
//		    	}
//		    }
//		    //End of ADC A
//
//	case 'B' || 'b':
//
//		/* Move stored calibration values to ADC A */
//		ADC_CalibrationValues_Load(&ADCB);
//
//		//Set the resolution and the signed or unsigned conversion mode
//		ADC_ConvMode_and_Resolution_Config(&ADCB, myADC->isSigned, ADC_RESOLUTION_12BIT_gc);
//
//		//Set the vRef
//		switch (myADC->vRef){
//		case 0: ADC_Reference_Config(&ADCB, ADC_REFSEL_VCC_gc);
//		}
//
//		//Set the PreScaler
//		switch (myADC->preScale){
//		case 4: ADC_Prescaler_Config(&ADCB, ADC_PRESCALER_DIV4_gc);
//		case 8: ADC_Prescaler_Config(&ADCB, ADC_PRESCALER_DIV8_gc);
//		case 16: ADC_Prescaler_Config(&ADCB, ADC_PRESCALER_DIV16_gc);
//		case 32: ADC_Prescaler_Config(&ADCB, ADC_PRESCALER_DIV32_gc);
//		case 64: ADC_Prescaler_Config(&ADCB, ADC_PRESCALER_DIV64_gc);
//		case 128: ADC_Prescaler_Config(&ADCB, ADC_PRESCALER_DIV128_gc);
//		case 256: ADC_Prescaler_Config(&ADCB, ADC_PRESCALER_DIV256_gc);
//		case 512: ADC_Prescaler_Config(&ADCB, ADC_PRESCALER_DIV512_gc);
//		}
//
//		//Set the channel, mode, and gain, and input pins
//		switch (myADC->chan){
//		case 0:
//			//set the mode
//			switch (myADC->mode){
//			case 0:
//				//set the gain
//				switch (myADC->gain){
//				case 1: ADC_Ch_InputMode_and_Gain_Config(&ADCB.CH0,ADC_CH_INPUTMODE_SINGLEENDED_gc, ADC_CH_GAIN_1X_gc);
//				case 2: ADC_Ch_InputMode_and_Gain_Config(&ADCB.CH0,ADC_CH_INPUTMODE_SINGLEENDED_gc, ADC_CH_GAIN_2X_gc);
//				case 4: ADC_Ch_InputMode_and_Gain_Config(&ADCB.CH0,ADC_CH_INPUTMODE_SINGLEENDED_gc, ADC_CH_GAIN_4X_gc);
//				case 8: ADC_Ch_InputMode_and_Gain_Config(&ADCB.CH0,ADC_CH_INPUTMODE_SINGLEENDED_gc, ADC_CH_GAIN_8X_gc);
//				case 16: ADC_Ch_InputMode_and_Gain_Config(&ADCB.CH0,ADC_CH_INPUTMODE_SINGLEENDED_gc, ADC_CH_GAIN_16X_gc);
//				case 32: ADC_Ch_InputMode_and_Gain_Config(&ADCB.CH0,ADC_CH_INPUTMODE_SINGLEENDED_gc, ADC_CH_GAIN_32X_gc);
//				case 64: ADC_Ch_InputMode_and_Gain_Config(&ADCB.CH0,ADC_CH_INPUTMODE_SINGLEENDED_gc, ADC_CH_GAIN_64X_gc);
//				}
//			}
//
//			//Select which posative pin
//			switch (myADC->pinPos){
//			case 0:
//				//Select which negative pin (not that the negative pin is internally connected to ground)
//				switch (myADC->pinNeg){
//				case 0: ADC_Ch_InputMux_Config(&ADCB.CH0, ADC_CH_MUXPOS_PIN0_gc, ADC_CH_MUXNEG_PIN0_gc);
//				case 1: ADC_Ch_InputMux_Config(&ADCB.CH0, ADC_CH_MUXPOS_PIN0_gc, ADC_CH_MUXNEG_PIN1_gc);
//				case 2: ADC_Ch_InputMux_Config(&ADCB.CH0, ADC_CH_MUXPOS_PIN0_gc, ADC_CH_MUXNEG_PIN2_gc);
//				case 3: ADC_Ch_InputMux_Config(&ADCB.CH0, ADC_CH_MUXPOS_PIN0_gc, ADC_CH_MUXNEG_PIN3_gc);
//				case 4: ADC_Ch_InputMux_Config(&ADCB.CH0, ADC_CH_MUXPOS_PIN0_gc, ADC_CH_MUXNEG_PIN4_gc);
//				case 5: ADC_Ch_InputMux_Config(&ADCB.CH0, ADC_CH_MUXPOS_PIN0_gc, ADC_CH_MUXNEG_PIN5_gc);
//				case 6: ADC_Ch_InputMux_Config(&ADCB.CH0, ADC_CH_MUXPOS_PIN0_gc, ADC_CH_MUXNEG_PIN6_gc);
//				case 7: ADC_Ch_InputMux_Config(&ADCB.CH0, ADC_CH_MUXPOS_PIN0_gc, ADC_CH_MUXNEG_PIN7_gc);
//				}
//			case 1:
//				//Select which negative pin (not that the negative pin is internally connected to ground)
//				switch (myADC->pinNeg){
//				case 0: ADC_Ch_InputMux_Config(&ADCB.CH0, ADC_CH_MUXPOS_PIN1_gc, ADC_CH_MUXNEG_PIN0_gc);
//				case 1: ADC_Ch_InputMux_Config(&ADCB.CH0, ADC_CH_MUXPOS_PIN1_gc, ADC_CH_MUXNEG_PIN1_gc);
//				case 2: ADC_Ch_InputMux_Config(&ADCB.CH0, ADC_CH_MUXPOS_PIN1_gc, ADC_CH_MUXNEG_PIN2_gc);
//				case 3: ADC_Ch_InputMux_Config(&ADCB.CH0, ADC_CH_MUXPOS_PIN1_gc, ADC_CH_MUXNEG_PIN3_gc);
//				case 4: ADC_Ch_InputMux_Config(&ADCB.CH0, ADC_CH_MUXPOS_PIN1_gc, ADC_CH_MUXNEG_PIN4_gc);
//				case 5: ADC_Ch_InputMux_Config(&ADCB.CH0, ADC_CH_MUXPOS_PIN1_gc, ADC_CH_MUXNEG_PIN5_gc);
//				case 6: ADC_Ch_InputMux_Config(&ADCB.CH0, ADC_CH_MUXPOS_PIN1_gc, ADC_CH_MUXNEG_PIN6_gc);
//				case 7: ADC_Ch_InputMux_Config(&ADCB.CH0, ADC_CH_MUXPOS_PIN1_gc, ADC_CH_MUXNEG_PIN7_gc);
//				}
//			case 2:
//				//Select which negative pin (not that the negative pin is internally connected to ground)
//				switch (myADC->pinNeg){
//				case 0: ADC_Ch_InputMux_Config(&ADCB.CH0, ADC_CH_MUXPOS_PIN2_gc, ADC_CH_MUXNEG_PIN0_gc);
//				case 1: ADC_Ch_InputMux_Config(&ADCB.CH0, ADC_CH_MUXPOS_PIN2_gc, ADC_CH_MUXNEG_PIN1_gc);
//				case 2: ADC_Ch_InputMux_Config(&ADCB.CH0, ADC_CH_MUXPOS_PIN2_gc, ADC_CH_MUXNEG_PIN2_gc);
//				case 3: ADC_Ch_InputMux_Config(&ADCB.CH0, ADC_CH_MUXPOS_PIN2_gc, ADC_CH_MUXNEG_PIN3_gc);
//				case 4: ADC_Ch_InputMux_Config(&ADCB.CH0, ADC_CH_MUXPOS_PIN2_gc, ADC_CH_MUXNEG_PIN4_gc);
//				case 5: ADC_Ch_InputMux_Config(&ADCB.CH0, ADC_CH_MUXPOS_PIN2_gc, ADC_CH_MUXNEG_PIN5_gc);
//				case 6: ADC_Ch_InputMux_Config(&ADCB.CH0, ADC_CH_MUXPOS_PIN2_gc, ADC_CH_MUXNEG_PIN6_gc);
//				case 7: ADC_Ch_InputMux_Config(&ADCB.CH0, ADC_CH_MUXPOS_PIN2_gc, ADC_CH_MUXNEG_PIN7_gc);
//				}
//			case 3:
//				//Select which negative pin (not that the negative pin is internally connected to ground)
//				switch (myADC->pinNeg){
//				case 0: ADC_Ch_InputMux_Config(&ADCB.CH0, ADC_CH_MUXPOS_PIN3_gc, ADC_CH_MUXNEG_PIN0_gc);
//				case 1: ADC_Ch_InputMux_Config(&ADCB.CH0, ADC_CH_MUXPOS_PIN3_gc, ADC_CH_MUXNEG_PIN1_gc);
//				case 2: ADC_Ch_InputMux_Config(&ADCB.CH0, ADC_CH_MUXPOS_PIN3_gc, ADC_CH_MUXNEG_PIN2_gc);
//				case 3: ADC_Ch_InputMux_Config(&ADCB.CH0, ADC_CH_MUXPOS_PIN3_gc, ADC_CH_MUXNEG_PIN3_gc);
//				case 4: ADC_Ch_InputMux_Config(&ADCB.CH0, ADC_CH_MUXPOS_PIN3_gc, ADC_CH_MUXNEG_PIN4_gc);
//				case 5: ADC_Ch_InputMux_Config(&ADCB.CH0, ADC_CH_MUXPOS_PIN3_gc, ADC_CH_MUXNEG_PIN5_gc);
//				case 6: ADC_Ch_InputMux_Config(&ADCB.CH0, ADC_CH_MUXPOS_PIN3_gc, ADC_CH_MUXNEG_PIN6_gc);
//				case 7: ADC_Ch_InputMux_Config(&ADCB.CH0, ADC_CH_MUXPOS_PIN3_gc, ADC_CH_MUXNEG_PIN7_gc);
//				}
//			case 4:
//				//Select which negative pin (not that the negative pin is internally connected to ground)
//				switch (myADC->pinNeg){
//				case 0: ADC_Ch_InputMux_Config(&ADCB.CH0, ADC_CH_MUXPOS_PIN4_gc, ADC_CH_MUXNEG_PIN0_gc);
//				case 1: ADC_Ch_InputMux_Config(&ADCB.CH0, ADC_CH_MUXPOS_PIN4_gc, ADC_CH_MUXNEG_PIN1_gc);
//				case 2: ADC_Ch_InputMux_Config(&ADCB.CH0, ADC_CH_MUXPOS_PIN4_gc, ADC_CH_MUXNEG_PIN2_gc);
//				case 3: ADC_Ch_InputMux_Config(&ADCB.CH0, ADC_CH_MUXPOS_PIN4_gc, ADC_CH_MUXNEG_PIN3_gc);
//				case 4: ADC_Ch_InputMux_Config(&ADCB.CH0, ADC_CH_MUXPOS_PIN4_gc, ADC_CH_MUXNEG_PIN4_gc);
//				case 5: ADC_Ch_InputMux_Config(&ADCB.CH0, ADC_CH_MUXPOS_PIN4_gc, ADC_CH_MUXNEG_PIN5_gc);
//				case 6: ADC_Ch_InputMux_Config(&ADCB.CH0, ADC_CH_MUXPOS_PIN4_gc, ADC_CH_MUXNEG_PIN6_gc);
//				case 7: ADC_Ch_InputMux_Config(&ADCB.CH0, ADC_CH_MUXPOS_PIN4_gc, ADC_CH_MUXNEG_PIN7_gc);
//				}
//			case 5:
//				//Select which negative pin (not that the negative pin is internally connected to ground)
//				switch (myADC->pinNeg){
//				case 0: ADC_Ch_InputMux_Config(&ADCB.CH0, ADC_CH_MUXPOS_PIN5_gc, ADC_CH_MUXNEG_PIN0_gc);
//				case 1: ADC_Ch_InputMux_Config(&ADCB.CH0, ADC_CH_MUXPOS_PIN5_gc, ADC_CH_MUXNEG_PIN1_gc);
//				case 2: ADC_Ch_InputMux_Config(&ADCB.CH0, ADC_CH_MUXPOS_PIN5_gc, ADC_CH_MUXNEG_PIN2_gc);
//				case 3: ADC_Ch_InputMux_Config(&ADCB.CH0, ADC_CH_MUXPOS_PIN5_gc, ADC_CH_MUXNEG_PIN3_gc);
//				case 4: ADC_Ch_InputMux_Config(&ADCB.CH0, ADC_CH_MUXPOS_PIN5_gc, ADC_CH_MUXNEG_PIN4_gc);
//				case 5: ADC_Ch_InputMux_Config(&ADCB.CH0, ADC_CH_MUXPOS_PIN5_gc, ADC_CH_MUXNEG_PIN5_gc);
//				case 6: ADC_Ch_InputMux_Config(&ADCB.CH0, ADC_CH_MUXPOS_PIN5_gc, ADC_CH_MUXNEG_PIN6_gc);
//				case 7: ADC_Ch_InputMux_Config(&ADCB.CH0, ADC_CH_MUXPOS_PIN5_gc, ADC_CH_MUXNEG_PIN7_gc);
//				}
//			case 6:
//				//Select which negative pin (not that the negative pin is internally connected to ground)
//				switch (myADC->pinNeg){
//				case 0: ADC_Ch_InputMux_Config(&ADCB.CH0, ADC_CH_MUXPOS_PIN6_gc, ADC_CH_MUXNEG_PIN0_gc);
//				case 1: ADC_Ch_InputMux_Config(&ADCB.CH0, ADC_CH_MUXPOS_PIN6_gc, ADC_CH_MUXNEG_PIN1_gc);
//				case 2: ADC_Ch_InputMux_Config(&ADCB.CH0, ADC_CH_MUXPOS_PIN6_gc, ADC_CH_MUXNEG_PIN2_gc);
//				case 3: ADC_Ch_InputMux_Config(&ADCB.CH0, ADC_CH_MUXPOS_PIN6_gc, ADC_CH_MUXNEG_PIN3_gc);
//				case 4: ADC_Ch_InputMux_Config(&ADCB.CH0, ADC_CH_MUXPOS_PIN6_gc, ADC_CH_MUXNEG_PIN4_gc);
//				case 5: ADC_Ch_InputMux_Config(&ADCB.CH0, ADC_CH_MUXPOS_PIN6_gc, ADC_CH_MUXNEG_PIN5_gc);
//				case 6: ADC_Ch_InputMux_Config(&ADCB.CH0, ADC_CH_MUXPOS_PIN6_gc, ADC_CH_MUXNEG_PIN6_gc);
//				case 7: ADC_Ch_InputMux_Config(&ADCB.CH0, ADC_CH_MUXPOS_PIN6_gc, ADC_CH_MUXNEG_PIN7_gc);
//				}
//			case 7:
//				//Select which negative pin (not that the negative pin is internally connected to ground)
//				switch (myADC->pinNeg){
//				case 0: ADC_Ch_InputMux_Config(&ADCB.CH0, ADC_CH_MUXPOS_PIN7_gc, ADC_CH_MUXNEG_PIN0_gc);
//				case 1: ADC_Ch_InputMux_Config(&ADCB.CH0, ADC_CH_MUXPOS_PIN7_gc, ADC_CH_MUXNEG_PIN1_gc);
//				case 2: ADC_Ch_InputMux_Config(&ADCB.CH0, ADC_CH_MUXPOS_PIN7_gc, ADC_CH_MUXNEG_PIN2_gc);
//				case 3: ADC_Ch_InputMux_Config(&ADCB.CH0, ADC_CH_MUXPOS_PIN7_gc, ADC_CH_MUXNEG_PIN3_gc);
//				case 4: ADC_Ch_InputMux_Config(&ADCB.CH0, ADC_CH_MUXPOS_PIN7_gc, ADC_CH_MUXNEG_PIN4_gc);
//				case 5: ADC_Ch_InputMux_Config(&ADCB.CH0, ADC_CH_MUXPOS_PIN7_gc, ADC_CH_MUXNEG_PIN5_gc);
//				case 6: ADC_Ch_InputMux_Config(&ADCB.CH0, ADC_CH_MUXPOS_PIN7_gc, ADC_CH_MUXNEG_PIN6_gc);
//				case 7: ADC_Ch_InputMux_Config(&ADCB.CH0, ADC_CH_MUXPOS_PIN7_gc, ADC_CH_MUXNEG_PIN7_gc);
//				}
//			}
//
//
//
//
//		case 1:
//			//set the mode
//			switch (myADC->mode){
//			case 0:
//				//set the gain
//				switch (myADC->gain){
//				case 1: ADC_Ch_InputMode_and_Gain_Config(&ADCB.CH1,ADC_CH_INPUTMODE_SINGLEENDED_gc, ADC_CH_GAIN_1X_gc);
//				case 2: ADC_Ch_InputMode_and_Gain_Config(&ADCB.CH1,ADC_CH_INPUTMODE_SINGLEENDED_gc, ADC_CH_GAIN_2X_gc);
//				case 4: ADC_Ch_InputMode_and_Gain_Config(&ADCB.CH1,ADC_CH_INPUTMODE_SINGLEENDED_gc, ADC_CH_GAIN_4X_gc);
//				case 8: ADC_Ch_InputMode_and_Gain_Config(&ADCB.CH1,ADC_CH_INPUTMODE_SINGLEENDED_gc, ADC_CH_GAIN_8X_gc);
//				case 16: ADC_Ch_InputMode_and_Gain_Config(&ADCB.CH1,ADC_CH_INPUTMODE_SINGLEENDED_gc, ADC_CH_GAIN_16X_gc);
//				case 32: ADC_Ch_InputMode_and_Gain_Config(&ADCB.CH1,ADC_CH_INPUTMODE_SINGLEENDED_gc, ADC_CH_GAIN_32X_gc);
//				case 64: ADC_Ch_InputMode_and_Gain_Config(&ADCB.CH1,ADC_CH_INPUTMODE_SINGLEENDED_gc, ADC_CH_GAIN_64X_gc);
//				}
//			}
//
//			//Select which posative pin
//			switch (myADC->pinPos){
//			case 0:
//				//Select which negative pin (not that the negative pin is internally connected to ground)
//				switch (myADC->pinNeg){
//				case 0: ADC_Ch_InputMux_Config(&ADCB.CH1, ADC_CH_MUXPOS_PIN0_gc, ADC_CH_MUXNEG_PIN0_gc);
//				case 1: ADC_Ch_InputMux_Config(&ADCB.CH1, ADC_CH_MUXPOS_PIN0_gc, ADC_CH_MUXNEG_PIN1_gc);
//				case 2: ADC_Ch_InputMux_Config(&ADCB.CH1, ADC_CH_MUXPOS_PIN0_gc, ADC_CH_MUXNEG_PIN2_gc);
//				case 3: ADC_Ch_InputMux_Config(&ADCB.CH1, ADC_CH_MUXPOS_PIN0_gc, ADC_CH_MUXNEG_PIN3_gc);
//				case 4: ADC_Ch_InputMux_Config(&ADCB.CH1, ADC_CH_MUXPOS_PIN0_gc, ADC_CH_MUXNEG_PIN4_gc);
//				case 5: ADC_Ch_InputMux_Config(&ADCB.CH1, ADC_CH_MUXPOS_PIN0_gc, ADC_CH_MUXNEG_PIN5_gc);
//				case 6: ADC_Ch_InputMux_Config(&ADCB.CH1, ADC_CH_MUXPOS_PIN0_gc, ADC_CH_MUXNEG_PIN6_gc);
//				case 7: ADC_Ch_InputMux_Config(&ADCB.CH1, ADC_CH_MUXPOS_PIN0_gc, ADC_CH_MUXNEG_PIN7_gc);
//				}
//			case 1:
//				//Select which negative pin (not that the negative pin is internally connected to ground)
//				switch (myADC->pinNeg){
//				case 0: ADC_Ch_InputMux_Config(&ADCB.CH1, ADC_CH_MUXPOS_PIN1_gc, ADC_CH_MUXNEG_PIN0_gc);
//				case 1: ADC_Ch_InputMux_Config(&ADCB.CH1, ADC_CH_MUXPOS_PIN1_gc, ADC_CH_MUXNEG_PIN1_gc);
//				case 2: ADC_Ch_InputMux_Config(&ADCB.CH1, ADC_CH_MUXPOS_PIN1_gc, ADC_CH_MUXNEG_PIN2_gc);
//				case 3: ADC_Ch_InputMux_Config(&ADCB.CH1, ADC_CH_MUXPOS_PIN1_gc, ADC_CH_MUXNEG_PIN3_gc);
//				case 4: ADC_Ch_InputMux_Config(&ADCB.CH1, ADC_CH_MUXPOS_PIN1_gc, ADC_CH_MUXNEG_PIN4_gc);
//				case 5: ADC_Ch_InputMux_Config(&ADCB.CH1, ADC_CH_MUXPOS_PIN1_gc, ADC_CH_MUXNEG_PIN5_gc);
//				case 6: ADC_Ch_InputMux_Config(&ADCB.CH1, ADC_CH_MUXPOS_PIN1_gc, ADC_CH_MUXNEG_PIN6_gc);
//				case 7: ADC_Ch_InputMux_Config(&ADCB.CH1, ADC_CH_MUXPOS_PIN1_gc, ADC_CH_MUXNEG_PIN7_gc);
//				}
//			case 2:
//				//Select which negative pin (not that the negative pin is internally connected to ground)
//				switch (myADC->pinNeg){
//				case 0: ADC_Ch_InputMux_Config(&ADCB.CH1, ADC_CH_MUXPOS_PIN2_gc, ADC_CH_MUXNEG_PIN0_gc);
//				case 1: ADC_Ch_InputMux_Config(&ADCB.CH1, ADC_CH_MUXPOS_PIN2_gc, ADC_CH_MUXNEG_PIN1_gc);
//				case 2: ADC_Ch_InputMux_Config(&ADCB.CH1, ADC_CH_MUXPOS_PIN2_gc, ADC_CH_MUXNEG_PIN2_gc);
//				case 3: ADC_Ch_InputMux_Config(&ADCB.CH1, ADC_CH_MUXPOS_PIN2_gc, ADC_CH_MUXNEG_PIN3_gc);
//				case 4: ADC_Ch_InputMux_Config(&ADCB.CH1, ADC_CH_MUXPOS_PIN2_gc, ADC_CH_MUXNEG_PIN4_gc);
//				case 5: ADC_Ch_InputMux_Config(&ADCB.CH1, ADC_CH_MUXPOS_PIN2_gc, ADC_CH_MUXNEG_PIN5_gc);
//				case 6: ADC_Ch_InputMux_Config(&ADCB.CH1, ADC_CH_MUXPOS_PIN2_gc, ADC_CH_MUXNEG_PIN6_gc);
//				case 7: ADC_Ch_InputMux_Config(&ADCB.CH1, ADC_CH_MUXPOS_PIN2_gc, ADC_CH_MUXNEG_PIN7_gc);
//				}
//			case 3:
//				//Select which negative pin (not that the negative pin is internally connected to ground)
//				switch (myADC->pinNeg){
//				case 0: ADC_Ch_InputMux_Config(&ADCB.CH1, ADC_CH_MUXPOS_PIN3_gc, ADC_CH_MUXNEG_PIN0_gc);
//				case 1: ADC_Ch_InputMux_Config(&ADCB.CH1, ADC_CH_MUXPOS_PIN3_gc, ADC_CH_MUXNEG_PIN1_gc);
//				case 2: ADC_Ch_InputMux_Config(&ADCB.CH1, ADC_CH_MUXPOS_PIN3_gc, ADC_CH_MUXNEG_PIN2_gc);
//				case 3: ADC_Ch_InputMux_Config(&ADCB.CH1, ADC_CH_MUXPOS_PIN3_gc, ADC_CH_MUXNEG_PIN3_gc);
//				case 4: ADC_Ch_InputMux_Config(&ADCB.CH1, ADC_CH_MUXPOS_PIN3_gc, ADC_CH_MUXNEG_PIN4_gc);
//				case 5: ADC_Ch_InputMux_Config(&ADCB.CH1, ADC_CH_MUXPOS_PIN3_gc, ADC_CH_MUXNEG_PIN5_gc);
//				case 6: ADC_Ch_InputMux_Config(&ADCB.CH1, ADC_CH_MUXPOS_PIN3_gc, ADC_CH_MUXNEG_PIN6_gc);
//				case 7: ADC_Ch_InputMux_Config(&ADCB.CH1, ADC_CH_MUXPOS_PIN3_gc, ADC_CH_MUXNEG_PIN7_gc);
//				}
//			case 4:
//				//Select which negative pin (not that the negative pin is internally connected to ground)
//				switch (myADC->pinNeg){
//				case 0: ADC_Ch_InputMux_Config(&ADCB.CH1, ADC_CH_MUXPOS_PIN4_gc, ADC_CH_MUXNEG_PIN0_gc);
//				case 1: ADC_Ch_InputMux_Config(&ADCB.CH1, ADC_CH_MUXPOS_PIN4_gc, ADC_CH_MUXNEG_PIN1_gc);
//				case 2: ADC_Ch_InputMux_Config(&ADCB.CH1, ADC_CH_MUXPOS_PIN4_gc, ADC_CH_MUXNEG_PIN2_gc);
//				case 3: ADC_Ch_InputMux_Config(&ADCB.CH1, ADC_CH_MUXPOS_PIN4_gc, ADC_CH_MUXNEG_PIN3_gc);
//				case 4: ADC_Ch_InputMux_Config(&ADCB.CH1, ADC_CH_MUXPOS_PIN4_gc, ADC_CH_MUXNEG_PIN4_gc);
//				case 5: ADC_Ch_InputMux_Config(&ADCB.CH1, ADC_CH_MUXPOS_PIN4_gc, ADC_CH_MUXNEG_PIN5_gc);
//				case 6: ADC_Ch_InputMux_Config(&ADCB.CH1, ADC_CH_MUXPOS_PIN4_gc, ADC_CH_MUXNEG_PIN6_gc);
//				case 7: ADC_Ch_InputMux_Config(&ADCB.CH1, ADC_CH_MUXPOS_PIN4_gc, ADC_CH_MUXNEG_PIN7_gc);
//				}
//			case 5:
//				//Select which negative pin (not that the negative pin is internally connected to ground)
//				switch (myADC->pinNeg){
//				case 0: ADC_Ch_InputMux_Config(&ADCB.CH1, ADC_CH_MUXPOS_PIN5_gc, ADC_CH_MUXNEG_PIN0_gc);
//				case 1: ADC_Ch_InputMux_Config(&ADCB.CH1, ADC_CH_MUXPOS_PIN5_gc, ADC_CH_MUXNEG_PIN1_gc);
//				case 2: ADC_Ch_InputMux_Config(&ADCB.CH1, ADC_CH_MUXPOS_PIN5_gc, ADC_CH_MUXNEG_PIN2_gc);
//				case 3: ADC_Ch_InputMux_Config(&ADCB.CH1, ADC_CH_MUXPOS_PIN5_gc, ADC_CH_MUXNEG_PIN3_gc);
//				case 4: ADC_Ch_InputMux_Config(&ADCB.CH1, ADC_CH_MUXPOS_PIN5_gc, ADC_CH_MUXNEG_PIN4_gc);
//				case 5: ADC_Ch_InputMux_Config(&ADCB.CH1, ADC_CH_MUXPOS_PIN5_gc, ADC_CH_MUXNEG_PIN5_gc);
//				case 6: ADC_Ch_InputMux_Config(&ADCB.CH1, ADC_CH_MUXPOS_PIN5_gc, ADC_CH_MUXNEG_PIN6_gc);
//				case 7: ADC_Ch_InputMux_Config(&ADCB.CH1, ADC_CH_MUXPOS_PIN5_gc, ADC_CH_MUXNEG_PIN7_gc);
//				}
//			case 6:
//				//Select which negative pin (not that the negative pin is internally connected to ground)
//				switch (myADC->pinNeg){
//				case 0: ADC_Ch_InputMux_Config(&ADCB.CH1, ADC_CH_MUXPOS_PIN6_gc, ADC_CH_MUXNEG_PIN0_gc);
//				case 1: ADC_Ch_InputMux_Config(&ADCB.CH1, ADC_CH_MUXPOS_PIN6_gc, ADC_CH_MUXNEG_PIN1_gc);
//				case 2: ADC_Ch_InputMux_Config(&ADCB.CH1, ADC_CH_MUXPOS_PIN6_gc, ADC_CH_MUXNEG_PIN2_gc);
//				case 3: ADC_Ch_InputMux_Config(&ADCB.CH1, ADC_CH_MUXPOS_PIN6_gc, ADC_CH_MUXNEG_PIN3_gc);
//				case 4: ADC_Ch_InputMux_Config(&ADCB.CH1, ADC_CH_MUXPOS_PIN6_gc, ADC_CH_MUXNEG_PIN4_gc);
//				case 5: ADC_Ch_InputMux_Config(&ADCB.CH1, ADC_CH_MUXPOS_PIN6_gc, ADC_CH_MUXNEG_PIN5_gc);
//				case 6: ADC_Ch_InputMux_Config(&ADCB.CH1, ADC_CH_MUXPOS_PIN6_gc, ADC_CH_MUXNEG_PIN6_gc);
//				case 7: ADC_Ch_InputMux_Config(&ADCB.CH1, ADC_CH_MUXPOS_PIN6_gc, ADC_CH_MUXNEG_PIN7_gc);
//				}
//			case 7:
//				//Select which negative pin (not that the negative pin is internally connected to ground)
//				switch (myADC->pinNeg){
//				case 0: ADC_Ch_InputMux_Config(&ADCB.CH1, ADC_CH_MUXPOS_PIN7_gc, ADC_CH_MUXNEG_PIN0_gc);
//				case 1: ADC_Ch_InputMux_Config(&ADCB.CH1, ADC_CH_MUXPOS_PIN7_gc, ADC_CH_MUXNEG_PIN1_gc);
//				case 2: ADC_Ch_InputMux_Config(&ADCB.CH1, ADC_CH_MUXPOS_PIN7_gc, ADC_CH_MUXNEG_PIN2_gc);
//				case 3: ADC_Ch_InputMux_Config(&ADCB.CH1, ADC_CH_MUXPOS_PIN7_gc, ADC_CH_MUXNEG_PIN3_gc);
//				case 4: ADC_Ch_InputMux_Config(&ADCB.CH1, ADC_CH_MUXPOS_PIN7_gc, ADC_CH_MUXNEG_PIN4_gc);
//				case 5: ADC_Ch_InputMux_Config(&ADCB.CH1, ADC_CH_MUXPOS_PIN7_gc, ADC_CH_MUXNEG_PIN5_gc);
//				case 6: ADC_Ch_InputMux_Config(&ADCB.CH1, ADC_CH_MUXPOS_PIN7_gc, ADC_CH_MUXNEG_PIN6_gc);
//				case 7: ADC_Ch_InputMux_Config(&ADCB.CH1, ADC_CH_MUXPOS_PIN7_gc, ADC_CH_MUXNEG_PIN7_gc);
//				}
//			}
//
//
//		case 2:
//			//set the mode
//			switch (myADC->mode){
//			case 0:
//				//set the gain
//				switch (myADC->gain){
//				case 1: ADC_Ch_InputMode_and_Gain_Config(&ADCB.CH2,ADC_CH_INPUTMODE_SINGLEENDED_gc, ADC_CH_GAIN_1X_gc);
//				case 2: ADC_Ch_InputMode_and_Gain_Config(&ADCB.CH2,ADC_CH_INPUTMODE_SINGLEENDED_gc, ADC_CH_GAIN_2X_gc);
//				case 4: ADC_Ch_InputMode_and_Gain_Config(&ADCB.CH2,ADC_CH_INPUTMODE_SINGLEENDED_gc, ADC_CH_GAIN_4X_gc);
//				case 8: ADC_Ch_InputMode_and_Gain_Config(&ADCB.CH2,ADC_CH_INPUTMODE_SINGLEENDED_gc, ADC_CH_GAIN_8X_gc);
//				case 16: ADC_Ch_InputMode_and_Gain_Config(&ADCB.CH2,ADC_CH_INPUTMODE_SINGLEENDED_gc, ADC_CH_GAIN_16X_gc);
//				case 32: ADC_Ch_InputMode_and_Gain_Config(&ADCB.CH2,ADC_CH_INPUTMODE_SINGLEENDED_gc, ADC_CH_GAIN_32X_gc);
//				case 64: ADC_Ch_InputMode_and_Gain_Config(&ADCB.CH2,ADC_CH_INPUTMODE_SINGLEENDED_gc, ADC_CH_GAIN_64X_gc);
//				}
//			}
//
//			//Select which posative pin
//			switch (myADC->pinPos){
//			case 0:
//				//Select which negative pin (not that the negative pin is internally connected to ground)
//				switch (myADC->pinNeg){
//				case 0: ADC_Ch_InputMux_Config(&ADCB.CH2, ADC_CH_MUXPOS_PIN0_gc, ADC_CH_MUXNEG_PIN0_gc);
//				case 1: ADC_Ch_InputMux_Config(&ADCB.CH2, ADC_CH_MUXPOS_PIN0_gc, ADC_CH_MUXNEG_PIN1_gc);
//				case 2: ADC_Ch_InputMux_Config(&ADCB.CH2, ADC_CH_MUXPOS_PIN0_gc, ADC_CH_MUXNEG_PIN2_gc);
//				case 3: ADC_Ch_InputMux_Config(&ADCB.CH2, ADC_CH_MUXPOS_PIN0_gc, ADC_CH_MUXNEG_PIN3_gc);
//				case 4: ADC_Ch_InputMux_Config(&ADCB.CH2, ADC_CH_MUXPOS_PIN0_gc, ADC_CH_MUXNEG_PIN4_gc);
//				case 5: ADC_Ch_InputMux_Config(&ADCB.CH2, ADC_CH_MUXPOS_PIN0_gc, ADC_CH_MUXNEG_PIN5_gc);
//				case 6: ADC_Ch_InputMux_Config(&ADCB.CH2, ADC_CH_MUXPOS_PIN0_gc, ADC_CH_MUXNEG_PIN6_gc);
//				case 7: ADC_Ch_InputMux_Config(&ADCB.CH2, ADC_CH_MUXPOS_PIN0_gc, ADC_CH_MUXNEG_PIN7_gc);
//				}
//			case 1:
//				//Select which negative pin (not that the negative pin is internally connected to ground)
//				switch (myADC->pinNeg){
//				case 0: ADC_Ch_InputMux_Config(&ADCB.CH2, ADC_CH_MUXPOS_PIN1_gc, ADC_CH_MUXNEG_PIN0_gc);
//				case 1: ADC_Ch_InputMux_Config(&ADCB.CH2, ADC_CH_MUXPOS_PIN1_gc, ADC_CH_MUXNEG_PIN1_gc);
//				case 2: ADC_Ch_InputMux_Config(&ADCB.CH2, ADC_CH_MUXPOS_PIN1_gc, ADC_CH_MUXNEG_PIN2_gc);
//				case 3: ADC_Ch_InputMux_Config(&ADCB.CH2, ADC_CH_MUXPOS_PIN1_gc, ADC_CH_MUXNEG_PIN3_gc);
//				case 4: ADC_Ch_InputMux_Config(&ADCB.CH2, ADC_CH_MUXPOS_PIN1_gc, ADC_CH_MUXNEG_PIN4_gc);
//				case 5: ADC_Ch_InputMux_Config(&ADCB.CH2, ADC_CH_MUXPOS_PIN1_gc, ADC_CH_MUXNEG_PIN5_gc);
//				case 6: ADC_Ch_InputMux_Config(&ADCB.CH2, ADC_CH_MUXPOS_PIN1_gc, ADC_CH_MUXNEG_PIN6_gc);
//				case 7: ADC_Ch_InputMux_Config(&ADCB.CH2, ADC_CH_MUXPOS_PIN1_gc, ADC_CH_MUXNEG_PIN7_gc);
//				}
//			case 2:
//				//Select which negative pin (not that the negative pin is internally connected to ground)
//				switch (myADC->pinNeg){
//				case 0: ADC_Ch_InputMux_Config(&ADCB.CH2, ADC_CH_MUXPOS_PIN2_gc, ADC_CH_MUXNEG_PIN0_gc);
//				case 1: ADC_Ch_InputMux_Config(&ADCB.CH2, ADC_CH_MUXPOS_PIN2_gc, ADC_CH_MUXNEG_PIN1_gc);
//				case 2: ADC_Ch_InputMux_Config(&ADCB.CH2, ADC_CH_MUXPOS_PIN2_gc, ADC_CH_MUXNEG_PIN2_gc);
//				case 3: ADC_Ch_InputMux_Config(&ADCB.CH2, ADC_CH_MUXPOS_PIN2_gc, ADC_CH_MUXNEG_PIN3_gc);
//				case 4: ADC_Ch_InputMux_Config(&ADCB.CH2, ADC_CH_MUXPOS_PIN2_gc, ADC_CH_MUXNEG_PIN4_gc);
//				case 5: ADC_Ch_InputMux_Config(&ADCB.CH2, ADC_CH_MUXPOS_PIN2_gc, ADC_CH_MUXNEG_PIN5_gc);
//				case 6: ADC_Ch_InputMux_Config(&ADCB.CH2, ADC_CH_MUXPOS_PIN2_gc, ADC_CH_MUXNEG_PIN6_gc);
//				case 7: ADC_Ch_InputMux_Config(&ADCB.CH2, ADC_CH_MUXPOS_PIN2_gc, ADC_CH_MUXNEG_PIN7_gc);
//				}
//			case 3:
//				//Select which negative pin (not that the negative pin is internally connected to ground)
//				switch (myADC->pinNeg){
//				case 0: ADC_Ch_InputMux_Config(&ADCB.CH2, ADC_CH_MUXPOS_PIN3_gc, ADC_CH_MUXNEG_PIN0_gc);
//				case 1: ADC_Ch_InputMux_Config(&ADCB.CH2, ADC_CH_MUXPOS_PIN3_gc, ADC_CH_MUXNEG_PIN1_gc);
//				case 2: ADC_Ch_InputMux_Config(&ADCB.CH2, ADC_CH_MUXPOS_PIN3_gc, ADC_CH_MUXNEG_PIN2_gc);
//				case 3: ADC_Ch_InputMux_Config(&ADCB.CH2, ADC_CH_MUXPOS_PIN3_gc, ADC_CH_MUXNEG_PIN3_gc);
//				case 4: ADC_Ch_InputMux_Config(&ADCB.CH2, ADC_CH_MUXPOS_PIN3_gc, ADC_CH_MUXNEG_PIN4_gc);
//				case 5: ADC_Ch_InputMux_Config(&ADCB.CH2, ADC_CH_MUXPOS_PIN3_gc, ADC_CH_MUXNEG_PIN5_gc);
//				case 6: ADC_Ch_InputMux_Config(&ADCB.CH2, ADC_CH_MUXPOS_PIN3_gc, ADC_CH_MUXNEG_PIN6_gc);
//				case 7: ADC_Ch_InputMux_Config(&ADCB.CH2, ADC_CH_MUXPOS_PIN3_gc, ADC_CH_MUXNEG_PIN7_gc);
//				}
//			case 4:
//				//Select which negative pin (not that the negative pin is internally connected to ground)
//				switch (myADC->pinNeg){
//				case 0: ADC_Ch_InputMux_Config(&ADCB.CH2, ADC_CH_MUXPOS_PIN4_gc, ADC_CH_MUXNEG_PIN0_gc);
//				case 1: ADC_Ch_InputMux_Config(&ADCB.CH2, ADC_CH_MUXPOS_PIN4_gc, ADC_CH_MUXNEG_PIN1_gc);
//				case 2: ADC_Ch_InputMux_Config(&ADCB.CH2, ADC_CH_MUXPOS_PIN4_gc, ADC_CH_MUXNEG_PIN2_gc);
//				case 3: ADC_Ch_InputMux_Config(&ADCB.CH2, ADC_CH_MUXPOS_PIN4_gc, ADC_CH_MUXNEG_PIN3_gc);
//				case 4: ADC_Ch_InputMux_Config(&ADCB.CH2, ADC_CH_MUXPOS_PIN4_gc, ADC_CH_MUXNEG_PIN4_gc);
//				case 5: ADC_Ch_InputMux_Config(&ADCB.CH2, ADC_CH_MUXPOS_PIN4_gc, ADC_CH_MUXNEG_PIN5_gc);
//				case 6: ADC_Ch_InputMux_Config(&ADCB.CH2, ADC_CH_MUXPOS_PIN4_gc, ADC_CH_MUXNEG_PIN6_gc);
//				case 7: ADC_Ch_InputMux_Config(&ADCB.CH2, ADC_CH_MUXPOS_PIN4_gc, ADC_CH_MUXNEG_PIN7_gc);
//				}
//			case 5:
//				//Select which negative pin (not that the negative pin is internally connected to ground)
//				switch (myADC->pinNeg){
//				case 0: ADC_Ch_InputMux_Config(&ADCB.CH2, ADC_CH_MUXPOS_PIN5_gc, ADC_CH_MUXNEG_PIN0_gc);
//				case 1: ADC_Ch_InputMux_Config(&ADCB.CH2, ADC_CH_MUXPOS_PIN5_gc, ADC_CH_MUXNEG_PIN1_gc);
//				case 2: ADC_Ch_InputMux_Config(&ADCB.CH2, ADC_CH_MUXPOS_PIN5_gc, ADC_CH_MUXNEG_PIN2_gc);
//				case 3: ADC_Ch_InputMux_Config(&ADCB.CH2, ADC_CH_MUXPOS_PIN5_gc, ADC_CH_MUXNEG_PIN3_gc);
//				case 4: ADC_Ch_InputMux_Config(&ADCB.CH2, ADC_CH_MUXPOS_PIN5_gc, ADC_CH_MUXNEG_PIN4_gc);
//				case 5: ADC_Ch_InputMux_Config(&ADCB.CH2, ADC_CH_MUXPOS_PIN5_gc, ADC_CH_MUXNEG_PIN5_gc);
//				case 6: ADC_Ch_InputMux_Config(&ADCB.CH2, ADC_CH_MUXPOS_PIN5_gc, ADC_CH_MUXNEG_PIN6_gc);
//				case 7: ADC_Ch_InputMux_Config(&ADCB.CH2, ADC_CH_MUXPOS_PIN5_gc, ADC_CH_MUXNEG_PIN7_gc);
//				}
//			case 6:
//				//Select which negative pin (not that the negative pin is internally connected to ground)
//				switch (myADC->pinNeg){
//				case 0: ADC_Ch_InputMux_Config(&ADCB.CH2, ADC_CH_MUXPOS_PIN6_gc, ADC_CH_MUXNEG_PIN0_gc);
//				case 1: ADC_Ch_InputMux_Config(&ADCB.CH2, ADC_CH_MUXPOS_PIN6_gc, ADC_CH_MUXNEG_PIN1_gc);
//				case 2: ADC_Ch_InputMux_Config(&ADCB.CH2, ADC_CH_MUXPOS_PIN6_gc, ADC_CH_MUXNEG_PIN2_gc);
//				case 3: ADC_Ch_InputMux_Config(&ADCB.CH2, ADC_CH_MUXPOS_PIN6_gc, ADC_CH_MUXNEG_PIN3_gc);
//				case 4: ADC_Ch_InputMux_Config(&ADCB.CH2, ADC_CH_MUXPOS_PIN6_gc, ADC_CH_MUXNEG_PIN4_gc);
//				case 5: ADC_Ch_InputMux_Config(&ADCB.CH2, ADC_CH_MUXPOS_PIN6_gc, ADC_CH_MUXNEG_PIN5_gc);
//				case 6: ADC_Ch_InputMux_Config(&ADCB.CH2, ADC_CH_MUXPOS_PIN6_gc, ADC_CH_MUXNEG_PIN6_gc);
//				case 7: ADC_Ch_InputMux_Config(&ADCB.CH2, ADC_CH_MUXPOS_PIN6_gc, ADC_CH_MUXNEG_PIN7_gc);
//				}
//			case 7:
//				//Select which negative pin (not that the negative pin is internally connected to ground)
//				switch (myADC->pinNeg){
//				case 0: ADC_Ch_InputMux_Config(&ADCB.CH2, ADC_CH_MUXPOS_PIN7_gc, ADC_CH_MUXNEG_PIN0_gc);
//				case 1: ADC_Ch_InputMux_Config(&ADCB.CH2, ADC_CH_MUXPOS_PIN7_gc, ADC_CH_MUXNEG_PIN1_gc);
//				case 2: ADC_Ch_InputMux_Config(&ADCB.CH2, ADC_CH_MUXPOS_PIN7_gc, ADC_CH_MUXNEG_PIN2_gc);
//				case 3: ADC_Ch_InputMux_Config(&ADCB.CH2, ADC_CH_MUXPOS_PIN7_gc, ADC_CH_MUXNEG_PIN3_gc);
//				case 4: ADC_Ch_InputMux_Config(&ADCB.CH2, ADC_CH_MUXPOS_PIN7_gc, ADC_CH_MUXNEG_PIN4_gc);
//				case 5: ADC_Ch_InputMux_Config(&ADCB.CH2, ADC_CH_MUXPOS_PIN7_gc, ADC_CH_MUXNEG_PIN5_gc);
//				case 6: ADC_Ch_InputMux_Config(&ADCB.CH2, ADC_CH_MUXPOS_PIN7_gc, ADC_CH_MUXNEG_PIN6_gc);
//				case 7: ADC_Ch_InputMux_Config(&ADCB.CH2, ADC_CH_MUXPOS_PIN7_gc, ADC_CH_MUXNEG_PIN7_gc);
//				}
//			}
//
//
//		case 3:
//			//set the mode
//			switch (myADC->mode){
//			case 0:
//				//set the gain
//				switch (myADC->gain){
//				case 1: ADC_Ch_InputMode_and_Gain_Config(&ADCB.CH3,ADC_CH_INPUTMODE_SINGLEENDED_gc, ADC_CH_GAIN_1X_gc);
//				case 2: ADC_Ch_InputMode_and_Gain_Config(&ADCB.CH3,ADC_CH_INPUTMODE_SINGLEENDED_gc, ADC_CH_GAIN_2X_gc);
//				case 4: ADC_Ch_InputMode_and_Gain_Config(&ADCB.CH3,ADC_CH_INPUTMODE_SINGLEENDED_gc, ADC_CH_GAIN_4X_gc);
//				case 8: ADC_Ch_InputMode_and_Gain_Config(&ADCB.CH3,ADC_CH_INPUTMODE_SINGLEENDED_gc, ADC_CH_GAIN_8X_gc);
//				case 16: ADC_Ch_InputMode_and_Gain_Config(&ADCB.CH3,ADC_CH_INPUTMODE_SINGLEENDED_gc, ADC_CH_GAIN_16X_gc);
//				case 32: ADC_Ch_InputMode_and_Gain_Config(&ADCB.CH3,ADC_CH_INPUTMODE_SINGLEENDED_gc, ADC_CH_GAIN_32X_gc);
//				case 64: ADC_Ch_InputMode_and_Gain_Config(&ADCB.CH3,ADC_CH_INPUTMODE_SINGLEENDED_gc, ADC_CH_GAIN_64X_gc);
//				}
//			}
//
//			//Select which posative pin
//			switch (myADC->pinPos){
//			case 0:
//				//Select which negative pin (not that the negative pin is internally connected to ground)
//				switch (myADC->pinNeg){
//				case 0: ADC_Ch_InputMux_Config(&ADCB.CH3, ADC_CH_MUXPOS_PIN0_gc, ADC_CH_MUXNEG_PIN0_gc);
//				case 1: ADC_Ch_InputMux_Config(&ADCB.CH3, ADC_CH_MUXPOS_PIN0_gc, ADC_CH_MUXNEG_PIN1_gc);
//				case 2: ADC_Ch_InputMux_Config(&ADCB.CH3, ADC_CH_MUXPOS_PIN0_gc, ADC_CH_MUXNEG_PIN2_gc);
//				case 3: ADC_Ch_InputMux_Config(&ADCB.CH3, ADC_CH_MUXPOS_PIN0_gc, ADC_CH_MUXNEG_PIN3_gc);
//				case 4: ADC_Ch_InputMux_Config(&ADCB.CH3, ADC_CH_MUXPOS_PIN0_gc, ADC_CH_MUXNEG_PIN4_gc);
//				case 5: ADC_Ch_InputMux_Config(&ADCB.CH3, ADC_CH_MUXPOS_PIN0_gc, ADC_CH_MUXNEG_PIN5_gc);
//				case 6: ADC_Ch_InputMux_Config(&ADCB.CH3, ADC_CH_MUXPOS_PIN0_gc, ADC_CH_MUXNEG_PIN6_gc);
//				case 7: ADC_Ch_InputMux_Config(&ADCB.CH3, ADC_CH_MUXPOS_PIN0_gc, ADC_CH_MUXNEG_PIN7_gc);
//				}
//			case 1:
//				//Select which negative pin (not that the negative pin is internally connected to ground)
//				switch (myADC->pinNeg){
//				case 0: ADC_Ch_InputMux_Config(&ADCB.CH3, ADC_CH_MUXPOS_PIN1_gc, ADC_CH_MUXNEG_PIN0_gc);
//				case 1: ADC_Ch_InputMux_Config(&ADCB.CH3, ADC_CH_MUXPOS_PIN1_gc, ADC_CH_MUXNEG_PIN1_gc);
//				case 2: ADC_Ch_InputMux_Config(&ADCB.CH3, ADC_CH_MUXPOS_PIN1_gc, ADC_CH_MUXNEG_PIN2_gc);
//				case 3: ADC_Ch_InputMux_Config(&ADCB.CH3, ADC_CH_MUXPOS_PIN1_gc, ADC_CH_MUXNEG_PIN3_gc);
//				case 4: ADC_Ch_InputMux_Config(&ADCB.CH3, ADC_CH_MUXPOS_PIN1_gc, ADC_CH_MUXNEG_PIN4_gc);
//				case 5: ADC_Ch_InputMux_Config(&ADCB.CH3, ADC_CH_MUXPOS_PIN1_gc, ADC_CH_MUXNEG_PIN5_gc);
//				case 6: ADC_Ch_InputMux_Config(&ADCB.CH3, ADC_CH_MUXPOS_PIN1_gc, ADC_CH_MUXNEG_PIN6_gc);
//				case 7: ADC_Ch_InputMux_Config(&ADCB.CH3, ADC_CH_MUXPOS_PIN1_gc, ADC_CH_MUXNEG_PIN7_gc);
//				}
//			case 2:
//				//Select which negative pin (not that the negative pin is internally connected to ground)
//				switch (myADC->pinNeg){
//				case 0: ADC_Ch_InputMux_Config(&ADCB.CH3, ADC_CH_MUXPOS_PIN2_gc, ADC_CH_MUXNEG_PIN0_gc);
//				case 1: ADC_Ch_InputMux_Config(&ADCB.CH3, ADC_CH_MUXPOS_PIN2_gc, ADC_CH_MUXNEG_PIN1_gc);
//				case 2: ADC_Ch_InputMux_Config(&ADCB.CH3, ADC_CH_MUXPOS_PIN2_gc, ADC_CH_MUXNEG_PIN2_gc);
//				case 3: ADC_Ch_InputMux_Config(&ADCB.CH3, ADC_CH_MUXPOS_PIN2_gc, ADC_CH_MUXNEG_PIN3_gc);
//				case 4: ADC_Ch_InputMux_Config(&ADCB.CH3, ADC_CH_MUXPOS_PIN2_gc, ADC_CH_MUXNEG_PIN4_gc);
//				case 5: ADC_Ch_InputMux_Config(&ADCB.CH3, ADC_CH_MUXPOS_PIN2_gc, ADC_CH_MUXNEG_PIN5_gc);
//				case 6: ADC_Ch_InputMux_Config(&ADCB.CH3, ADC_CH_MUXPOS_PIN2_gc, ADC_CH_MUXNEG_PIN6_gc);
//				case 7: ADC_Ch_InputMux_Config(&ADCB.CH3, ADC_CH_MUXPOS_PIN2_gc, ADC_CH_MUXNEG_PIN7_gc);
//				}
//			case 3:
//				//Select which negative pin (not that the negative pin is internally connected to ground)
//				switch (myADC->pinNeg){
//				case 0: ADC_Ch_InputMux_Config(&ADCB.CH3, ADC_CH_MUXPOS_PIN3_gc, ADC_CH_MUXNEG_PIN0_gc);
//				case 1: ADC_Ch_InputMux_Config(&ADCB.CH3, ADC_CH_MUXPOS_PIN3_gc, ADC_CH_MUXNEG_PIN1_gc);
//				case 2: ADC_Ch_InputMux_Config(&ADCB.CH3, ADC_CH_MUXPOS_PIN3_gc, ADC_CH_MUXNEG_PIN2_gc);
//				case 3: ADC_Ch_InputMux_Config(&ADCB.CH3, ADC_CH_MUXPOS_PIN3_gc, ADC_CH_MUXNEG_PIN3_gc);
//				case 4: ADC_Ch_InputMux_Config(&ADCB.CH3, ADC_CH_MUXPOS_PIN3_gc, ADC_CH_MUXNEG_PIN4_gc);
//				case 5: ADC_Ch_InputMux_Config(&ADCB.CH3, ADC_CH_MUXPOS_PIN3_gc, ADC_CH_MUXNEG_PIN5_gc);
//				case 6: ADC_Ch_InputMux_Config(&ADCB.CH3, ADC_CH_MUXPOS_PIN3_gc, ADC_CH_MUXNEG_PIN6_gc);
//				case 7: ADC_Ch_InputMux_Config(&ADCB.CH3, ADC_CH_MUXPOS_PIN3_gc, ADC_CH_MUXNEG_PIN7_gc);
//				}
//			case 4:
//				//Select which negative pin (not that the negative pin is internally connected to ground)
//				switch (myADC->pinNeg){
//				case 0: ADC_Ch_InputMux_Config(&ADCB.CH3, ADC_CH_MUXPOS_PIN4_gc, ADC_CH_MUXNEG_PIN0_gc);
//				case 1: ADC_Ch_InputMux_Config(&ADCB.CH3, ADC_CH_MUXPOS_PIN4_gc, ADC_CH_MUXNEG_PIN1_gc);
//				case 2: ADC_Ch_InputMux_Config(&ADCB.CH3, ADC_CH_MUXPOS_PIN4_gc, ADC_CH_MUXNEG_PIN2_gc);
//				case 3: ADC_Ch_InputMux_Config(&ADCB.CH3, ADC_CH_MUXPOS_PIN4_gc, ADC_CH_MUXNEG_PIN3_gc);
//				case 4: ADC_Ch_InputMux_Config(&ADCB.CH3, ADC_CH_MUXPOS_PIN4_gc, ADC_CH_MUXNEG_PIN4_gc);
//				case 5: ADC_Ch_InputMux_Config(&ADCB.CH3, ADC_CH_MUXPOS_PIN4_gc, ADC_CH_MUXNEG_PIN5_gc);
//				case 6: ADC_Ch_InputMux_Config(&ADCB.CH3, ADC_CH_MUXPOS_PIN4_gc, ADC_CH_MUXNEG_PIN6_gc);
//				case 7: ADC_Ch_InputMux_Config(&ADCB.CH3, ADC_CH_MUXPOS_PIN4_gc, ADC_CH_MUXNEG_PIN7_gc);
//				}
//			case 5:
//				//Select which negative pin (not that the negative pin is internally connected to ground)
//				switch (myADC->pinNeg){
//				case 0: ADC_Ch_InputMux_Config(&ADCB.CH3, ADC_CH_MUXPOS_PIN5_gc, ADC_CH_MUXNEG_PIN0_gc);
//				case 1: ADC_Ch_InputMux_Config(&ADCB.CH3, ADC_CH_MUXPOS_PIN5_gc, ADC_CH_MUXNEG_PIN1_gc);
//				case 2: ADC_Ch_InputMux_Config(&ADCB.CH3, ADC_CH_MUXPOS_PIN5_gc, ADC_CH_MUXNEG_PIN2_gc);
//				case 3: ADC_Ch_InputMux_Config(&ADCB.CH3, ADC_CH_MUXPOS_PIN5_gc, ADC_CH_MUXNEG_PIN3_gc);
//				case 4: ADC_Ch_InputMux_Config(&ADCB.CH3, ADC_CH_MUXPOS_PIN5_gc, ADC_CH_MUXNEG_PIN4_gc);
//				case 5: ADC_Ch_InputMux_Config(&ADCB.CH3, ADC_CH_MUXPOS_PIN5_gc, ADC_CH_MUXNEG_PIN5_gc);
//				case 6: ADC_Ch_InputMux_Config(&ADCB.CH3, ADC_CH_MUXPOS_PIN5_gc, ADC_CH_MUXNEG_PIN6_gc);
//				case 7: ADC_Ch_InputMux_Config(&ADCB.CH3, ADC_CH_MUXPOS_PIN5_gc, ADC_CH_MUXNEG_PIN7_gc);
//				}
//			case 6:
//				//Select which negative pin (not that the negative pin is internally connected to ground)
//				switch (myADC->pinNeg){
//				case 0: ADC_Ch_InputMux_Config(&ADCB.CH3, ADC_CH_MUXPOS_PIN6_gc, ADC_CH_MUXNEG_PIN0_gc);
//				case 1: ADC_Ch_InputMux_Config(&ADCB.CH3, ADC_CH_MUXPOS_PIN6_gc, ADC_CH_MUXNEG_PIN1_gc);
//				case 2: ADC_Ch_InputMux_Config(&ADCB.CH3, ADC_CH_MUXPOS_PIN6_gc, ADC_CH_MUXNEG_PIN2_gc);
//				case 3: ADC_Ch_InputMux_Config(&ADCB.CH3, ADC_CH_MUXPOS_PIN6_gc, ADC_CH_MUXNEG_PIN3_gc);
//				case 4: ADC_Ch_InputMux_Config(&ADCB.CH3, ADC_CH_MUXPOS_PIN6_gc, ADC_CH_MUXNEG_PIN4_gc);
//				case 5: ADC_Ch_InputMux_Config(&ADCB.CH3, ADC_CH_MUXPOS_PIN6_gc, ADC_CH_MUXNEG_PIN5_gc);
//				case 6: ADC_Ch_InputMux_Config(&ADCB.CH3, ADC_CH_MUXPOS_PIN6_gc, ADC_CH_MUXNEG_PIN6_gc);
//				case 7: ADC_Ch_InputMux_Config(&ADCB.CH3, ADC_CH_MUXPOS_PIN6_gc, ADC_CH_MUXNEG_PIN7_gc);
//				}
//			case 7:
//				//Select which negative pin (not that the negative pin is internally connected to ground)
//				switch (myADC->pinNeg){
//				case 0: ADC_Ch_InputMux_Config(&ADCB.CH3, ADC_CH_MUXPOS_PIN7_gc, ADC_CH_MUXNEG_PIN0_gc);
//				case 1: ADC_Ch_InputMux_Config(&ADCB.CH3, ADC_CH_MUXPOS_PIN7_gc, ADC_CH_MUXNEG_PIN1_gc);
//				case 2: ADC_Ch_InputMux_Config(&ADCB.CH3, ADC_CH_MUXPOS_PIN7_gc, ADC_CH_MUXNEG_PIN2_gc);
//				case 3: ADC_Ch_InputMux_Config(&ADCB.CH3, ADC_CH_MUXPOS_PIN7_gc, ADC_CH_MUXNEG_PIN3_gc);
//				case 4: ADC_Ch_InputMux_Config(&ADCB.CH3, ADC_CH_MUXPOS_PIN7_gc, ADC_CH_MUXNEG_PIN4_gc);
//				case 5: ADC_Ch_InputMux_Config(&ADCB.CH3, ADC_CH_MUXPOS_PIN7_gc, ADC_CH_MUXNEG_PIN5_gc);
//				case 6: ADC_Ch_InputMux_Config(&ADCB.CH3, ADC_CH_MUXPOS_PIN7_gc, ADC_CH_MUXNEG_PIN6_gc);
//				case 7: ADC_Ch_InputMux_Config(&ADCB.CH3, ADC_CH_MUXPOS_PIN7_gc, ADC_CH_MUXNEG_PIN7_gc);
//				}
//			}
//		}
//
//	    // Before the ADC can be used it must be enabled
//		ADC_Enable(&ADCB);
//
//	    // Wait until the ADC is ready
//	    ADC_Wait_8MHz(&ADCB);
//
//	    // In the while(1) loop, a conversion is started on CH0 and the 8 MSB of the result is
//	    // ouput on the LEDPORT when the conversion is done
//
//		/* Get offset value for ADC B.  */
//	    switch (myADC->isSigned){
//	    case true:
//	    	switch(myADC->chan){
//	    	case 0: myADC->offset = ADC_Offset_Get_Signed(&ADCB, &(ADCB.CH0), myADC->oversampling);
//	    	case 1: myADC->offset = ADC_Offset_Get_Signed(&ADCB, &(ADCB.CH1), myADC->oversampling);
//	    	case 2: myADC->offset = ADC_Offset_Get_Signed(&ADCB, &(ADCB.CH2), myADC->oversampling);
//	    	case 3: myADC->offset = ADC_Offset_Get_Signed(&ADCB, &(ADCB.CH3), myADC->oversampling);
//	    	case 4: myADC->offset = ADC_Offset_Get_Signed(&ADCB, &(ADCB.CH4), myADC->oversampling);
//	    	case 5: myADC->offset = ADC_Offset_Get_Signed(&ADCB, &(ADCB.CH5), myADC->oversampling);
//	    	case 6: myADC->offset = ADC_Offset_Get_Signed(&ADCB, &(ADCB.CH6), myADC->oversampling);
//	    	case 7: myADC->offset = ADC_Offset_Get_Signed(&ADCB, &(ADCB.CH7), myADC->oversampling);
//	    	}
//	    case false:
//	    	switch(myADC->chan){
//	    	case 0: myADC->offset = ADC_Offset_Get_Unsigned(&ADCB, &(ADCB.CH0), myADC->oversampling);
//	    	case 0: myADC->offset = ADC_Offset_Get_Unsigned(&ADCB, &(ADCB.CH1), myADC->oversampling);
//	    	case 2: myADC->offset = ADC_Offset_Get_Unsigned(&ADCB, &(ADCB.CH2), myADC->oversampling);
//	    	case 3: myADC->offset = ADC_Offset_Get_Unsigned(&ADCB, &(ADCB.CH3), myADC->oversampling);
//	    	case 4: myADC->offset = ADC_Offset_Get_Unsigned(&ADCB, &(ADCB.CH4), myADC->oversampling);
//	    	case 5:	myADC->offset = ADC_Offset_Get_Unsigned(&ADCB, &(ADCB.CH5), myADC->oversampling);
//	    	case 6: myADC->offset = ADC_Offset_Get_Unsigned(&ADCB, &(ADCB.CH6), myADC->oversampling);
//	    	case 7: myADC->offset = ADC_Offset_Get_Unsigned(&ADCB, &(ADCB.CH7), myADC->oversampling);
//	    	}
//	    }
//	    //End of ADC B
//	}

}

int adcTestMain1( void )
{
    // Variable for use when we read the result from an ADC channel
    int8_t offset;

    LEDPORT.DIR = 0xFF; //Set as ouput, the 8 MSB of the result is output here
    LEDPORT.OUT = 0xFF; //Default off for LED

	//PORTQ.PIN2CTRL = (PORTQ.PIN2CTRL & ~PORT_OPC_gm) | PORT_OPC_PULLDOWN_gc;	// This pin must be grounded to "enable" NTC-resistor

  	/* Move stored calibration values to ADC B */
	ADC_CalibrationValues_Load(&ADCB);

    /* Set up ADC B to have signed conversion mode and 12 bit resolution. */
  	ADC_ConvMode_and_Resolution_Config(&ADCB, true, ADC_RESOLUTION_12BIT_gc);

    // The ADC has different voltage reference options, controlled by the REFSEL bits in the
    // REFCTRL register. Here the internal reference is selected
	ADC_Reference_Config(&ADCB, ADC_REFSEL_VCC_gc);

	// The clock into the ADC decide the maximum sample rate and the conversion time, and
    // this is controlled by the PRESCALER bits in the PRESCALER register. Here, the
    // Peripheral Clock is divided by 8 ( gives 250 KSPS with 2Mhz clock )
	ADC_Prescaler_Config(&ADCB, ADC_PRESCALER_DIV8_gc);

    // The used Virtual Channel (CH0) must be set in the correct mode
    // In this task we will use single ended input, so this mode is selected

    /* Setup channel 0 to have single ended input. */
	ADC_Ch_InputMode_and_Gain_Config(&ADCB.CH0,
	                                 ADC_CH_INPUTMODE_SINGLEENDED_gc,
                                     ADC_CH_GAIN_1X_gc);


    // Setting up the which pins to convert.
    // Note that the negative pin is internally connected to ground
	ADC_Ch_InputMux_Config(&ADCB.CH0, ADC_CH_MUXPOS_PIN1_gc, ADC_CH_MUXNEG_PIN0_gc);


    // Before the ADC can be used it must be enabled
	ADC_Enable(&ADCB);


    // Wait until the ADC is ready
    ADC_Wait_8MHz(&ADCB);

    // In the while(1) loop, a conversion is started on CH0 and the 8 MSB of the result is
    // ouput on the LEDPORT when the conversion is done

	/* Get offset value for ADC B.  */
	offset = ADC_Offset_Get_Unsigned(&ADCB, &(ADCB.CH0), true);

  while(1)
  {
        // Start a single conversion
        ADC_Ch_Conversion_Start(&ADCB.CH0);

        while(!ADC_Ch_Conversion_Complete(&ADCB.CH0));

        //ADCB.INTFLAGS = ADC_CH0IF_bm;     // Clear CH0IF by writing a one to it
        ADC_result =   ADC_ResultCh_GetWord_Unsigned(&ADCB.CH0, offset);
        // Max result is 2047, divide by 4 to get a byte value;
        ADC_result = ((ADC_result - 1) / 8);
        // invert as the LED is on when pin is low
        LEDPORT.OUT = ~ADC_result;
    }
}



