/*
 * general_timer.c
 *
 *  Created on: Dec 13, 2010
 *      Author: hsrmqp
 */
#include "utils/system_time.h"
#include <avr/interrupt.h>

static volatile uint64_t time= 0;

void system_time_ISR_handler(void) {
   time++;
}

/**
 * Get the raw value of the time counter.  Units vary based on the rate
 * of the ISR.  The timer starts counting on boot as soon as interrupts
 * are enabled.
 */
uint64_t getTime(void) {
   uint64_t ret;
   cli();
   ret= time;
   sei();

   return ret;
}

/**
 * Get the time since boot in ms.
 */
uint64_t getTime_ms(void) {
   uint64_t retVal;

   retVal= getTime();

   return retVal/SYSTIME_ISR_PER_MS;
}

/**
 * Get the time since boot in us.
 */
uint64_t getTime_us(void) {
   uint64_t retVal;

   retVal= getTime();

   retVal*= 1000/SYSTIME_ISR_PER_MS;

   return retVal;
}
